/*
**> Max( (S(T) - K1)+, (Sbar - K2)+ )
**
** Best of Call/Asian
**
*/

new;
library option,pgraph;

cls;

S0 = 100;            
mu = 0.05;
sigma = 0.20;
r = 0.05;

t = seqa(0.25,0.25,8);                       // Fixing dates
tau = t[rows(t)];                            // Maturity of the option = 2 Years
Notional = 1;                                // Notional of the option
K_Asian = 100;                               // Strike of the Asian option
K_Call = 101;                                // Strike of the Call option
fn call_payoff(S,K) = (S - K) .* (S .>= K);  // call option
fn put_payoff(S,K) = (K - S) .* (S .<= K);   // put option

// asian option
fn asian_payoff(S,K) = call_payoff(meanc(S),K); 

Ns = 100000;  // Number of simulations
S = simulate_GBM(S0,r,sigma,t,Ns);
ST = S[rows(t),.]';

Payout = _max_( call_payoff(ST,K_Call), asian_payoff(S,K_Asian) );

K_BestOf = 10;

C = Notional * exp(-r*tau) * meanc( call_payoff(Payout,K_BestOf) );
P = Notional * exp(-r*tau) * meanc( put_payoff(payout,K_BestOf) );

print ftos(C,"Call BestOf Call/Asian Option Price = %lf",3,2);
print ftos(P,"Put BestOf Call/Asian Option Price = %lf",3,2);