/*
**> In this program, we price barrier options using local volatility model with Backward Dupire PDE model.
** 
*/

new;
library option,pgraph;
OptionSet;

cls;

loadm databuf = Dupire-ImpVol;

Smile_K = vread(databuf,"K");
Smile_T = vread(databuf,"T");
Smile_ImpVol = vread(databuf,"ImpVol");

S0 = 100;
b = 0.05;
r = 0.05;

FileName = "Dupire11";
call LocalVol_Init(Smile_K,Smile_ImpVol,Smile_T,0,200,201,1,201,S0,b,r,FileName);

Tau = 1.0;
K = 100;
L = 90;
H = 115;

let string OptionType[10,1] = "call" "put" "doc" "dop" "uoc" "uop" "koc" "kop" "bc" "bp";
nIters = rows(OptionType);

__output = 0;

i = 1;
do until i > nIters;

  {tmp_S0,tmp_Tau,C} = LocalVol_Backward_PDE_Solve(OptionType[i],K,L,H,tau,0.5);
  str = upper(OptionType[i]) $+ ftos(C," = %lf",5,4);
  print /flush str;

  i = i + 1;
endo;