new;
library option,pgraph;

S0 = 100;
K = 100;
sigma = 0.20;
r = 0.05;
b = r;
tau = 1.0;

n = 4;

{CRR,Tree} = EuropeanCRR(S0,K,sigma,tau,b,r,n);

fn call_payoff(S,K) = (S - K) .* (S .>= K);
Ns = 10000;

Nr = 500;
C1 = zeros(Nr,1);
C2 = zeros(Nr,1);
i = 1;
do until i > Nr;
  {S1,S2} = Simulate_CRR_av(S0,sigma,tau,b,r,n,nS);
  ST1 = S1[n,.]';
  ST2 = S2[n,.]';
  C1[i] = exp(-r*tau)*meanc(call_payoff(ST1,K));
  C2[i] = exp(-r*tau)*meanc(call_payoff(ST2,K));
  i = i + 1;
endo;

Cav = 0.5 * (C1 + C2); 

_Kernel[1:3] = 9.4|10.6|256;
{x,d1,F,retcode} = Kernel(C1);
{x,d2,F,retcode} = Kernel(Cav);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1; _plwidth = 10;
  title("\216Density of the MC estimate with nS = 10000");
  xtics(9.4,10.4,0.2,2);
  _plegstr = "MC\000AV";
  _plegctl = {2 5 5.5 4.5};
  graphprt("-c=1 -cf=mc4.eps");
  xy(x,d1~d2);