new;

#define USE_OPTMUM

#ifdef USE_CO
  library option,pgraph,co;
#else
  #ifdef USE_OPTMUM
    library option,optmum,pgraph;
  #else
    library option,pgraph;
  #endif
#endif

OptionSet;

Strike = seqa(70,1,61);

let S0 = 100;

proc (2) = Skew(Kmin,SkewMin,Kmax,SkewMax);
  local Skew;

  if Kmax == 0;
    Skew = Kmin~SkewMin;
  else;
    Skew = Kmin~SkewMin |
           Kmax~SkewMax ;
  endif;

  retp(Skew[.,1],Skew[.,2]);
endp;


let K   =  90   100;
let Vol =  0.30 0.25;
let sv = 0.5 0.1 0.1;

{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,Skew(70,-0.01,0,0),sv);
Smile = PDM_ImpVol(S0,Strike,a,b,c,d,m);

let sv = 0.5 0.1 0.1;

_PDM_Weight = 0.01;
p = PDM_Skew(S0,130,a,b,c,d,m);
{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,Skew(70,-0.01,130,0.005),sv);
Smile = Smile~PDM_ImpVol(S0,Strike,a,b,c,d,m);

let sv = 0.5 0.1 0.1 0.1;
sv = a|b|c|0.1;
p = PDM_Skew(S0,130,a,b,c,d,m);
{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,Skew(70,-0.01,130,0.01),sv);
Smile = Smile~PDM_ImpVol(S0,Strike,a,b,c,d,m);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3;
  _plwidth = 10;
  xlabel("\214Strike K");
  title("\216Sk(70) = -100 bp");
  xtics(60,140,20,2);
  ytics(0.15,0.40,0.05,2);
  _psym = K~Vol~ones(2,1).*(11~10~0~1~0);
  _plegstr = "No Sk(+)\000Sk(130) = 50 bp\000Sk(130) = 100 bp";
  _plegctl = {2 5 5 5};
  xy(Strike,Smile);

