new;
library option,pgraph;
optionSet;

a = 0.05;     /* Lower bound of the process  */
b = 0.10;     /* Upper bound of the process  */
theta = 0.8;  /* Mean-reversion coefficient  */

sigma = 2;    /* High volatility       !!!   */
c = 0.1;      /* Low intensity           !!! */

proc procMu(t,x);
  local w1,w2,w3,w;
  w1 = b - a;
  w2 = b - x;
  w3 = x - a;
  w = (c.*(w2-w3) - w2.*w3.*theta)./w1;
  retp(w);
endp;

proc procSigma(t,x);
  local w1,w2,w3,w;
  w1 = b - a;
  w2 = b - x;
  w3 = x - a;
  w = sigma.*w2.*w3./w1;
  retp(w);
endp;

t = qmc_Generate_t(0,5,501);  // You have to use a small time spacing, because we use the Euler Scheme and not an exact scheme
x = qmc_simulate_SDE(0.05,&procMu,&procSigma,t,2);

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3; _plwidth = 10; _pframe = 0;
  title("\216Two simulations of the Schlogl et Summer @[1995@] process");
  xlabel("\216t"); ylabel("\216x(t)");
  xy(t,x);