/*
**> Durrleman Approximation of the Heston Model
**
*/

new;
library option,pgraph;

// #define VD_OLD_VERSION

_VD_order = 4;

S0 = 100;
tau = 1/2;
r = 0.0;

kappa = 1;
sigma = 0.20;
mu = sigma^2;
epsilon = 0.2;
rho = -0.75;

K = seqa(50,1,101);
{smile,cdf,pdf} = VD_HestonDensity(S0,K,sigma,kappa,mu,epsilon,rho,tau,r);
{cdf_ln,pdf_ln} = EuropeanBS_Density(S0,K,_VD_ATM_volatility,tau,r);

graphset;
  _pdate = "";
  _pltype = 6|3|1; _pframe = 0; _pnum = 2;
  _pcolor = 10|12|13; _plwidth = 10;
  title("\216PDF");
  xlabel("\216K");
  _plegstr = "Heston Model\000ATM BS Model";
  _plegctl = {2 5 6 4};
  graphprt("-c=1 -cf=smile_to_density3.eps");
  xy(K,pdf~pdf_ln);