new;
library qam,pgraph,optmum;

let w[2,1] = 0.50 0.50;

let P[7,2] = 100 100
             150 50
             250 100
             100 150
             110 125
             160 140
             150 150;
R = P./lagn(P,1) - 1;
Rw = R*w;

nT = rows(P);
S = 1000 + zeros(Nt,6);
S1 = 1000 + zeros(nT,1);

nA1 = zeros(nT,2);
nA1[1,.] = S[1,1] .* w' ./ P[1,.];

nA2 = zeros(nT,2);
nA2[1,.] = S[1,2] .* w' ./ P[1,.];

nA3 = zeros(nT,2);
nA3[1,.] = S[1,3] .* w' ./ P[1,.];

nA6 = zeros(nT,2);
nA6[1,.] = S[1,6] .* w' ./ P[1,.];

t = 2;
do until t > nT;
  S1[t] = S1[t-1] .* (1 + Rw[t]);

  S[t,1] = nA1[t-1,.] * P[t,.]';
  nA1[t,.] = S[t,1] .* w' ./ P[t,.];

  S[t,2] = nA2[t-1,.] * P[t,.]';  
  if t%2 == 1;
    nA2[t,.] = S[t,2] .* w' ./ P[t,.];
  else;
    nA2[t,.] = nA2[t-1,.];
  endif;

  S[t,3] = nA3[t-1,.] * P[t,.]';  
  if t%3 == 1;
    nA3[t,.] = S[t,3] .* w' ./ P[t,.];
  else;
    nA3[t,.] = nA3[t-1,.];
  endif;

  S[t,6] = nA6[t-1,.] * P[t,.]';  
  if t%6 == 1;
    nA6[t,.] = S[t,6] .* w' ./ P[t,.];
  else;
    nA6[t,.] = nA6[t-1,.];
  endif;

  t = t + 1;
endo;

t = seqa(0,1,nT);

TexFile = "Backtest1.tex";
mask = 1;
let fmt[7,3] = "%lf" 6 0
               "%lf" 6 0
               "%lf" 6 0
               "%lf" 6 3
               "%lf" 6 3
               "%lf" 6 3
               "%lf" 6 2;
let string colNames = "$t$" "$S_1\\left( t\\right)$" "$S_2\\left( t\\right)$" "$R_1\\left( t\\right)$" "$R_2\\left( t\\right)$" 
                      "$R\\left( t\\right)$" "$S\\left( t\\right)$";

data = t~P~R~Rw~S1;
Tabular(TeXFile,data,mask,fmt,0,colNames,0,0,1);

let fmt[6,3] = "%lf" 6 0
               "%lf" 6 0
               "%lf" 6 0
               "%lf" 6 2
               "%lf" 6 2
               "%lf" 6 2;
let string colNames = "$t$" "$S_1\\left( t\\right)$" "$S_2\\left( t\\right)$" "$N_1\\left( t\\right)$" "$N_2\\left( t\\right)$" 
                      "$S\\left( t\\right)$";

let indx = 1 2 3 6;
i = 1;
do until i > 4;
  data = t~P~varget(itos("nA",indx[i]))~S[.,indx[i]];
  Tabular(TeXFile,data,mask,fmt,0,colNames,0,0,0);
  i = i + 1;
endo;

cls;
call text_print(TexFile);