new;
library qam,pgraph,optmum;

rndseed 123;

dt = 2;
tmax = 1;
nt = 1 + dt * tmax;
ns = 50000;

let sigma = 0.10 0.20 0.40 0.80;
nSigma = rows(sigma);

s = seqa(1,1,ns);
std1 = zeros(ns,nSigma);
std2 = zeros(ns,nSigma);

iter = 1;
do until iter > nSigma; 

  r = sigma[iter] * rndn(nt,ns)/sqrt(dt);
  r[1,.] = 0 * r[1,.];
  x1 = 100*cumprodc(1 + r);
  x2 = 100*exp(cumsumc(r));

  r1 = x1[nt,.]' ./ x1[1,.]' - 1;
  r2 = ln(x2[nt,.]') - ln(x2[1,.]');

  m1 = cumsumc(r1)./s;
  std1[.,iter] = sqrt(cumsumc(r1^2)./s - m1^2);
  m2 = cumsumc(r2)./s;
  std2[.,iter] = sqrt(cumsumc(r2^2)./s - m2^2);

  iter = iter + 1;
endo;

indx = seqa(1,100,ns/100);

sigma = sigma' .* ones(ns,1);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pcolor = 1|3|4; _plwidth = 8; _pltype = 6|1|3;
  _paxht = 0.20; _pnumht = 0.20;
  xlabel("\216Nombre de simulations");
  xtics(0,5e4,1e4,2);
  _plegstr = "\202s\201]n[[A](1)\000\202s\201(1)\000\202s\201]n[[L](1)";

  iter = 1;
  do until iter > 4;
    setwind(iter);
      if iter == 1;
        ytics(0.096,0.104,0.002,2);
      elseif iter == 2; 
        ytics(0.196,0.204,0.002,2);
      elseif iter == 3; 
        ytics(0.39,0.42,0.01,2);
      elseif iter == 4; 
        ytics(0.75,1.00,0.05,2);
      endif;
      xy(s[indx],std1[indx,iter]~std2[indx,iter]~sigma[indx,iter]);
    iter = iter + 1;
  endo;

  graphprt("-c=1 -cf=backtest11.eps");

  endwind;


