new;
library qam,pgraph,optmum;

datFileName = "..\\data\\qam_dataset1";
Data = loadd(datFileName);

Data = selif(Data,(Data[.,1] .>= 19900101) .and (Data[.,1] .<= 20091231));
vnames = "" $+ getname(datFileName);

Dates = Data[.,1];
nDates = rows(Dates);

let string selected_names = "SPX_TR";
indx = indsav(selected_names,vnames);
Data = Data[.,indx];
Data = Fill_Miss(Data,3);

SPTR = Data[.,1];
Data = SPTR./SPTR[1,.] * 100;

indx  = selif(seqa(1,1,nDates),Dates .<= 20071231);

maxDD = zeros(2,1); startDD = zeros(2,1); endDD = zeros(2,1);

{maxDD[1],startDD[1],endDD[1]} = Compute_Maximum_Drawdown(Data[indx],1);
{maxDD[2],startDD[2],endDD[2]} = Compute_Maximum_Drawdown(Data,1);

yMaxDD = data[startDD];
yMinDD = data[endDD];
TUW = maxindc(data .> yMaxDD');

pline = (1~3~0~0~0~0~1~0~10) .* ones(5,1);
pline[1,3 4 5 6] = startDD[1]~0~startDD[1]~700;
pline[2,3 4 5 6] = endDD[1]~0~endDD[1]~700;
pline[3,3 4 5 6] = TUW[1]~0~TUW[1]~700;
pline[4,3 4 5 6] = startDD[2]~0~startDD[2]~700;
pline[5,3 4 5 6] = endDD[2]~0~endDD[2]~700;

psym = (0~0~11~5~0~1~10) .* ones(5,1);
psym[1,1 2] = startDD[1]~yMaxDD[1];
psym[2,1 2] = endDD[1]~yMinDD[1];
psym[3,1 2] = TUW[1]~data[TUW[1]];
psym[4,1 2] = startDD[2]~yMaxDD[2];
psym[5,1 2] = endDD[2]~yMinDD[2];

parrow = (0~0~0~0~1.5~0.10~02~0~1~6~10) .* ones(6,1);
parrow[1,1 2 3 4] = startDD[1]~0.9*yMinDD[1]~endDD[1]~0.9*yMinDD[1];
parrow[2,1 2 3 4] = startDD[1]~0.985*yMaxDD[1]~startDD[1]~yMinDD[1];
parrow[3,1 2 3 4] = endDD[1]~yMaxDD[1]~endDD[1]~yMinDD[1];
parrow[4,1 2 3 4] = startDD[1]~150~TUW[1]~150;
parrow[5,1 2 3 4] = startDD[2]~0.9*yMinDD[2]~endDD[2]~0.9*yMinDD[2];
parrow[6,1 2 3 4] = startDD[2]~0.985*yMaxDD[2]~startDD[2]~yMinDD[2];

pmsgstr = ftos(100*maxDD[1],"D = %lf",3,2) $+ "%" $+ "\000Pick to Valley\000Time under Water\000" $+ ftos(100*maxDD[2],"MDD = %lf",3,2) $+ "%";
pmsgctl = (0~0~0.125~0~1~4~10) .* ones(4,1);
pmsgctl[1,1 2 4] = 2620~460~-90;
pmsgctl[2,1 2] = 1.22*startDD[1]~0.87*yMinDD[1];
pmsgctl[3,1 2] = 0.6025*startDD[1]~145;
pmsgctl[4,1 2 4] = 4710~500~-90;

d = startDD[1]|endDD[1]|TUW[1];
print Dates[d]'~maxDD[1]~(Data[endDD[1]]/Data[startDD[1]]-1);

d = startDD[2]|endDD[2];
print Dates[d]'~maxDD[2]~(Data[endDD[2]]/Data[startDD[2]]-1);

pqgwin many;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _pcolor = 1|2|3; _plwidth = 8;
  xtics(1,2*260*10,2*260,2);
  ytics(0,700,100,2);
  let xlab = "1990" "92" "94" "96" "98" "2000" "02" "04" "06" "08" "10";
  _parrow = parrow[1 2 4 5 6,.]; _pline = pline; _psym = psym; _pmsgstr = pmsgstr; _pmsgctl = pmsgctl;
  asclabel(xlab,0);
  graphprt("-c=1 -cf=backtest12.eps");
  xy(0,Data);

