new;
library qam,pgraph,optmum;

datFileName = "..\\data\\qam_database1";
Data = loadd(datFileName);

Data = selif(Data,(Data[.,1] .>= 19900101) .and (Data[.,1] .<= 20091231));
vnames = "" $+ getname(datFileName);

Dates = Data[.,1];
nDates = rows(Dates);

let string selected_names = "SPX_TR" "GBI_US";
indx = indsav(selected_names,vnames);
Data = Data[.,indx];
Data = Fill_Miss(Data,4);

indx = selif(seqa(1,1,nDates),Dates .<= 20071231);

{t1,L1} = Compute_Loss_Function(packr(Data[.,1]),260*8);
L1_s = regSpline(t1,L1,0.000001,t1);

{t2,L2} = Compute_Loss_Function(packr(Data[indx,1]),260*8);
L2_s = regSpline(t2,L2,0.000001,t2);

{t3,L3} = Compute_Loss_Function(packr(Data[.,2]),260*8);
L3_s = regSpline(t3,L3,0.000001,t3);

{t4,L4} = Compute_Loss_Function(packr(Data[indx,2]),260*8);
L4_s = regSpline(t4,L4,0.000001,t4);

graphset;
  window3d;
  
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 0;
  xtics(1,260*8,260,2);
  let xlab = "" "1Y" "2Y" "3Y" "4Y" "5Y" "6Y" "7Y" "8Y";
  asclabel(xlab,0);

  _paxht = 0.20; _pnumht = 0.25; _ptitlht = 0.25; 
  _plwidth = 10; _pcolor = 1|4; _pltype = 6|3;
  _pline = 1~6~0~0~5000~0~1~0~10;

  ytics(-60,20,20,2);
  setwind(1);
    title("\216Fonction de perte maximale\L\216S&P 500");  
    xy(t1~t2,100*(L1~L2));

  setwind(2);  
    title("\216Estimation spline\L\216S&P 500");  
    xy(t1~t2,100*(L1_s~L2_s));

  ytics(-10,50,10,2);
  setwind(3);  
    title("\216Estimation spline\L\216JP Morgan Government Bond US");  
    _plegstr = "1990-2009\0001990-2007";
    _plegctl = {2 5 9.5 3};
    xy(t3~t4,100*(L3_s~L4_s));

    graphprt("-c=1 -cf=backtest13.eps");

  endwind;