new;
library qam,pgraph,optmum;

datFileName = "..\\data\\qam_dataset1";

Data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

Data = selif(Data,(Data[.,1] .>= 19891231) .and (Data[.,1] .<= 20091231));

Dates = Data[.,1];
nDates = rows(Dates);
let string selected_names = "BXM";
indx = indsav(selected_names,vnames);
Data = Data[.,indx];
Data = Fill_Miss(Data,4);

Strategy = Data[.,1];
{Stats1M,Stats1Y} = Compute_Monthly_Statistics(Dates,Strategy,0,0);

{Stats1M,Stats1Y2} = Compute_Monthly_Statistics2(Dates,Strategy,0,0);

print stats1Y~stats1Y2;


proc (2) = Compute_Monthly_Statistics2(Dates,Funds,Begin_Date,End_Date);
  local nDates,YYYY_MM,Months,nMonths,nCols;
  local x0,x1,perf,i,iter;
  local tDates,tMonths,ntMonths,allMonths,Begin_Trim,End_Trim,Stats1M;
  local Years,nYears,Stats1Y,breakDate,tmp_beg,tmp_end,data;

  nDates = rows(Dates);
  if Begin_Date == 0;
    Begin_Date = Dates[1];
  endif;

  if End_Date == 0;
    End_Date = Dates[nDates];
  endif;

  YYYY_MM = trunc(Dates/100);
  Months = Unique(YYYY_MM,1);
  nMonths = rows(Months);

  nCols = cols(Funds);
  Perf = zeros(nMonths,nCols);
  x0 = Funds[1,.];
  iter = 1;

  i = 2;
  do until i > nDates;

    if YYYY_MM[i] /= YYYY_MM[i-1];
      x1 = Funds[i-1,.];
      Perf[iter,.] = x1./x0 - 1;
      x0 = x1;
      iter = iter + 1;
    endif;

    i = i + 1;
  endo;

  if iter == nMonths;
    x1 = Funds[nDates,.];
    Perf[iter,.] = x1./x0 - 1;
  endif;

  tDates = TradingDates(Begin_Date,End_Date);
  tMonths = unique(trunc(tDates/100),1);
  ntMonths = rows(tMonths);

  allMonths = unique(Months|tMonths,1);
  Begin_Trim = indnv(tMonths[1],allMonths) - indnv(Months[1],allMonths);
  End_Trim = indnv(tMonths[ntMonths],allMonths) - indnv(Months[nMonths],allMonths);

  if Begin_Trim >= 0;
    Perf = trimr(Perf,Begin_Trim,0);
    allMonths = trimr(allMonths,Begin_Trim,0);
  else;
    Perf = miss(zeros(-Begin_Trim,nCols),0) | Perf;
  endif;

  if End_Trim <= 0;
    Perf = trimr(Perf,0,-End_Trim);
    allMonths = trimr(allMonths,0,-End_Trim);
  else;
    Perf = Perf | miss(zeros(End_Trim,nCols),0) ;
  endif;

  stats1M = allMonths~Perf;

  Years = unique(trunc(tDates/1e4),1);
  nYears = rows(Years);
  stats1Y = zeros(nYears,3);

  breakDate = (Years[1]-1)*1e4 + 1231;

  i = 1;
  do until i > nYears;

    stats1Y[i,1] = Years[i];

    tmp_beg = breakDate + (i-1)*10000;
    tmp_end = breakDate + i*10000;

    if tmp_beg >= Dates[1];
      do until indnv(tmp_beg,Dates) /= error(0);
        tmp_beg = tmp_beg - 1;
      endo;
    endif;

    data = selif(Dates~Funds, (Dates .>= tmp_beg) .and (Dates .<= tmp_end) );
    data = packr(data);
    print data[1,1]~data[rows(data),1];
    data = data[.,2];

    stats1Y[i,2] = data[rows(data)]./data[1] - 1;
    data = data ./ lag1(data) - 1;
    stats1Y[i,3] = sqrt(260) * stdc(packr(data));
    i = i + 1;
  endo;

  Stats1M = allMonths~Perf;

  retp(Stats1M,Stats1Y);
endp;
