new;
library qam,pgraph,optmum;

Dates = TradingDates(20080102,20080115);
let G = 100 100.5 102.7 107.4 98.2  100 104.2;
let B = 207 207.5 208.1 208.5 207.6 207 206.4; 
nDates = rows(G);
Dates = Dates[1:nDates];

let knots = 20071231;

mf = 0.02;
pf = 0.10;

F1 = Add_Fees(dates,G,mf,knots,B,pf);

dt = etdays2(lag1(Dates),Dates);
F0 = 100 + zeros(nDates,2);
Surperf = miss(zeros(nDates,1),0);
i = 2;
do until i > nDates;
  F0[i,1] = F0[i-1,1] .* (G[i]./G[i-1] - mf .* dt[i]/365);
  Surperf[i] = F0[i,1] ./ F0[1,1] - B[i] ./ B[1];
  F0[i,2] = F0[1,2] .* (F0[i,1]./F0[1,1] - pf .* _max_(Surperf[i],0));
  i = i + 1;
endo;

TexFile = "backtest1.tex";
mask = 1;
let fmt[7,3] = "%lf" 10 0
               "%lf" 6 2
               "%lf" 6 0
               "%lf" 6 4
               "%lf" 6 2
               "%lf" 6 4
               "%lf" 6 4;
let string colNames = "$t$" "$G\\left(t \\right)$" "$dt$" "$F^{\star}\\left( t\\right)$" "$B\\left( t\\right)$" 
                      "Surperf" "$F^{\star}\\left( t\\right)$";
data = Dates~G~dt~F0[.,1]~B~100*Surperf~F0[.,2];
Tabular(TeXFile,data,mask,fmt,0,colNames,0,0,1);

cls;
call text_print(TexFile);