new;
library qam,pgraph,optmum;

rndseed 123;

FirstDate = 20000101;
LastDate = 20080101;
Dates = TradingDates(FirstDate,LastDate);

nDates = rows(Dates);
t = seqa(0,1,nDates)/nDates*8;

x0 = 100; mu = 0.20; sigma = 0.05; Ns = 1;

rndseed 123;
x = simulate_GBM(x0,mu,sigma,t,Ns);

Benchmark1 = ones(nDates,1);
Benchmark2 = simulate_GBM(x0,mu/2,sigma,t,Ns);
Benchmark3 = simulate_GBM(x0,-mu/2,sigma,t,Ns);

let knots = 20001231 20011231 20021231 20031231 20041231 20051231 20061231 20071231;

Benchmark = Benchmark1;
mf = 0.01|0.02;
pf = 0.00|0.00;
y1 = Add_Fees(dates,x,mf,knots,Benchmark,pf);

mf = 0.02|0.02;
pf = 0.10|0.20;
y2 = Add_Fees(dates,x,mf,knots,Benchmark,pf);

Benchmark = Benchmark2;
mf = 0.02|0.02;
pf = 0.10|0.20;
y3 = Add_Fees(dates,x,mf,knots,Benchmark,pf);

Benchmark = Benchmark3;
y4 = Add_Fees(dates,x,mf,knots,Benchmark,pf);

//t = 2000 + t;

graphset;
  begwind;
  window(2,2,0);

    _pdate = ""; _pnum = 2; _pframe = 0;
    _paxht = 0.25; _pnumht = 0.17;
    _pltype = 6|6|3|1; _pcolor = 0|1|2|3; _plwidth = 8; 
    _pstype = 11; _plctrl = 0|250|0|0; _psymsiz = 6;
    xtics(2000,2008,1,2);
    xtics(0,8,1,0);
    let xlab = "2000" "01" "02" "03" "04" "05" "06" "07" "08";
    asclabel(xlab,0);
    ytics(100,500,100,2);

    _plegctl = {2 6 1 4.5};

  setwind(1);
    _plegstr = "G]t[\000B]t[\000F]t[ (m]f[ = 1%)\000F]t[ (m]f[ = 2%)";
    xy(t,x~Benchmark1~y1);

  setwind(2);
    _plegstr = "G]t[\000B]t[\000F]t[ (m]f[ = 2%, p]f[ = 10%)\000F]t[ (m]f[ = 2%, p]f[ = 20%)";
    xy(t,x~Benchmark1~y2);

  setwind(3);
    _plegstr = "G]t[\000B]t[\000F]t[ (m]f[ = 2%, p]f[ = 10%)\000F]t[ (m]f[ = 2%, p]f[ = 20%)";
    xy(t,x~Benchmark2~y3);

  setwind(4);
    ytics(0,500,100,2);
    xy(t,x~Benchmark3~y4);

    graphprt("-c=1 -cf=backtest3.eps");

  endwind;