new;
library qam,pgraph,optmum;

rndseed 123;

FirstDate = 20000101;
LastDate = 20080101;
Dates = TradingDates(FirstDate,LastDate);
nDates = rows(Dates);
t = seqa(0,1,nDates)/nDates*8;

x0 = 100; mu = 0.20; sigma = 0.05; Ns = 1;

//rndseed 123;

let knots = 20001231 20011231 20021231 20031231 20041231 20051231 20061231 20071231;

mf = 0.00; 
pf = seqa(0.5/100,0.5/100,198);
nPF = rows(pf);
Benchmark = ones(nDates,1);

nSimul = 100;
stats = arrayinit(5|nSimul|nPF,0);

i = 1;
do until i > nSimul;
  x = simulate_GBM(x0,mu,sigma,t,Ns);
  y = Add_Fees(dates,x,mf,knots,Benchmark,pf);

  Data = y;
  Rt = packr(Data./lag1(Data) - 1);
  m = (Data[nDates,.]./Data[1,.])^(1/8)-1.0;
  v = sqrt(260) * stdc(Rt)';
  Sharpe = m./v;

  stats[1,i,.] = m;
  stats[2,i,.] = v;
  stats[3,i,.] = Sharpe;

  Rt = x./lag1(x) - 1;
  Rt = packr(Rt ~ _Fees_ct);
  rho = submat(corrx(Rt),1,seqa(2,1,nPF));
  v = sqrt(260) * stdc(Rt)';
  v_G = v[1,1];
  v_c = v[1,seqa(2,1,nPF)];

  stats[4,i,.] = v_G^2 + 2*rho .* pf' .* v_G .* v_c;
  stats[4,i,.] = missex(sqrt(stats[4,i,.]),stats[4,i,.] .< 0);
  stats[5,i,.] = sqrt(v_G^2 + 2*rho .* pf' .* v_G .* v_c + (pf')^2 .* v_c^2);
  

  i = i + 1;
endo;

mstats = arraytomat(atranspose(amean(real(stats),2),2|1|3));

graphset;
  window3u;

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 8; _pcolor = 1|3|4;
  _paxht = 0.20; _pnumht = 0.20;

  xtics(0,100,10,2);
  xlabel("\216Frais de Performance (en %)");

  setwind(1);
    ylabel("\216Rendement annuel (en %)");   
    xy(100*pf,100*mstats[1,.]');

  setwind(2);
    ylabel("\216Volatilite annuelle (en %)");
    _plegstr = "Formule exacte\000Formule approchee (I)\000Formule approchee (II)";
    _plegctl = {2 5 4 5};
    _pmsgstr = "-";
    _pmsgctl = 0.18~3.18~0.07~-45~2~0~5;
    xy(100*pf,100*mstats[2 5 4,.]');

    _plegctl = 0;
    _pmsgstr = "-\000-";
    _pmsgctl = -1.52~5.67~0.07~45~2~0~5 |
               -1.52~5.34~0.07~45~2~0~5 ;

  setwind(3);
    ylabel("\216Ratio de Sharpe");   
    xy(100*pf,mstats[3,.]');

    graphprt("-c=1 -cf=backtest4.eps");

  endwind;