new;
library qam,pgraph,optmum;

datFileName = "..\\data\\qam_dataset1";

Data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

Data = selif(Data,(Data[.,1] .>= 19990101) .and (Data[.,1] .<= 20091231));
Data = Fill_Miss(Data,3);

Dates = Data[.,1];
nDates = rows(Dates);

let string selected_names = "SPX_TR" "USD/EUR" "US_1W" "EUR_1W";
indx = indsav(selected_names,vnames);
Data = Data[.,indx];

SPX_TR = Data[.,1];
EUR = Data[.,2];
USD_1W = Data[.,3]/100;
EUR_1W = Data[.,4]/100;

SPX_EUR_H = Currency_Hedging(Dates,SPX_TR,EUR_1W,USD_1W);
SPX_EUR_C = SPX_TR .* EUR;

Data = SPX_TR~SPX_EUR_H~SPX_EUR_C;
Data = Data./Data[1,.] * 100;

graphset;
  window3u;

    _pdate = ""; _pnum = 2; _pframe = 0;
    _pltype = 6|1|3; _plwidth = 8; _ptitlht = 0.275; _paxht = 0.175; _pnumht = 0.20;
    xtics(1,nDates,261,2);
    ytics(60,180,20,2);
    let xlab = "99" "00" "01" "02" "03" "04" "05" "06" "07" "08" "09";
    asclabel(xlab,0);

  setwind(1);
    _pcolor = 1;
    title("\216S&P 500 (Dollar)");
    xy(0,Data[.,1]);

  setwind(2);
    _pcolor = 2;
    title("\216S&P 500 (Euro couvert)");
    xy(0,Data[.,2]);

  setwind(3);
    _pcolor = 4;
    title("\216S&P 500 (Euro non couvert)");
    xy(0,Data[.,3]);

    graphprt("-c=1 -cf=backtest5.eps");

  endwind;

