new;
library qam,pgraph,optmum;


Dates = TradingDates(20080102,20080115);
let S = 100 100.5 102.7 107.4 98.2  100 104.2;
nDates = rows(S);
Dates = Dates[1:nDates];

let r = 0.04 0.04 0.041 0.040 0.039 0.038 0.040;
c = r + 50e-4;

S1 = Compute_Leverage_Strategy(Dates,S,r,0.5);
S2 = Compute_Leverage_Strategy(Dates,S,c,2);

Rdt = S./lag1(S) - 1;
dt = etdays2(lag1(Dates),Dates);
S_Lev = 100 + zeros(nDates,2);
i = 2;
do until i > nDates;
  S_Lev[i,1] = S_Lev[i-1,1] * (1 + 0.5 .* r[i-1] .* dt[i]/365 + 0.5 .* Rdt[i]);
  S_Lev[i,2] = S_Lev[i-1,2] * (1 + Rdt[i] + (Rdt[i] - c[i-1] .* dt[i]/365) );
  i = i + 1;
endo;

TexFile = "backtest6.tex";
mask = 1;
let fmt[8,3] = "%lf" 10 0
               "%lf" 6 2
               "%lf" 6 0
               "%lf" 6 4
               "%lf" 6 4
               "%lf" 6 4
               "%lf" 6 4
               "%lf" 6 4;
let string colNames = "$t$" "$S\\left(t \\right)$" "$dt$" "$R\\left( t\\right)$ (en \\%)" "$r\\left( t\\right)$ (en \\%)"
                      "$S_{\\ell_1}\\left( t\\right)$" "$c\\left( t\\right)$ (en \\%)" "$S_{\\ell_2}\\left( t\\right)$";
data = Dates~S~dt~100*Rdt~100*r~S1~c*100~S2;
Tabular(TeXFile,data,mask,fmt,0,colNames,0,0,1);

cls;
call text_print(TexFile);



