new;
library qam,optmum,cml;
qamSet;

rndseed 123456;

Nobs = 100;
Nreg = 4;
sigma = 0.25;

beta = rndn(Nreg,1);
x = rndu(Nobs,Nreg);
y = x*beta + rndn(Nobs,1)*sigma; // Modle Linaire

proc ml(theta,data);
  local b,sigma2,u,logl;

  b = theta[1:Nreg];
  sigma2 = theta[Nreg+1]^2;
  u = data[.,1] - data[.,2:cols(data)]*b;

  logl = -0.5*ln(2*pi) - 0.5*ln(sigma2) - 0.5*u^2/sigma2;    // Vecteur Nobs x 1

  retp(logl);
endp;

fn NegSumLL(theta) = -sumc(ml(theta,y~x));

sv = beta|sigma;

__output = 0;

_cml_A = 1~1~0~0~0;
_cml_B = 1;
{theta,fmin,grd,retcode} = optprt(optmum(&NegSumLL,sv));
{x,f,g,cov,retcode } = cmlprt(cml(y~x,0,&ml,sv));


