new;
library qam,optmum;
qamSet;

_Reg_PrintIters = 0;

rndseed 123456;

Nobs = 100;
Nreg = 4;
sigma = 0.25;

beta = rndn(Nreg,1);
x = rndu(Nobs,Nreg);
y = x*beta + rndn(Nobs,1)*sigma;

proc functionCLS(b);
  retp(y - x*b);
endp;

/*
**> Est. I
*/

sv = beta;
{theta,stderr,Mcov,u} = regCLS(&functionCLS,sv,0,0);

/*
**> Est. II - Introducing some missing values
*/
 
y[5] = miss(0,0);
{theta,stderr,Mcov,u} = regCLS(&functionCLS,sv,0,0);


/*
**> Est. III - Take into account weights and restrictions
*/

rndseed 123456;

x1 = rndu(Nobs,Nreg);
y1 = x1*beta + rndn(Nobs,1)*sigma;
x2 = rndu(Nobs,Nreg);
y2 = x2*(beta+1) + rndn(Nobs,1)*sigma;
x = x1|x2;
y = y1|y2;
y[1] = miss(0,0);

_reg_weight = ones(Nobs,1)|3*ones(Nobs,1);
let _ParNames = var1 var2 var3 var4;
{RR,r,gamma_} = regRestrict(0|0|0|0,1|2);
{theta,stderr,Mcov,u} = regCLS(&functionCLS,gamma_,RR,r);
