new;
library qam,optmum;
qamSet;

cls;

_reg_row = 5;
_reg_opalgr = 5;

rndseed 123456;

Nobs = 100;
Nreg = 4;
sigma = 0.25;

beta = rndn(Nreg,1);
x = rndu(Nobs,Nreg);
y = x*beta + rndn(Nobs,1)*sigma;


proc ml(theta,data);
  local b,sigma2,u,logl;

  b = theta[1:Nreg];
  sigma2 = theta[Nreg+1]^2;
  u = data[.,1] - data[.,2:cols(data)]*b;

  logl = -0.5*ln(2*pi) - 0.5*ln(sigma2) - 0.5*u^2/sigma2;

  retp(logl);
endp;

/*
**> Est. I
*/

data = y~x;

sv = beta|sigma;
_reg_Mcov = 1;
{theta,stderr,Mcov,u} = regML(0,data,&ml,sv,0,0);

_reg_Mcov = 2;
{theta,stderr,Mcov,u} = regML(0,data,&ml,sv,0,0);

_reg_Mcov = 3;
{theta,stderr,Mcov,u} = regML(0,data,&ml,sv,0,0);

/*
**> Est. II - Introducing some missing values
*/

 
y[5] = miss(0,0);
data = y~x;

_reg_Mcov = 2;
{theta,stderr,Mcov,u} = regML(0,data,&ml,sv,0,0);


/*
**> Est. III - Take into account weights and restrictions
*/

rndseed 123456;

x1 = rndu(Nobs,Nreg);
y1 = x1*beta + rndn(Nobs,1)*sigma;
x2 = rndu(Nobs,Nreg);
y2 = x2*(beta+1) + rndn(Nobs,1)*sigma;
x = x1|x2;
y = y1|y2;
y[1] = miss(0,0);
data = y~x;

_reg_weight = ones(Nobs,1)|3*ones(Nobs,1);
let _ParNames = var1 var2 var3 var4;
{RR,r,gamma_} = regRestrict(0|0|0|0|1,1|2);
_reg_Mcov = 1;
{theta,stderr,Mcov,u} = regML(0,data,&ml,gamma_,RR,r);