new;
library qam,optmum,pgraph;

cls;

let mu    = 5.0 10.0  8.0 12.0 12.0;
let sigma = 5.0 15.0 15.0 20.0 30.0;

mu = mu/100;
sigma = sigma/100;
let cor =   1
            0.1     1.0
           -0.1     0.5     1.0
           -0.1     0.5     0.7     1.0
            0.0     0.2     0.2     0.4     1.0;
cor = xpnd(cor);
cov = cor .* sigma .* sigma';
call invpd(cov);

let x_Bench = 0.55 0.00 0.45 0.00 0.00;

rf = 0.02;

sh = 0.10; 
{Pi1,phi} = Black_Litterman_Pi(x_Bench,cov,sh,rf,0);

sh = 0.25; 
{Pi2,phi} = Black_Litterman_Pi(x_Bench,cov,sh,rf,0);

sh = 0.50; 
{Pi3,phi} = Black_Litterman_Pi(x_Bench,cov,sh,rf,0);
print ftosa(100*(Pi1~Pi2~Pi3),"%lf",3,1);

mu_Target = 7.0/100;
nBasket = 5;
x0 = ones(nBasket,1)/nBasket;

Bounds = 0.0~1.0;

sh = 0.25; 
P = eye(nBasket); Q = mu; Omega = eye(nBasket) .* 0.05; Omega = Omega^2;

{x_BL1,phi,Pi_,mu_cond,TE} = Black_Litterman_Solve2(x_bench,cov,sh,rf,P,Q,Omega,Bounds,mu,mu_target,1e-10,0.5);

x = x_Bench~x_BL1;

print "-------------------------------";
print ftosa(100*x,"%lf",3,1);

ER_Bench = x_Bench'mu;
ER = x'mu;
VOL = sqrt(diag(x'*cov*x));
TE = sqrt(diag( (x-x_Bench)'*cov*(x-x_Bench) ));
IR = (ER - ER_Bench) ./ TE;

data = ER' | VOL' | TE' | IR';
print "-------------------------------";
print ftosa(100*data,"%lf",3,1);
