new;
library qam,optmum,pgraph;

cls;

pqgwin many;

xlsFileName = "gra2008-ex1.xls";
Rg = "A4";
Sheet = 1;

if 0;
  data = SpreadSheetReadM(xlsFileName,Rg,Sheet);
  data[.,1] = data[.,1]/1e6;
  save gra2008-ex1 = data;
else;
  loadm data = gra2008-ex1;
endif;

data = trimr(data,1,0);

Dates = Data[.,1];
nDates = rows(Dates);

SPTR = Data[.,2];
SX5T = Data[.,3];
Libor_USD = Data[.,4];
Libor_EUR = Data[.,5];

indx = 1|nDates;

SPTR_EUR = Currency_Hedging(Dates,SPTR,LIBOR_EUR,LIBOR_USD);

print "=====================  Question 4  =======================================";
print ftosa(Dates[indx]',"%lf",1,0);
print ftosa(SPTR[indx]',"%lf",1,2);
print ftosa(SPTR_EUR[indx]',"%lf",1,2);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 8; _pltype = 6|3; _pcolor = 1|4;
  xtics(0,nDates,262,1);
  let xlab = "2000" "2001" "2002" "2003" "2004" "2005" "2006" "2007" "2008" "2009" "2010";
  asclabel(xlab,0);
  title("\216Question 4");
  _plegstr = "USD\000EUR";
  _plegctl = {2 5 3 5};
  xy(0,SPTR~SPTR_EUR);

Weights_Basket = ones(nDates,1) .* (0.5~0.5);
Basket = SPTR_EUR~SX5T;
NR_Index = ones(nDates,1);
TC_Bid = 0;
TC_Ask = 0;

RD = trunc(Dates/1e4) ./= lag1(trunc(Dates/1e4));

F0 = Compute_Basket_With_TC(Dates,Weights_Basket,Basket,NR_Index,RD,TC_Bid,TC_Ask);

print "=====================  Question 5  =======================================";
print ftosa(Dates[indx]',"%lf",1,0);
print ftosa(F0[indx]',"%lf",1,2);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 8; _pltype = 6; _pcolor = 1;
  xtics(0,nDates,262,1);
  let xlab = "2000" "2001" "2002" "2003" "2004" "2005" "2006" "2007" "2008" "2009" "2010";
  asclabel(xlab,0);
  title("\216Question 5");
  xy(0,F0);

F1 = Add_Fees(Dates,F0,0.01,error(0),0,0);

print "=====================  Question 6  =======================================";
print ftosa(Dates[indx]',"%lf",1,0);
print ftosa(F1[indx]',"%lf",1,2);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 8; _pltype = 6|3; _pcolor = 1|4;
  xtics(0,nDates,262,1);
  let xlab = "2000" "2001" "2002" "2003" "2004" "2005" "2006" "2007" "2008" "2009" "2010";
  asclabel(xlab,0);
  title("\216Question 6");
  _plegstr = "Gross\000+ Fees";
  _plegctl = {2 5 3 5};
  xy(0,F0~F1);

Strategy = F1;
BenchMark = ones(nDates,1);
R_Index = Compute_Capitalized_Eonia(Dates,Libor_EUR);

Results = Compute_Global_Reporting(Dates,Strategy,BenchMark,R_Index,0,0);
xlsFileName = "gra2008-ex1-reporting.xlsx";
retcode = Excel_Reporting(Results,xlsFileName);

RD = trunc(Dates/1e4) ./= lag1(trunc(Dates/1e4));
F0 = Compute_Basket_With_TC(Dates,Weights_Basket,Basket,NR_Index,RD,TC_Bid,TC_Ask);

RD = rotater(RD',130)';
F1 = Compute_Basket_With_TC(Dates,Weights_Basket,Basket,NR_Index,RD,TC_Bid,TC_Ask);

RD = trunc(Dates/1e2) ./= lag1(trunc(Dates/1e2));
F2 = Compute_Basket_With_TC(Dates,Weights_Basket,Basket,NR_Index,RD,TC_Bid,TC_Ask);

print "=====================  Question 8  =======================================";
print ftosa(Dates[indx]',"%lf",1,0);
print ftosa(F0[indx]',"%lf",1,2);
print ftosa(F1[indx]',"%lf",1,2);
print ftosa(F2[indx]',"%lf",1,2);