new;
library qam,optmum,pgraph;

cls;

pqgwin many;

use_continuous = 1;

let mu =    0.05 0.06 0.08 0.06;
let sigma = 0.15 0.20 0.25 0.30;
n = rows(Sigma);
let rho =   1.00 
            0.10   1.00
            0.40   0.70   1.00
            0.50   0.40   0.80 1.00;
rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';
A = ones(1,n); B = 1;

Bounds = (-5~5) .* ones(n,1);

if use_continuous;
  phi = seqa(-2,1/100,600);
else;
  let phi = -1.0 -0.5 -0.25 0.00 0.25 0.50 1.00 2.00;
endif;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,A,B,0,0,Bounds,phi,0);  
er0 = er; risk0 = risk;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1;
  title("\216Question 1");
  xy(100*Risk,100*ER);

phi = 0;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,A,B,0,0,Bounds,phi,0);  
x_min = x;
vol_min = risk;
print "=====================  Question 2  =======================================";
print "Portefeuille de Variance Minimale";
print ftosa(100*x_min',"%lf",3,2); 
print ftos(100*vol_min,"vol = %lf",3,2); 
print ftos(100*er,"er = %lf",3,2);  

vol_target = 0.10;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,A,B,0,0,Bounds,vol_target,2);  
print "=====================  Question 3  =======================================";
print ftosa(100*x',"%lf",3,2); 
print ftos(100*risk,"vol = %lf",3,2); 
print ftos(100*er,"er = %lf",3,2); 
print "------------------------";

vol_target = 0.15;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,A,B,0,0,Bounds,vol_target,2);  
print ftosa(100*x',"%lf",3,2); 
print ftos(100*risk,"vol = %lf",3,2); 
print ftos(100*er,"er = %lf",3,2); 
print "------------------------";

vol_target = 0.20;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,A,B,0,0,Bounds,vol_target,2);  
print ftosa(100*x',"%lf",3,2); 
print ftos(100*risk,"vol = %lf",3,2);
print ftos(100*er,"er = %lf",3,2);  

x_sharpe = x;
let alpha = -0.50 -0.25 0.00 0.10 0.20 0.50 0.70 1.00;
x = (1-alpha') .* x_min + alpha' .* x_sharpe;
er = x'mu;
risk = sqrt(diag(x'cov*x));
print "=====================  Question 3  =======================================";
print "           ALPHA              VOL               ER";
print ftosa(100*(alpha~risk~er),"%lf",3,2); 

if use_continuous;
  alpha = seqa(-0.5,5/1000,600);
else;
  let alpha = -0.50 -0.25 0.00 0.10 0.20 0.50 0.70 1.00;
endif;
x = (1-alpha') .* x_min + alpha' .* x_sharpe;

er = x'mu;
risk = sqrt(diag(x'cov*x));

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  _plctrl = use_continuous-1|0; _pstype = 8;
  title("\216Question 4");
  xy(100*(Risk~Risk0),100*(ER~ER0));

Bounds = (0~1.00) .* ones(n,1);
phi = 0;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,A,B,0,0,Bounds,phi,0);  
x_min = x;
vol_min = risk;
print "=====================  Question 5  =======================================";
print ftosa(100*x_min',"%lf",3,2); 
print ftos(100*vol_min,"vol = %lf",3,2);
print ftos(100*er,"er = %lf",3,2);  
print "------------------------";

vol_target = 0.10;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,A,B,0,0,Bounds,vol_target,2);  
print ftosa(100*x',"%lf",3,2); 
print ftos(100*risk,"vol = %lf",3,2); 
print ftos(100*er,"er = %lf",3,2); 
print "------------------------";

vol_target = 0.15;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,A,B,0,0,Bounds,vol_target,2);  
print ftosa(100*x',"%lf",3,2); 
print ftos(100*risk,"vol = %lf",3,2); 
print ftos(100*er,"er = %lf",3,2); 
print "------------------------";

vol_target = 0.20;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,A,B,0,0,Bounds,vol_target,2);  
print ftosa(100*x',"%lf",3,2); 
print ftos(100*risk,"vol = %lf",3,2);
print ftos(100*er,"er = %lf",3,2);  

mu = mu | 0.03;
cov = (cov ~ zeros(4,1)) | zeros(1,5);
Bounds = (-5~5) .* ones(n+1,1);
A = ones(1,n+1); B = 1;

if use_continuous;
  phi = seqa(0,1/100,600);
else;
  let phi = -1.0 -0.5 -0.25 0.00 0.25 0.50 1.00 2.00;
endif;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,A,B,0,0,Bounds,phi,0);  
er0 = er; risk0 = risk;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1;
  title("\216Question 6 (b)");
  xy(100*Risk,100*ER);

indx = minindc(abs(x[5,.]'));
x_M = x[.,indx];

let phi = 0.25 0.50;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,A,B,0,0,Bounds,phi,0);  

print "=====================  Question 6 (d)  =======================================";
print "Portefeuille w1";
print ftosa(100*x[.,1]',"%lf",3,2); 
print ftos(100*risk[1],"vol = %lf",3,2);
print ftos(100*er[1],"er = %lf",3,2);  
print "------------------------";
print "Portefeuille w2";
print ftosa(100*x[.,2]',"%lf",3,2); 
print ftos(100*risk[2],"vol = %lf",3,2);
print ftos(100*er[2],"er = %lf",3,2);  
print "------------------------";
sh = (er[2] - er[1])/(risk[2] - risk[1]);
print ftos(sh,"sh = %lf",3,2);  
print "------------------------";

x1 = x[.,1];
x2 = x[.,2];

alpha = -x2[5]/(x1[5] - x2[5]);
x = alpha * x1 + (1-alpha) * x2;

print "=====================  Question 6 (e)  =======================================";
print ftos(100*alpha,"alpha = %lf",3,2);  
print ftosa(100*(x~x_M),"%lf",3,2); 
