new;
library qam,optmum,pgraph;

let params = 0.05 -0.02 0.00 1;

cls;

/*
**> Taux zro coupon
**
*/

t = 2|5|10;
Rt = NelsonSiegel_SpotRate(params,t);

print "=====================  Question 1 (a)  ==================================";
print ftosa(100*Rt,"%lf",3,2);

t = seqa(0,0.1,101);
Rt = NelsonSiegel_SpotRate(params,t);

graphset;
  _pdate = ""; _pframe = 0; _pnum = 2;
  _pltype = 6; _plwidth = 10; _pcolor = 1;
  title("\216Question 1 (b)");
  xy(t,Rt);

/*
**> Prix, YTM et Sensibilit des 3 obligations
**
*/

let Coupons = 3.5 5.15 4.25;
let tau     = 2   5    10;
Notionel = 100;

_Bond_Continuous_Time = 0;

Results = zeros(3,4);

i = 1;
do until i > 3;
  t = seqa(1,1,tau[i]);
  nt = rows(t);
  Ct = Coupons[i] * ones(nt,1);
  Ct[nt] = 100 + Ct[nt];
  Rt = NelsonSiegel_SpotRate(params,t);

  P = Bond_Compute_Price(t,Ct,Rt);
  YTM = Bond_Compute_YTM(t,Ct,P);
  D = Bond_Compute_Duration(t,Ct,YTM);

  Results[i,1] = tau[i];  
  Results[i,2] = P;  
  Results[i,3] = 100*YTM;  
  Results[i,4] = D; 

  if i == 2;
    P0 = P;
    P1 = Bond_Compute_Price(t,Ct,0.045);
    P2 = Bond_Compute_Price(t,Ct,0.046);
  endif; 

  i = i + 1;
endo;

print;
print "=====================  Question 2   ==================================";
print ftosa(Results,"%lf",3,3);
print;
print "=====================  Question 2 (b) ==================================";
print ftosa(P1~P0~P2,"%lf",3,3);

/*
**> Impact d'une hausse des taux
**
*/

P0 = Results[.,2];
YTM0 = Results[.,3];
S0 = Results[.,4];

dR = 0.0030;
P1 = zeros(3,3);

i = 1;
do until i > 3;
  t = seqa(1,1,tau[i]);
  nt = rows(t);
  Ct = Coupons[i] * ones(nt,1);
  Ct[nt] = 100 + Ct[nt];
  Rt = NelsonSiegel_SpotRate(params,t);

  P = Bond_Compute_Price(t,Ct,Rt + dR);
  P1[i,1] = P;
  P = Bond_Compute_Price(t,Ct,YTM0[i]/100 + dR);
  P1[i,2] = P;
  P = P0[i] + S0[i] .* dR;
  P1[i,3] = P;

  i = i + 1;
endo;

print;
print "=====================  Question 3 ==================================";
print ftosa(P0~P1,"%lf",3,4);

/*
**> Calcul du roll-down
**
*/

P1 = zeros(3,1);

i = 1;
do until i > 3;
  t = seqa(1,1,tau[i] - 1);
  nt = rows(t);
  Ct = Coupons[i] * ones(nt,1);
  Ct[nt] = 100 + Ct[nt];
  Rt = NelsonSiegel_SpotRate(params,t);

  P = Bond_Compute_Price(t,Ct,Rt);
  P1[i] = P;  
  i = i + 1;
endo;

Riding = (P1 + Coupons)./P0 - 1.0;

R1 = NelsonSiegel_SpotRate(params,1);
ER = Riding - R1;
Carry_C = Coupons ./ P0;
Carry_F = -R1*ones(3,1);
Carry = Carry_C + Carry_F;
Roll_Down = P1 ./ P0 - 1.0;

print;
print "=====================  Question 4 (b) ==================================";
print ftosa(tau~P0~100*(Carry~Roll_Down~ER),"%lf",3,2);

/*
**> Calcul du roll-down avec hausse des taux
**
*/

P1 = zeros(3,1);

i = 1;
do until i > 3;
  t = seqa(1,1,tau[i] - 1);
  nt = rows(t);
  Ct = Coupons[i] * ones(nt,1);
  Ct[nt] = 100 + Ct[nt];
  Rt = NelsonSiegel_SpotRate(params,t);

  P = Bond_Compute_Price(t,Ct,Rt + dR);
  P1[i] = P;  
  i = i + 1;
endo;

Riding = (P1 + Coupons)./P0 - 1.0;

R1 = NelsonSiegel_SpotRate(params,1);
ER = Riding - R1;
Carry_C = Coupons ./ P0;
Carry_F = -R1*ones(3,1);
Carry = Carry_C + Carry_F;
Roll_Down = P1 ./ P0 - 1.0;

print;
print "=====================  Question 4 (c) ==================================";
print ftosa(tau~P0~100*(Carry~Roll_Down~ER),"%lf",3,2);

/*
**> Stratgies de barbell
**
*/

beta = 0.5;

{n1,n2,n3,n4} = Barbell_Calibrate(S0,P0,Tau,beta);
n1 = 100*n1; n2 = 100*n2; n3 = 100*n3; n4 = 100*n4;
n = n1~n2~n3~n4;

print;
print "=====================  Question 5 (a/b/d) ================================";
print ftosa(n,"%lf",3,1);

let Scenarios[2,3] = -30   0  15
                     -30   0   0;

Scenarios = Scenarios/1e4;
nScenarios = rows(Scenarios);
PnL = zeros(nScenarios,4);

i = 1;
do until i > nScenarios;
  dR = Scenarios[i,.]';
  x = sumc(n .* S0 .* dR);
  PnL[i,.] = x';
  i = i + 1;
endo;

str = strtruncr(strCombine(itos("",1e4*Scenarios),"/",0),1);

print;
print "=====================  Question 5 (c/d) ================================";
print str$~ftosa(PnL,"%lf",3,2);