new;
library qam,optmum,pgraph;

__eps = 1e-10;

let mu =    0.05 0.09 0.07 0.06;
let sigma = 0.04 0.15 0.05 0.10;
let rho =   1.00 
            0.10  1.00
            0.40  0.20  1.00
           -0.10 -0.10 -0.20 1.00;
rho = xpnd(rho);
Cov = rho .* sigma .* sigma';

Bounds = 0~1;

let sigma = 0.04;
{x_0,mu_0,sigma_0,phi,retcode} = Qprog_Allocation_Solve(mu,cov,1,0,0,0,Bounds,sigma,2);  

x = Compute_Discrete_Simplex(4,20,1);

mu_x = x*mu;
sigma_x = zeros(rows(x),1);
i = 1;
do until i > rows(x);
  sigma_x[i] = sqrt(x[i,.]*cov*x[i,.]');
  i = i + 1;
endo;

e = (mu_x .>= mu_0) .and (abs(sigma_x - sigma_0) .<= 0.0050);

indx = selif(seqa(1,1,rows(e)),e);
x_1 = x[indx,.];
//dev = sumc(abs(x_1' - x_0));
dev = sumc((x_1' - x_0)^2);
indx = rev(sortind(dev));

n_x = _min_(10,rows(x_1));
x_1 = x_1[indx[1:n_x],.];

mu_1 = x_1*mu;
sigma_1 = sqrt(diag(x_1*cov*x_1'));
dev_1 = sumc((x_1' - x_0)^2);

Results = 100*(x_0'~mu_0~sigma_0~0) |
          100*(x_1~mu_1~sigma_1~dev_1) ;

Results = miss(Results,0);
Results = ftosa(Results,"%lf",3,2);

TexFile = "approxim2.tex";
call DeleteFile(TexFile);
call saTabular(Results,TexFile);

cls;
call text_print(TexFile);


