new;
library qam,pgraph,optmum;
dlibrary quad;

declare matrix omega;

proc (1) = f(x);
  retp( 2*pi*omega* cos(omega * x * 2 * pi) + 2 * x);
endp;

proc (1) = I(x);
  retp( x^2 + sin(2*pi*omega*x) );
endp;

bounds = seqa(0,0.05,201);
xl = bounds' | zeros(1,201);

omega = 1;
Iy = f(bounds);
I0 = I(bounds);
N = 4;
I1 = quadLegendre1(&f,xl,4);
N = 12;
I2 = quadLegendre1(&f,xl,N);
N = 100;
I3 = quadLegendre1(&f,xl,N);

omega = 8;
Jy = f(bounds);
J0 = I(bounds);
N = 100;
J3 = quadLegendre1(&f,xl,N);

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pnum = 2; _pltype = 6|1|3|5; _pframe = 0; _plwidth = 8;
  _pcolor = 1|2|3|4;
  _pnumht = 0.20; _paxht = 0.275; _ptitlht = 0.30;
  xtics(0,10,2,2);

  setwind(1);
    title("\216\202w\201 = 1");
    xlabel("\216x");
    ylabel("\216f(x)");
    ytics(-5,25,5,2);
    xy(bounds,Iy);

  setwind(2);
    ylabel("\216G(f)");
    ytics(0,120,20,2);
    _plegstr = "I\000n = 4\000n = 12\000n = 100";
    _plegctl = {2 5 2 4};
    xy(bounds,I0~I1~I2~I3);

  setwind(3);
    title("\216\202w\201 = 8");
    ylabel("\216f(x)");
    ytics(-50,75,25,2);
    _plegctl = 0;
    xy(bounds,Jy);

  setwind(4); 
    title("\216\202w\201 = 8 et n = 100");   
    ylabel("\216I - G(f)");
    ytics(1e-2,100,10,1);
    logy(bounds,abs(J0-J3)+__macheps);

  graphprt("-c=1 -cf=approxim21.eps");

  endwind;

