new;
library qam,pgraph,optmum;
dlibrary quad;

declare matrix omega;

proc (1) = f(x);
  retp( 2*pi*omega* cos(omega * x * 2 * pi) + 2 * x);
endp;

proc (1) = I(x);
  retp( x^2 + sin(2*pi*omega*x) );
endp;

omega = 1;

bounds = 10;
x = seqa(0,bounds/200,201);
y = f(x);
fit = zeros(rows(x),4);

N = 10;
{x_,w_} = gaussLegendre(N);
diff = bounds;
x_ = (0.5 * ( bounds + (bounds .* x_')))';
y1 = f(x_);
x1 = x_;
k = 1;
do until k > rows(x);
  fit[k,1] = polyint(x_,f(x_),x[k]);
  k = k + 1;
endo;

N = 16;
{x_,w_} = gaussLegendre(N);
diff = bounds;
x_ = (0.5 * ( bounds + (bounds .* x_')))';
y2 = f(x_);
x2 = x_;
k = 1;
do until k > rows(x);
  fit[k,2] = polyint(x_,f(x_),x[k]);
  k = k + 1;
endo;

N = 36;
{x_,w_} = gaussLegendre(N);
diff = bounds;
x_ = (0.5 * ( bounds + (bounds .* x_')))';
y3 = f(x_);
x3 = x_;
k = 1;
do until k > rows(x);
  fit[k,3] = polyint(x_,f(x_),x[k]);
  k = k + 1;
endo;

N = 200;
{x_,w_} = gaussLegendre(N);
diff = bounds;
x_ = (0.5 * ( bounds + (bounds .* x_')))';
y4 = f(x_);
x4 = x_;
k = 1;
do until k > rows(x);
  fit[k,4] = polyint(x_,f(x_),x[k]);
  k = k + 1;
endo;

graphset;
  begwind;
  window(2,2,0);

  _pnum = 2; _pltype = 6|1|3|5; _pframe = 0;
  _pnumht = 0.20; _paxht = 0.25; _ptitlht = 0.30;
  ytics(-5,25,5,2);
  _plwidth = 10; _pcolor = 1|2;

  setwind(1);
    title("\216n = 10");
    _psym = x1~y1~ones(rows(x1),1).*(8~0~15~1~0);
    xy(x,y~fit[.,1]);

  setwind(2);
    title("\216n = 16");
    _psym = x2~y2~ones(rows(x2),1).*(8~0~15~1~0);
    xy(x,y~fit[.,2]);

  setwind(3);
    title("\216n = 36");
    _psym = x3~y3~ones(rows(x3),1).*(8~0~15~1~0);
    xy(x,y~fit[.,3]);

  setwind(4);
    title("\216n = 200");
    _psym = x4~y4~ones(rows(x4),1).*(8~0~15~1~0);
    xy(x,y~fit[.,4]);

    graphprt("-c=1 -cf=approxim22.eps");

  endwind;