new;
library qam,pgraph,optmum;

rndseed 123;
dt = 1/50;
Nt = 301;
t = seqa(0,dt,Nt);
x = simulate_GBM(100,0.05,0.10,t,1);

p = 0.40;
indx = ceil(Nt*rndu(trunc(p*Nt),1));
indx = unique(indx,1);
x_miss = x;
x_miss[indx] = error(0) * ones(rows(indx),1);

y = regSpline(t,x,1,t);
ys = regSpline(t,x,0.5,t)~regSpline(t,x,0.99999,t);

graphset;
 begwind;
 window(2,2,0);

   _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pltype = 6; _ptitlht = 0.275;
  _paxht = 0.20; _pnumht = 0.20;

 xtics(0,6,1,0);
 ytics(90,150,10,0);
 xlabel("\216t");

 setwind(1);
   title("\216y]t[");
   _pcolor = 1;
   xy(t,x);

 setwind(2);
   title("\216y[*]]t[");
   _pcolor = 2;
   xy(t,x_miss);

 setwind(3);
   title("\216Interpolation spline S(t)");
   _pcolor = 3;
   xy(t,y);

 setwind(4);
   title("\216Lissage spline S(t)");
   _pcolor = 4|5; _pltype = 3|6;
   _plegstr = "p = 50%\000p = 99,99%";
   _plegctl = {2 6 5.5 1.5};
   xy(t,ys);

   graphprt("-c=1 -cf=approxim3.eps");

 endwind;