new;
library qam,optmum,pgraph;

proc f(t,x);
  local dx;
  dx = x[1]*cos(x[2]-x[3])*sin(x[4])    |
       0.2-x[2]*exp(-t)+x[1]/10         |
       -0.2*(x[1]-x[3])       |
       x[4]/(t^2)+1/x[1]                ;
  retp(dx);
endp;

let x_start = 1 -2 3 -2;
t_start = 5;
t_end = 30;
Nt = 500;

m = 20;
{t,x1,dx1} = ODE_Euler(&f,x_start,t_start,t_end,Nt);
{t_bis,x1_bis,dx1_bis} = ODE_Euler(&f,x_start,t_start,t_end,m*(Nt-1)+1);
{t,x2,dx2} = ODE_Runge_Kutta(&f,x_start,t_start,t_end,Nt);
{t,x3,dx3} = ODE_Adams_Bashforth(&f,x_start,t_start,t_end,Nt,5);
{t,x4,dx4} = ODE_Adams_Moulton(&f,x_start,t_start,t_end,Nt,5,5);

indx = seqa(1,m,Nt);
t_bis = t_bis[indx];
x1_bis = x1_bis[indx,.];

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|5|3; _pcolor = 1|2|3|4; _plwidth = 10;
  xtics(5,30,5,2);
  xlabel("\216t");
  ylabel("\216x]1[(t)");
  _plegstr = "Euler (N]t[ = 500)\000Runge Kutta (N]t[ = 500)\000Adams-Bashforth (N]t[ = 500)\000Euler (N]t[ = 10000)";
  _plegctl = {2 5 1.5 5};
  graphprt("-c=1 -cf=approxim30.eps");
  xy(t,x1[.,1]~x2[.,1]~x3[.,1]~x1_bis[.,1]);

 

