new;
library qam,optmum,pgraph;

proc solution(t);
  retp(exp(t) + t^2);
endp;

proc f(t,x);
  local u;
  u = zeros(3,1);
  u[1] = x[2];
  u[2] = x[3];
  u[3] = x[1]-t^2;
  retp(u);
endp;

let x_start = 1 1 3;
t_start = 0; t_end = 5; Nt = 1000;

{t,x1,dx1} = ODE_Euler(&f,x_start,t_start,t_end,Nt);
{t,x2,dx2} = ODE_Runge_Kutta(&f,x_start,t_start,t_end,Nt);
{t,x3,dx3} = ODE_Adams_Bashforth(&f,x_start,t_start,t_end,Nt,5);
{t,x4,dx4} = ODE_Adams_Moulton(&f,x_start,t_start,t_end,Nt,5,5);

y = solution(t);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pltype = 6; _pysci = 0;
  _paxht = 0.20; _pnumht = 0.20; _ptitlht = 0.25;
  xtics(0,5,1,2);
  ylabel("\216Erreur numerique");
  _pmsgstr = "-";
  _pmsgctl = 0.18~3.75~0.07~-45~2~0~5 ;

  setwind(1);
    title("\216Euler");
    _pcolor = 1;
    ytics(-2,0,0.5,2);
    xy(t,x1[.,1]-y);

  setwind(2);
    title("\216Runge Kutta");
    _pcolor = 2;
    ytics(-5e-9,0,1e-9,2);
    xy(t,x2[.,1]-y);

  setwind(3);
    title("\216Adams-Bashforth");
    _pcolor = 3;
    ytics(-8e-10,0,2e-10,2);
    xy(t,x3[.,1]-y);

  setwind(4);
    title("\216Adams-Moulton");
    _pcolor = 4;
    ytics(-0.3e-11,1.2e-11,0.3e-11,2);
    xy(t,x4[.,1]-y);

  graphprt("-c=1 -cf=approxim31.eps");

  endwind;




