new;
library qam,optmum,pgraph;

proc f(t,x);
  local y;
  y = x[2]        |
      -sin(t)     ;
  retp(y);
endp;

let x_start = 0 1;
t_start = 0;
t_end = 2*pi;
Nt = 1000;

{t,x,dx} = ODE_Runge_Kutta(&f,x_start,t_start,t_end,Nt);

{r,theta} = topolar(complex(x[.,1],x[.,2]));
r2 = ones(Nt,1);
theta2 = seqa(0,2*pi/Nt,Nt);

graphset;
  begwind;
  makewind(9,6.855,0,0,0);
  makewind(3,2,0.5,0.5,0);

  _pdate = ""; _pframe = 0; _pnum = 2;
  _plwidth = 10; _pltype = 6|3; _pcolor = 1|2;
  fonts("simplex simgrma");

  setwind(1);
    _pticout = 0;
    xtics(-1,1,0.25,2);
    ytics(-1,1,0.25,2);
    polar(r~r2,theta~theta2);
  setwind(2);
    _pframe = 1; _pysci = 0; _pbox = 4;
    _ptitlht = 0.30; _paxht = 0.25; _pnumht = 0.25;
    _pltype = 1;
    xtics(0,2*pi,pi/2,0);
    ytics(-4e-12,0,1e-12,2);
    let xlab = "0" "\202p\201/2" "\202p\201" "3\202p\201/2" "2\202p\201";
    asclabel(xlab,0);
    title("Erreur de la solution numerique");
    xlabel("t");
    xy(t,x[.,1]-sin(t));
  endwind;

