new;
library qam,optmum,pgraph;

proc f(t,x);
  local dx;
  dx = 0.2*x[1]-x[2] |
       x[2]+x[1]     ;
  retp(dx);
endp;

t_start = 2;
t_end = 10;
Nt = 200;

let x_start = 3 2;
{t,x,dx} = ODE_Runge_Kutta(&f,x_start,t_start,t_end,Nt);
print x[Nt,.]';

proc g(theta);
  local t,x,dx,x_end,u;
  {t,x,dx} = ODE_Runge_Kutta(&f,theta,t_start,t_end,Nt);
  x_end = x[Nt,.]';
  u = x_end-(10|15);
  retp(u'u);
endp;

let sv = 3 2;
{theta,fmin,grd,retcode} = optmum(&g,sv);
x_start = theta;
{t,x,dx} = ODE_Runge_Kutta(&f,x_start,t_start,t_end,Nt);
print x[Nt,.]';


graphset;
  _pdate = ""; _pframe = 0; _pnum = 2; _pgrid = {3,1};
  _plwidth = 10; _pltype = 6|1; _pcolor = 1|4;
  _plegstr = "x]1[(t)\000x]2[(t)";
  _plegctl = {2 5 2 4};
  ytics(-10,15,5,2);
  xlabel("\216t");
  graphprt("-c=1 -cf=approxim34.eps");
  xy(t,x);

