new;
library qam,optmum,pgraph;

declare external epsilon;
declare external omega;
declare external _gamma;

proc duffing(t,z);
  local x,y,d;

  x = z[1];
  y = z[2];

  d = (y                                              )    |
      (x - x^3 - epsilon*y + _gamma*cos(omega*t)      )    ;

  retp(d);
endp;

let z0 = -1 1;

epsilon = 0.22; _gamma = 0.3; omega = 1;

{t,z,dz} = ODE_Runge_Kutta(&duffing,z0,0,50,100);

pqgwin many;

graphset;
  _pnum = 2; _pdate = "";
  fonts("simplex simgrma");
  title("Duffing's equation (\202e\201=0.22, \202g\201=0.3, \202w\201=1)"\
        "\Ldx/dt = y                       "\
        "\Ldy/dt = x - x[3] - \202e\201y + \202g\201cos(\202w\201t)");
  xlabel("t");
  _plegstr = "x(t)\000y(t)";
  _plegctl = {2 5 7 1};
  xy(t,z);

{t,z,dz} = ODE_Runge_Kutta(&duffing,z0,0,5000,10000);
z0 = z[10000,.]';
{t,z,dz} = ODE_Runge_Kutta(&duffing,z0,0,500,10000);

graphset;
  _pnum = 2; _pdate = "";
  fonts("simplex simgrma");
  title("Duffing's equation (\202e\201=0.22, \202g\201=0.3, \202w\201=1)"\
        "\Ldx/dt = y                       "\
        "\Ldy/dt = x - x[3] - \202e\201y + \202g\201cos(\202w\201t)");
  xlabel("x");
  ylabel("y");
  xy(z[.,1],z[.,2]);


