new;
library qam,optmum,pgraph;

declare external a;
declare external b;
declare external alpha;

proc f(u);
  retp(-a*u + 0.5*(a+b)*( abs(u+1) - abs(u-1) ));
endp;

proc hopf(t,w);
  local x,y,z,fxy,dw;

  x = w[1];
  y = w[2];
  z = w[3];

  fxy = f(y-x);

  dw =  -alpha*fxy     |
        -fxy - z       |
            y          ;

  retp(dw);
endp;

alpha = 0.01; a = 0.07; b = 0.1;

w0 = ones(3,1);
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,100,1000);
w0 = w[1000,.]';
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,100,1000);

pqgwin many;

graphset;
  _pdate = ""; _pnum = 2; _pnumht = 0.20;  _paxht = 0.20;
  fonts("simplex simgrma");
  title("HOPF model (a=0.07, b=0.1, \202a\201=0.01)"\
        "\Ldx/dt = -\202a\201f(y-x)   dy/dt = -f(y-x)-z   dz/dt = y"\
        "\Lf(u) = -a*u + 0.5*(a+b)*(|u+1|-|u-1|)");
  xlabel("x");
  ylabel("y");
  zlabel("z");
  xyz(w[.,1],w[.,2],w[.,3]);

alpha = 0.1;
w0 = ones(3,1);
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);
w0 = w[10000,.]';
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);

graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("HOPF model (a=0.07, b=0.1, \202a\201=0.1)"\
        "\Ldx/dt = -\202a\201f(y-x)   dy/dt = -f(y-x)-z   dz/dt = y"\
        "\Lf(u) = -a*u + 0.5*(a+b)*(|u+1|-|u-1|)");
  xlabel("x");
  ylabel("y");
  xy(w[.,1],w[.,2]);

  _pdate = ""; _pnum = 2; _pnumht = 0.20;  _paxht = 0.20;
  xlabel("x");
  ylabel("y");
  zlabel("z");
  xyz(w[.,1],w[.,2],w[.,3]);



alpha = 1;
w0 = ones(3,1);
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);
w0 = w[10000,.]';
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);

graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("HOPF model (a=0.07, b=0.1, \202a\201=1)"\
        "\Ldx/dt = -\202a\201f(y-x)   dy/dt = -f(y-x)-z   dz/dt = y"\
        "\Lf(u) = -a*u + 0.5*(a+b)*(|u+1|-|u-1|)");
  xlabel("x");
  ylabel("z");
  xy(w[.,1],w[.,3]);

  _pdate = ""; _pnum = 2; _pnumht = 0.20;  _paxht = 0.20;
  xlabel("x");
  ylabel("y");
  zlabel("z");
  xyz(w[.,1],w[.,2],w[.,3]);



alpha = 20;
w0 = ones(3,1);
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);
w0 = w[10000,.]';
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);

graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("HOPF model (a=0.07, b=0.1, \202a\201=20)"\
        "\Ldx/dt = -\202a\201f(y-x)   dy/dt = -f(y-x)-z   dz/dt = y"\
        "\Lf(u) = -a*u + 0.5*(a+b)*(|u+1|-|u-1|)");
  xlabel("x");
  ylabel("y");
  xy(w[.,1],w[.,2]);

  _pdate = ""; _pnum = 2; _pnumht = 0.20;  _paxht = 0.20;
  xlabel("x");
  ylabel("y");
  zlabel("z");
  xyz(w[.,1],w[.,2],w[.,3]);



alpha = 80;
w0 = ones(3,1);
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);
w0 = w[10000,.]';
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);

graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("HOPF model (a=0.07, b=0.1, \202a\201=80)"\
        "\Ldx/dt = -\202a\201f(y-x)   dy/dt = -f(y-x)-z   dz/dt = y"\
        "\Lf(u) = -a*u + 0.5*(a+b)*(|u+1|-|u-1|)");
  xlabel("x");
  ylabel("z");
  xy(w[.,1],w[.,3]);

  _pdate = ""; _pnum = 2; _pnumht = 0.20;  _paxht = 0.20;
  xlabel("x");
  ylabel("y");
  zlabel("z");
  xyz(w[.,1],w[.,2],w[.,3]);

