new;
library qam,optmum,pgraph;

declare external a,b,c;

proc lorenz(t,u);
  local x,y,z,dx,dy,dz,du;

  x = u[1]; y = u[2]; z = u[3];

  dx = -(y+z);
  dy = x + a*y;
  dz = b + x*z -c*z;

  du = dx|dy|dz;

  retp(du);
endp;


a = 0.2; b = 0.2; c = 5.25;

u0 = 0|1|1;
{t,u,du} = ODE_Runge_Kutta(&lorenz,u0,0,100,500);
u0 = u[500,.]';
{t,u,du} = ODE_Runge_Kutta(&lorenz,u0,0,100,2000);

graphset;
  _pdate = ""; _pnum = 2; _pnumht = 0.18;  _paxht = 0.18;
  fonts("simplex simgrma");
  title("Rossler model");
  xlabel("x");
  ylabel("y");
  zlabel("z");
  xyz(u[.,1],u[.,2],u[.,3]);

