new;
library qam,optmum,pgraph;

declare external e;
declare external m;

proc vdp(t,z);
  local x,y,dz;

  x = z[1];
  y = z[2];

  dz = -y                    |
       x -e*(y^3/3 - m*y)    ;

  retp(dz);
endp;

e = 1; m = 0.5;
z0 = zeros(2,1) + 0.00001;

{t,z,dz} = ODE_Runge_Kutta(&vdp,z0,0,100,1000);

pqgwin many;

graphset;
  _pnum = 2; _pdate = "";
  fonts("simplex simgrma");
  title("Van der Pol model (e=1, m=0.5)"\
        "\Ldx/dt = -y                  "\
        "\Ldy/dt = x - e*(y[3]/3 - m*y)");
  xlabel("x");
  ylabel("y");
  xy(z[.,1],z[.,2]);

e = 1; m = 1.5;
z0 = zeros(2,1) + 0.00001;

{t,z,dz} = ODE_Runge_Kutta(&vdp,z0,0,100,1000);
z0 = z[1000,.]';
{t,z,dz} = ODE_Runge_Kutta(&vdp,z0,0,100,1000);

graphset;
  _pnum = 2; _pdate = "";
  fonts("simplex simgrma");
  title("Van der Pol model (e=1, m=1.5)"\
        "\Ldx/dt = -y                  "\
        "\Ldy/dt = x - e*(y[3]/3 - m*y)");
  xlabel("x");
  ylabel("y");
  xy(z[.,1],z[.,2]);

