new;
library qam,optmum,pgraph;

declare external a;
declare external b;
declare external alpha;

proc f(u);
  retp(-a*u + 0.5*(a+b)*( abs(u+1) - abs(u-1) ));
endp;

proc hopf(t,w);
  local x,y,z,fxy,dw;

  x = w[1];
  y = w[2];
  z = w[3];

  fxy = f(y-x);

  dw =  -alpha*fxy     |
        -fxy - z       |
            y          ;

  retp(dw);
endp;

alpha = 0.01; a = 0.07; b = 0.1;

w0 = ones(3,1);
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,100,1000);
w0 = w[1000,.]';
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,100,1000);
w0 = w[1000,.]';
{t1,w1,dw1} = ODE_Runge_Kutta(&hopf,w0,0,100,1000);

alpha = 0.1;
w0 = ones(3,1);
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);
w0 = w[10000,.]';
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,100,1000);
w0 = w[1000,.]';
{t2,w2,dw2} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);

alpha = 1;
w0 = ones(3,1);
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);
w0 = w[10000,.]';
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,100,1000);
w0 = w[1000,.]';
{t3,w3,dw3} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);

alpha = 20;
w0 = ones(3,1);
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);
w0 = w[10000,.]';
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,100,1000);
w0 = w[1000,.]';
{t4,w4,dw4} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);

alpha = 80;
w0 = ones(3,1);
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);
w0 = w[10000,.]';
{t,w,dw} = ODE_Runge_Kutta(&hopf,w0,0,100,1000);
w0 = w[1000,.]';
{t5,w5,dw5} = ODE_Runge_Kutta(&hopf,w0,0,1000,10000);

graphset;
  begwind;
  window(2,2,1);

    _pnum = 2; _pdate = ""; _pframe = 0;
    _pltype = 6|3; _plwidth = 5; _pcolor = 1;
    _ptitlht = 0.25; _pnumht = 0.20; _paxht = 0.30;
    fonts("simplex simgrma");
    xlabel("\216x(t)");
    ylabel("\216y(t)");
    zlabel("\216z(t)");

  setwind(1);
    title("\216\202a\201 = 0,01");
    xtics(1.06,1.18,0.03,2);
    ytics(-1,1,0.5,2);
    ztics(-1,1,0.5,2);
    xyz(w1[.,1],w1[.,2],w1[.,3]);

  setwind(2);
    title("\216\202a\201 = O,1");
    xtics(1.25,1.28,0.01,2);
    ytics(-2,2,1,2);
    ztics(-2,2,1,2);
    xyz(w2[.,1],w2[.,2],w2[.,3]);

  setwind(3);
    title("\216\202a\201 = 1");
    xtics(-3,3,1,2);
    ytics(-3,3,1,2);
    ztics(-3,3,1,2);
    xyz(w4[.,1],w4[.,2],w4[.,3]);

  setwind(4);
    title("\216\202a\201 = 80");
    xtics(-15,15,5,2);
    ytics(-10,10,5,2);
    ztics(-10,10,5,2);
    xyz(w5[.,1],w5[.,2],w5[.,3]);

   graphprt("-c=1 -cf=approxim36.eps");

  endwind;

