new;
library qam,optmum,pgraph;

let matrix coeffs[4,6] = 0.05 0.10 0.05 0.05 0.02 0.05
                         0.05 0.10 0.05 0.05 0.02 0.11                         
                         0.05 0.10 0.05 0.05 0.02 0.15
                         0.05 0.10 0.05 0.05 0.02 0.50;

Coeffs = Coeffs';

declare matrix iter;

proc m_Proc(t);
  retp(0.02);
endp;

proc r_Proc(t);
 retp(Coeffs[1,iter]);
endp;

proc mu_Proc(t);
 retp(Coeffs[2,iter]);
endp;

proc Lambda_In_Proc(t);
  if t < 5;
    retp(Coeffs[3,iter]);
  else;
    retp(Coeffs[4,iter]);
  endif;
endp;

proc Lambda_Out_Proc(t);
  if t < 5;
    retp(Coeffs[5,iter]);
  else;
    retp(Coeffs[6,iter]);
  endif;
endp;

t_max = 20;
Nt = 1001;

K0 = 100;
K = zeros(Nt,4); F = zeros(Nt,4);

iter = 1;
do until iter > 4;
  {t,K[.,iter],F[.,iter]} = Compute_Ponzi_Model(K0,&r_Proc,&mu_Proc,&lambda_in_Proc,&lambda_out_Proc,&m_Proc,t_max,Nt);
  iter = iter + 1;
endo;

F = missex(F,K .<= 0.0);
K = missex(K,K .<= 0.0);

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|2;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.25;
  xtics(0,20,5,2);

  _pline = 1~1~5~0~5~800~1~4~10;

  j = 1;
  do until j > 4;
    setwind(j);
      ptitle = ftos(100*Coeffs[6,j],"\216\202l\201 = %lf",1,0) $+ "%";
      title(ptitle);
      if j == 1;
        ytics(0,600,100,2);
      elseif j == 2;
        ytics(0,250,50,2);
      elseif j == 3;
        ytics(0,200,50,2);
      elseif j == 4;
        ytics(0,200,50,2);
        _plegstr = "F(t)\000K(t)";
        _plegctl = {2 6.5 6 1.5};
      endif;
      xy(t,F[.,j]~K[.,j]);
    j = j + 1;
  endo;

  graphprt("-c=1 -cf=approxim39.eps");

  endwind;

