new;
library qam,option,pgraph,optmum;

dlibrary option_tridiag; // Don't miss to download the tridiag solver

cls;

a = 0.95; b = 0.10; sigma = 0.2; lambda = 0.05;
bprime =  b - lambda*sigma/a;

proc aProc(t,x);
  retp( 0.5*(sigma^2) * ones(rows(x),1) ); 
endp;


proc bProc(t,x);
  retp( a*(bprime-x) );
endp;

proc cProc(t,x);
  retp( x );
endp;

proc dProc(t,x);  
  retp( zeros(rows(x),1) );
endp;

proc tminBound(t,x);
  retp( ones(rows(x),1) );
endp;

call PDE(&aProc,&bProc,&cProc,&dProc,0,
         &tminBound,0,0,0,0);

tmin = 0;
tmax = 5;
Nt = 1001;
xmin = -1;
xmax = 1;
Nx = 101;

_pde_PrintIters = 0;
_pde_SaveLastIter = 0;

U = zeros(Nt,5);
theta = seqa(0,0.25,5);

i = 1;
do until i > 5;

  call PDE_solve(tmin,tmax,Nt,xmin,xmax,Nx,"pde",theta[i]);

  t = PDE_readFile("pde","t");
  x = PDE_readFile("pde","x");
  U[.,i] = PDE_readFile("pde","x"|x[56]);

  i = i + 1;
endo;

tau = t;
{CouponZero,TauxZero} = Vasicek(x[56],a,b,sigma,lambda,tau);
diff = CouponZero - U;

call DeleteFile("pde.dat");

graphset;
  _pdate = ""; _pnum = 2; _pltype = 3|1|6|1|3; _pstype = 8|8|1|9|9; _plctrl = 75|75|0|75|75;
  _pcolor = 1|2|3|4|5|6; _plwidth = 10;
  fonts("simplex simgrma");
  xtics(0,5,1,10);
  xlabel("\216T (en annees)");
  ylabel("\216Erreur");
  _plegstr = "\202Q\201 = 0\000\202Q\201 = 0.25\000\202Q\201 = 0.5\000"\
             "\202Q\201 = 0.75\000\202Q\201 = 1";
  _plegctl = {2 4 4 3.05};
  _pysci = 2;
  _pmsgstr = "-";
  _pmsgctl = 5.24~0.31~0.07~45~2~0~6;
  graphprt("-c=1 -cf=approxim50.eps");
  xy(t,diff);


