new;
library qam,pgraph,optmum;

cls;

Let MT_1M_S[6,6] = 0.9714 0.0041 0.0062 0.0054 0.0077 0.0052
                   0.0126 0.8484 0.1348 0.0040 0.0002 0.0000
                   0.0078 0.1423 0.6730 0.1696 0.0073 0.0000
                   0.0070 0.0084 0.2234 0.6230 0.1375 0.0007
                   0.0066 0.0000 0.0088 0.1523 0.7668 0.0655
                   0.0038 0.0000 0.0000 0.0005 0.1470 0.8487;

Lambda = lnMatrix(MT_1M_S)*12;
{Lambda1,lambda2} = Estimate_Markov_Generator(Lambda);

declare matrix indx_k;

proc (2) = Persistance_Measure(t,k);
  local MT,Pr_k,Pr_not_k; 

  MT = expMatrix(Lambda1*t);
  MT = MT[2:6,2:6];
  Pr_k = MT[k,k];
  Pr_not_k = sumc(MT[k,.]') - Pr_k;
  retp(Pr_k,Pr_not_k);
endp;

proc fn_t(t);
  local Pr_k,Pr_not_k;

  {Pr_k,Pr_not_k} = Persistance_Measure(t,indx_k);
  retp(Pr_k-Pr_not_k);
endp;

t = zeros(5,1);
k = 1;
do until k > 5;
  indx_k = k;
  t[k] = bisection(&fn_t,1/12,3);
  k = k + 1;
endo;

print t;
months = t*12;
print months;

t = seqa(0.001,0.01,101);
nt = rows(t);
Pr_k = zeros(nt,5);
Pr_not_k = zeros(nt,5);
i = 1;
do until i > nt;
  k = 1;
  do until k > 5;
    {Pr_k[i,k],Pr_not_k[i,k]} = Persistance_Measure(t[i],k);
    k = k + 1;
  endo;
  i = i + 1;
endo;

graphset;
  begwind;
  makewind(9/3,6.855/2,0,6.855/2,1);
  makewind(9/3,6.855/2,9/3,6.855/2,1);
  makewind(9/3,6.855/2,2*9/3,6.855/2,1);
  makewind(9/3,6.855/2,9/3/2,0,1);
  makewind(9/3,6.855/2,9/3/2+9/3,0,1);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10;
  _plegstr = "Pr(R(t) = R]k[)\000Pr(R(t) \202=\201 R]k[)";
  xtics(0,1,0.2,2);

  if _qam_BW;
    _pcolor = 0|3;
  endif;

  let string ptitle = "*" "**" "***" "****" "*****";
  _ptitlht = 0.50; _paxht = 0.25; _pnumht = 0.25;
  i = 1;
  do until i > 5;
    setwind(i);
    title("\216" $+ ptitle[i]);
    if i == 5;
      _plegctl = {2 7.5 8.0 2.3};
    endif;
    xy(t,100*(Pr_k[.,i]~Pr_not_k[.,i]));
    i = i + 1;
  endo;

  graphprt("-c=1 -cf=lapack14.eps");

  endwind;

 




