new;
library qam,pgraph,optmum;

__output = 0;

PathName = "..\\data\\";
FileName = PathName  $+ "qam_stocks_weekly";

data = loadd(FileName);
data = selif(data,(data[.,1] .>= 19900101) .and (data[.,1] .<= 20091231));
vnames = getname(FileName);

Dates = Data[.,1];
nDates = rows(dates);
R = Data./lag1(Data) - 1;

let factors = "cac 40" "brent" "eur/usd";
indx = indcv(factors,vnames);
R_Factors = R[.,indx];

indx = indcv("total",vnames);
R_Total = R[.,indx];

indx = indcv("carrefour",vnames);
R_carrefour = R[.,indx];

/* Residual efficiency frontier */

mu = seqa(0.10,0.01,49)|sqrt((seqm(1,2,20)));
n = rows(mu);
r2D = zeros(n,2);
r2M = zeros(n,2);

i = 1;
do until i>rows(mu);
  {beta,u,r2M[i,1],r2D[i,1]} = regFLS(R_Total,R_Factors,mu[i]);
  {beta,u,r2M[i,2],r2D[i,2]} = regFLS(R_Carrefour,R_Factors,mu[i]);
  i = i+1;
endo;

mu = 1.0;
{beta_Total,u_Total,r2M_Total,r2D_Total} = regFLS(R_Total,R_Factors,mu);
{beta_Carrefour,u_Carrefour,r2M_Carrefour,r2D_Carrefour} = regFLS(R_Carrefour,R_Factors,mu);

pqgwin many;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1; _pcolor = 1|4; _plwidth = 10;
  xlabel("\216R]D[[2]");
  ylabel("\216R]M[[2]");
  xtics(0,0.5,0.1,2);
  ytics(0.6,0.95,0.05,2);
  _plegstr = "Total\000Carrefour";
  _plegctl = {2 5 5 5};
  _psym = R2D_Total~R2M_Total~11~6.5~1~1~10 |
          R2D_carrefour~R2M_carrefour~11~6.5~4~1~10 ;
  graphprt("-c=1 -cf=lapack22-1.eps");
  xy(r2D,r2M);

let string ptitle[3,1] = "Cac 40" "Brent" "EUR/USD";

x = seqa(1,0.25,4*nDates);
{x,beta_Total} = graph_smooth(0,beta_Total,0.90,x,1);
{x,beta_Carrefour} = graph_smooth(0,beta_Carrefour,0.90,x,1);

graphset;
  window3u;

  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pltype = 6|1; _pcolor = 1|4;
  _pnumht = 0.20; _paxht = 0.20; _ptitlht = 0.25;

  xtics(1,nDates,2*52.15,2);
  let xlab = "90" "92" "94" "96" "98" "00" "02" "04" "06" "08" "10";
  asclabel(xlab,0);

  _plegstr = "Total\000Carrefour";

  i = 1;
  do until i > 3;
    _plegctl = 0;
    setwind(i);
      if i == 1;
        ytics(0.2,1.2,0.2,2);
        _plegctl = {2 7 10 3};
      elseif i == 2;
        ytics(-0.2,0.4,0.2,2);
      elseif i == 3;
        ytics(-0.4,0.2,0.2,2);
      endif;
      title("\216" $+ ptitle[i]);
      xy(x,beta_Total[.,i]~beta_Carrefour[.,i]);

    i = i + 1;
  endo;

  graphprt("-c=1 -cf=lapack22-2.eps");

  endwind;


