new;
library qam,pgraph;

rndseed 123456;

ns = 1000000;

fn f(x,y,z) = (x^2 + y^2 + z^2) ;

u = rndu(ns,3)*5;

x = u[.,1];
y = u[.,2];
z = u[.,3];

cnd = ((x^2 + y^2 + z^2) .<= 25) .and ((x + y + z) .>= 0);

value = f(x,y,z) .* cnd;
sigma = stdc(value);

s = seqa(1,1,ns);

I = cumsumc(value)./s;

std = sigma ./sqrt(s);

bounds = I + (-1.96~0~1.96) .* std;

indx = seqa(1,0.02,500);
indx = 10^indx;
indx = delif(indx, indx .> ns);

bounds = trimr(bounds[indx,.],0,0);
s = trimr(s[indx],0,0);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 3|6|3; _pcolor = 2|1|3; _plwidth = 10;
  ytics(4,13,1,2);
  xlabel("\216Nombre de simulations");
  _plegstr = "IC 99% (borne haute)\000Estimation\000IC 99% (borne basse)";
  _plegctl = {2 5 5 5};
  graphprt("-c=1 -cf=mc13.eps");
  logx(s,bounds);








