new;
library option,qam,pgraph,optmum;

x0 = 100; 
mu = 0.10;
sigma = 0.20;
Ns = 1;

fn procMu(t,x) = mu * x;
fn procSigma(t,x) = sigma * x;

t = seqa(0,0.1,101);

rndseed 123;
x1 = simulate_GBM(x0,mu,sigma,t,Ns);

rndseed 123;
x2 = simulate_SDE(x0,&procMu,&procSigma,t,Ns);

sigma = 0.50;
t_year = seqa(0,0.10,101);

rndseed 123;
x3 = simulate_GBM(x0,mu,sigma,t_year,Ns);

rndseed 123;
x4 = simulate_SDE(x0,&procMu,&procSigma,t_year,Ns);


graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; 
  _plwidth = 10; _pcolor = 1; _pltype = 6;
  _paxht = 0.25; _pnumht = 0.20; _ptitlht = 0.25;

  xtics(0,10,1,10);
  ytics(50,300,50,2);

  setwind(1);
   _pcolor = 1;
   title("\216Exact (\202s\201 = 20 %)");
    xy(t,x1);

  setwind(2);
   _pcolor = 2;
   title("\216Euler (\202s\201 = 20 %)");
    xy(t,x2);

  ytics(25,150,25,2);

  setwind(3);
   _pcolor = 3;
   title("\216Exact (\202s\201 = 50 %)");
    xy(t_year,x3);

  setwind(4);
   _pcolor = 4;
   title("\216Euler (\202s\201 = 50 %)");
   xy(t_year,x4);

   graphprt("-c=1 -cf=mc4.eps");

  endwind;