new;
library option,qam,pgraph,optmum;

x0 = 100; 
mu = 0.10;
sigma = 0.20;

Ns = 20000;
x_min = zeros(Ns,4);

fn procMu(t,x) = mu * x;
fn procSigma(t,x) = sigma * x;

t0 = seqa(2,2,5);
t1 = seqa(0,2,6);
t2 = seqa(0,0.5,21);

iter = 1;
do until iter > 4;
  rndseed 123;

  if iter <= 2;
    t = t1;
  else;
    t = t2;
  endif;

  if iter % 2 == 1;
    x = simulate_GBM(x0,mu,sigma,t,Ns);
  else;
    x = simulate_SDE(x0,&procMu,&procSigma,t,Ns);
  endif;

//  x = trimr(x,1,0);
  indx = indnv(t0,t);
  x = x[indx,.];
  x_min[.,iter] = minc(x);

  iter = iter + 1;
endo;

x = seqa(0,1,251);
d = zeros(rows(x),4);
i = 1;
do until i > 4;
  {d[.,i],F} = regKernelDensity(x_min[.,i],x);
  i = i + 1;
endo;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _pcolor = 1|2|3|4; _plwidth = 10;
  xtics(0,250,50,2);
  _plegstr = "Exact\000Euler (k = 2)\000Euler (k = 0,5)";
  _plegctl = {2 5 6 4.5};
  graphprt("-c=1 -cf=mc5.eps");  
  xy(x,d[.,1 2 4]);