new;
library qam,pgraph,optmum;

a = 0.10; b = 0.03; sigma = 0.04;
pi_B = 0.01; D = 10;
pi_S = 0.05; sigma_S = 0.20; rho = 0.20;

tau = 10; 

declare matrix _allocation_target;

proc fit_gamma(theta);
  local gamma_,x_C,x_B,x_S,params,x,u ;

  gamma_ = sqrt(theta^2);

  {x_C,x_B,x_S,params} = Profile_Fund_Allocation(a,b,sigma,pi_B,D,pi_S,sigma_S,rho,tau,gamma_);

  if rows(_allocation_target) == 3;
    x = x_C | x_B | x_S;   
  else;
    x = (x_C + x_B) | x_S;
  endif;

  u = x - _allocation_target;

  retp( sumc(u^2) );
endp;

let target[4,3] =  0.00 1.00 0.00
                  -0.10 0.90 0.20
                  -0.10 0.60 0.50
                  -0.10 0.30 0.80;

sv = 1.0;
gamma_ = zeros(4,1);

i = 1;
do until i > 4;
  _allocation_target = Target[i,.]';
  {gamma_[i],fmin,grd,retcode} = optmum(&fit_gamma,sv);
  i = i + 1;
endo;

gamma_ = abs(gamma_);

cls;
{x_C,x_B,x_S,params} = Profile_Fund_Allocation(a,b,sigma,pi_B,D,pi_S,sigma_S,rho,tau,gamma_);

data = 100*(x_C~x_B~x_S)~gamma_;

print ftosa(data,"%lf",3,2);


  