new;
library qam,optmum,pgraph;

PathName = "..\\data\\";
datFileName = PathName $+ "qam_dataset1";

data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

Begin_Date = 19890101;
Last_Date = 20091231;
data = selif(data,data[.,1] .>= Begin_Date);

let selected_names = "US_GB_BA" "SPX_TR";

indx = indsav(selected_names,vnames);

Dates = Data[.,1];
nDates = rows(Dates);

Basket = Data[.,indx];
nBasket = cols(Basket);

dt = 260;
{cov,vol,cor} = Compute_Running_Covariance(Dates,Basket,dt,2);

Months = trunc(Dates/100);
RD_Monthly = Months ./= lag1(Months);
RD_Monthly[1] = 0;

Weights = 0.80~0.20;
Weights = zeros(nDates,nBasket) + Weights;

Weights1 = weights;

Weights = 0.50~0.50;
Weights = zeros(nDates,nBasket) + Weights;

Weights2 = weights;

Weights = 0.20~0.80;
Weights = zeros(nDates,nBasket) + Weights;

Weights3 = weights;

rc1 = zeros(nDates,nBasket);
rc2 = zeros(nDates,nBasket);
rc3 = zeros(nDates,nBasket);

t = 1;
do until t > nDates;

  cov_t = arraytomat(cov[t,.,.]);

  x = weights1[t,.]';
  {vol,mr,tr,rc} = Compute_Risk_Contribution(x,cov_t);
  rc1[t,.] = rc';

  x = weights2[t,.]';
  {vol,mr,tr,rc} = Compute_Risk_Contribution(x,cov_t);
  rc2[t,.] = rc';

  x = weights3[t,.]';
  {vol,mr,tr,rc} = Compute_Risk_Contribution(x,cov_t);
  rc3[t,.] = rc';
   
  t = t + 1;
endo;

RD_Montly = RD_Monthly .* (Dates .>= 19900101) .* (Dates .<= 20100101);

Monthly_Dates = selif(Dates,RD_Monthly);

rc1 = selif(rc1,RD_Monthly);
rc2 = selif(rc2,RD_Monthly);
rc3 = selif(rc3,RD_Monthly);

graphset;
  window3u;

    _pdate = ""; _pnum = 2; _pframe = 0; _pgrid = {3,0};
    _pltype = 1|6; _plwidth = 10; _pcolor = 1|4;
    _paxht = 0.25; _pnumht = 0.225; _ptitlht = 0.25;

    xtics(1,12*20,5*12,12);
    let xlab = "1990" "1995" "2000" "2005" "2010";
    asclabel(xlab,0);
    ytics(-20,120,20,2);

  setwind(1);
    title("\216Prudent");
    _plegstr = "Obligations\000Actions";
    _plegctl = {2 5 10 4};
    xy(0,100*rc1);

  _plegctl = 0;

  setwind(2);
    title("\216Equilibre");
    _pmsgstr = "-";
    _pmsgctl = 5.60~6.45~0.07~45~2~0~5 ;
    xy(0,100*rc2);

  setwind(3);
    title("\216Dynamique");
    _pmsgctl = 0;
    xy(0,100*rc3);

   graphprt("-c=1 -cf=bellman15.eps");

  endwind;

   