new;
library qam,pgraph,optmum;

PathName = "..\\Data\\";
FileName = PathName $+ "qam_hfrx";

data = loadd(FileName);
vnames = getname(FileName);

let selected_vnames = "SPX_TR" "HFRXGL" "HFRXEHD" "HFRXEMN" "HFRXMAC";
n = rows(selected_vnames);

Data = loadd(FileName);
vnames = getname(FileName);
Data = selif(Data, (Data[.,1] .>= 20030331) .and (Data[.,1] .<= 20091231));
nDates = rows(Data);
t = seqa(1,1,nDates);
Dates = Data[.,1];

indx = indcv(selected_vnames,vnames);
Data = Data[.,indx];

{indx_first,indx_last} = indn_nomiss(Data);

Data = 100*Data ./ subvec(Data',indx_first)';
Data = Fill_Miss(Data,3);

dt = 5;
Rdt = 100 * (Data./lagn(Data,dt) - 1);
c = ones(rows(Rdt),1);

Rdt = trimr(Rdt,5,0);
x = Rdt[.,1];
y = Rdt[.,2 3 4 5];

beta_mco = (y/x)';

proc (1) = regQ(y,x,alpha,w);
  local nAlpha,i,b,u,v;
  local beta;

  nAlpha = rows(alpha);
  beta = zeros(nAlpha,1);

  i = 1;
  do until i > nAlpha;
    {b,u,v} = regQuantile(y,x,alpha[i],1);
    beta[i] = b[2];
    i = i + 1;
  endo;

  retp(beta);
endp;  

alpha = seqa(0.01,1/100,99);
nAlpha = rows(alpha);

_reg_PrintIters = 0;

z = seqa(-5,10/100,101);
q = zeros(101,4);

Alpha = 0.50;
Beta_QR = zeros(4,1);

let h = 2.5 2.0 2.0 1.3;

i = 1;
do until i > 4;

  _regQuantile_h = h[i];
  b = regQ(y[.,i],x,Alpha,1);
  Beta_QR[i] = b;
  q[.,i] = regKernelQuantile(y[.,i],x,Alpha,2,z);

  i = i + 1;
endo;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pframe = 0; _pnum = 2; _pcross = 1;
  _pltype = 6|1|3|5; _paxht = 0.12; _ptitlht = 0.25; _plwidth = 10;
  _pcolor = 1|2|3|4; _pgrid = {3,1};
  _pnumht = 0.12;
  _plegstr = "HFRX\000HFRX EH\000HFRX EMN\000HFRX MACRO";
  _plegctl = {2 5 5.5 1.00};
  xtics(-5,5,1,2);
  ytics(-2,2,1,2);
  xlabel("\216Rendement S&P 500 (en %)");
  ylabel("\216\202b\201-rendement (en %)");
  graphprt("-c=1 -cf=lprog1.eps");
  xy(z,q[.,1:3]);