new;
library qam,optmum,pgraph;

cls;

__eps = 1e-10;

let mu =    0.05 0.09 0.07 0.06;
let sigma = 0.04 0.15 0.05 0.10;
let rho =   1.00 
            0.10  1.00
            0.40  0.20  1.00
           -0.10 -0.10 -0.20 1.00;
rho = xpnd(rho);
Cov = rho .* sigma .* sigma';

Bounds = 0~1;

let vol_target = 0.04;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,1,0,0,0,Bounds,vol_target,2);  

{vol,mr,tr,rc} = Compute_Risk_Contribution(x,cov);

data = 100*(x~mr~tr~rc);

TexFile = "nonlin10.tex";
mask = 1;
let fmt[4,3] = 
               "%lf" 6 2
               "%lf" 6 2
               "%lf" 6 2
               "%lf" 6 2;
call Tabular(TeXFile,data,mask,fmt,0,0,0,0,1);

data = {};

_sqp_PrintIters = 0;
__output = 0;
let Asset_Class = 1 2 3 4;
let Asset_Class_RC_Max = 1.0 1.0 0.6 1.0;
{x,vol,mr,tr,rc} = Risk_Budgeting_Solve(0,mu,cov,1,0,0,0,1,Asset_Class,Asset_Class_RC_Max,Vol_Target);
data = data ~ x ~ rc;

let Asset_Class[4,1] = 0
                       1
                       0
                       1;
let Asset_Class_RC_Max = -0.35;
{x,vol,mr,tr,rc} = Risk_Budgeting_Solve(x,mu,cov,1,0,0,0,1,Asset_Class,Asset_Class_RC_Max,Vol_Target);
data = data ~ x ~ rc;

let Asset_Class[4,2] = 1 0
                       1 0
                       0 1
                       0 0;
let Asset_Class_RC_Max = -0.35 0.5;
{x,vol,mr,tr,rc} = Risk_Budgeting_Solve(0,mu,cov,1,0,0,0,1,Asset_Class,Asset_Class_RC_Max,Vol_Target);
data = data ~ x ~ rc;

let fmt[6,3] = 
               "%lf" 6 2
               "%lf" 6 2
               "%lf" 6 2
               "%lf" 6 2
               "%lf" 6 2
               "%lf" 6 2;
call Tabular(TeXFile,100*data,mask,fmt,0,0,0,0,0);

{x,vol,mr,tr,rc} = Compute_ERC_Portfolio(0,cov);
data = 100*(x~mr~tr~rc);

let fmt[4,3] = 
               "%lf" 6 2
               "%lf" 6 2
               "%lf" 6 2
               "%lf" 6 2;
call Tabular(TeXFile,data,mask,fmt,0,0,0,0,0);

cls;
call text_print(TexFile);

