new;
library qam,pgraph,optmum;

proc (2) = Compute_BasketVolatility(n,sigma,rho);
  local vol,asymp;

  vol = sigma .* sqrt( (1+(n-1) .* rho)./n);
  asymp = sigma .* sqrt(rho);

  retp(vol,asymp);
endp;

n = seqa(1,1,5000);
sigma = 0.20;
rho = 0.90~0.50~0.25~0.00;
{vol,asymp} = Compute_BasketVolatility(n,sigma,rho);
asymp = asymp';

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pstype = 8|9|10|11; _plctrl = 6;
  _pcolor = 1|2|3|4;
  e = ones(4,1);
  _pline = e.*( 1~3~0)~100*asymp~e.*50~100*asymp~e.*(1~0~10);
  xtics(0,50,10,5);
  ytics(0,20,5,5);
  _pgrid = {2,1};
  xlabel("\216Nombre d'actifs");
  _plegstr = "\202r\201 = 90%\000\202r\201 = 50%\000\202r\201 = 25%\000\202r\201 = 0%";
  _plegctl = {2 6 6 2};
  graphprt("-c=1 -cf=nonlin11.eps");
  xy(n,100*vol);

