new;
library qam,pgraph,optmum;

cls;

__eps = 1e-10;

let mu =    0.05 0.09 0.07 0.06;
let sigma = 0.04 0.15 0.05 0.10;
let rho =   1.00 
            0.10  1.00
            0.40  0.20  1.00
           -0.10 -0.10 -0.20 1.00;
rho = xpnd(rho);
Sigma = rho .* sigma .* sigma';

let x_star = 0.10 0.20 0.50 0.20;
sh = 1.00;

tau = 1;

let P[2,4] = 1 0 0 0
             0 1 -1 0;
let Q =  0.05 0.05;
let Omega[2,2] = 0.05 0.0
                 0.0 0.10;
Omega = Omega^2;

tau = seqa(0,0.01,301);
nTau = rows(tau);
TE = zeros(nTau,1);

i = 1;
do until i > nTau;
  {x,phi,Pi_,mu_cond,TE[i]} = Black_Litterman_Solve(x_star,Sigma,sh,0,tau[i],P,Q,Omega,0);
  i = i + 1;
endo;

TE_ex_ante = 0.01;

proc (1) = f_tau(tau);
  local x,phi,Pi_,mu_cond,TE;
  {x,phi,Pi_,mu_cond,TE} = Black_Litterman_Solve(x_star,Sigma,sh,0,tau,P,Q,Omega,0);
  retp(TE - TE_ex_ante);
endp;

c = Bisection_Path(&f_tau,0,3);
nC = rows(c);
TE_c = zeros(nC,1);

i = 1;
do until i > nC;
  {x,phi,Pi_,mu_cond,TE_c[i]} = Black_Litterman_Solve(x_star,Sigma,sh,0,c[i],P,Q,Omega,0);
  i = i + 1;
endo;

{x_cs,cs} = graph_smooth(0,c,0.99,seqa(1,0.25,4*nC),0);

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(4,2.855,4.5,1,0);

 fonts("simplex simgrma");

 setwind(1);
    _pdate = ""; _pnum = 2; _pframe = 0;
    _pltype = 6; _pcolor = 1; _plwidth = 10; _pgrid = {3,1};
    xtics(0,3,0.5,2);
    ytics(0,2,0.25,2);
    let indx = 1 2 3 4 5 6 7;
    e = ones(rows(indx),1);
    _psym = c[indx]~100*TE_c[indx]~e.*(11~0~2~1~5);
    _pmsgstr = MakeMsgStr(ftocv(indx,1,0));
    _pmsgctl = c[indx]-0.05~100*TE_c[indx]+0.05~e.*(0.125~0~1~4~10);    
    xlabel("\216\202t\201");
    ylabel("\216\202c\201 (en %)");
    xy(tau,100*TE);

    _pmsgctl = 0;

  setwind(2); 
    _pgrid = 0; _pbox = 1; _paxht = 0.25; _pnumht = 0.22;
    _psym = 0;
    xtics(1,14,2,0);
    ytics(0,3,0.5,2);
    xlabel("\216Iteration");
    ylabel("\216\202t\201");
    _pline = 1~6~0~1~20~1~1~0~6;
    _pmsgstr = "-";
    _pmsgctl = 4.50~0.37~0.07~45~2~0~6;
    xy(x_cs,cs);

    graphprt("-c=1 -cf=nonlin22.eps");

  endwind;

tau_star = Bisection(&f_tau,0,3);
{x,phi,Pi_,mu_cond,TE} = Black_Litterman_Solve(x_star,Sigma,sh,0,tau_star,P,Q,Omega,0);
print x;