new;
library optmum,pgraph,qam;

PathName = "..\\Data\\";
FileName = PathName $+ "qam_CST";

Data = loadd(FileName);
vnames = "" $+ getname(FileName);

let string Selected_Names[25,1] = date_NAV CST_NAV CA_NAV SB_NAV EM_NAV EMN_NAV ED_NAV FI_NAV GM_NAV LS_NAV MF_NAV MS_NAV
                                  date_W   CST_W   CA_W   SB_W   EM_W   EMN_W   ED_W   FI_W   GM_W   LS_W   MF_W   MS_W
                                  Libor;

Date_NAV = Data[.,1];
Index_NAV = Data[.,2];
Data_NAV = Data[.,3:12];

Date_W = Data[.,13];
Index_W = Data[.,14];
Data_W = Data[.,15:24];

Libor = Data[.,25];

R = Data_NAV./lag1(Data_NAV) - 1.0;
R_Index = Index_NAV./lag1(Index_NAV) - 1.0;

Reference_Index = Index_NAV;
Basket = missrv(Data_NAV,0);
Dates = Date_NAV;
nDates = rows(Dates);

nBasket = cols(Basket);

Months = trunc(Dates/100);
RD_Monthly = Months ./= lag1(Months);
RD_Monthly[1] = 1;

pLag_cov = 2*12;

{cov,vol,cor} = Compute_Running_Covariance(Dates,Basket,pLag_cov,2);
vol = vol / sqrt(260) * sqrt(12);
cov = cov / 260 * 12;

pLag_er = 12;
er = (lagn(Basket,-plag_er)./Basket)^(12/plag_er) - 1.0;
er = rev(er);
er[1:pLag_er,.] = er[pLag_er+1,.] .* ones(pLag_er,1);
er = rev(er);

Weights_Bench = Data_W ./ sumr(data_W);
Weights_Bench[1,.] = Weights_Bench[2,.];

let Incertainty_Parameters = 0.05 0.05 0.005;
let TE_Targets             = 100  200  100;
TE_TOL = 1;

_sqp_PrintIters = 0;
x0 = ones(nBasket,1)/nBasket;

nIters = rows(TE_Targets);

F = zeros(nDates,nIters);

iter = 1;
do until iter > nIters;

  Incertainty_Parameter = Incertainty_Parameters[iter];
  TE_Target = TE_Targets[iter];

  Weights = ones(nDates,nBasket)/nBasket;

  t = 1;
  do until t > nDates;

    cov_t = arraytomat(cov[_max_(t-1,1),.,.]);
    er_t = er[_max_(t-1,1),.]';

    if RD_Monthly[t] == 0;

      x = Weights[t-1,.]';
      Weights[t,.] = x';

    else;

      x_Bench = Weights_Bench[t,.]';
      sh_t = 0.50; tau = 0.05; P = eye(nBasket); Q = er_t; Omega = eye(nBasket) .* Incertainty_Parameter; Omega = Omega^2;
      {Pi_,phi} = Black_Litterman_Pi(x_Bench,cov_t,sh_t,0,0);

    BL_step:
      Gamma_ = tau*cov_t;
      mu_cond = Black_Litterman_mu(Pi_,Gamma_,P,Q,Omega);
      {x,_er_,_vol_,_phi_,_retcode_} = Qprog_Allocation_Solve(mu_cond,cov_t,ones(1,nBasket),1,0,0,ones(nbasket,1) .* (0~1),phi,0);

      if ismiss(x);
        x = Weights[t-1,.]';
      endif;

      TE = 1e4 * sqrt((x-x_Bench)'*cov_t*(x-x_Bench));

      if (Tau > 1e4) or (Tau < 1e-4);
        goto BL_End;
      endif;

      if TE > (TE_Target + TE_TOL);
        tau = 0.8*tau;
        goto BL_step;
      elseif TE < (TE_Target - TE_TOL);
        tau = 1.20*tau;
        goto BL_step;
      endif;

    BL_end:
      Weights[t,.] = x';

    endif;

    t = t + 1;
  endo;

  NR_Index = 100*ones(nDates,1);
  F[.,iter] = Compute_Basket_With_TC(Dates,Weights,Basket,NR_Index,RD_Monthly,0,0);

  iter = iter + 1;
endo;

data = Dates~Reference_Index~F;
data = selif(Data,Data[.,1] .>= 19951231);
Dates = Data[.,1];
Data = Data[.,2:nIters+2];
Data = 100* Data ./ data[1,.];

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10|10|10|14; _pcolor = 1|4|2|3; _pltype = 6|3|1|5;
  ytics(100,700,100,2);
  xtics(0,15*12,12,1);
  let xlab = "96" "97" "98" "99" "00" "01" "02" "03" "04" "05" "06" "07" "08" "09" "10" "11";
  asclabel(xlab,0);  
  _plegstr = "Indice\000\202c\201 = 1%, \202\119\201 = 5%\000\202c\201 = 2%, \202\119\201 = 5%\000\202c\201 = 1%, \202\119\201 = 0,5%";
  _plegctl = {2 5 1.5 4.75};
  graphprt("-c=1 -cf=nonlin24.eps");
  xy(0,data);

