new;
library qam,pgraph,optmum;

cls;

let Q[3,3] = 1.0 0.5  0.5
             0.5 1.0  0.25
             0.5 0.25 1.00;
let R = 1 -1 2;
A = 0; B = 0; 
C = 0; D = 0; 
Bounds = (-1e200~1e200) .* ones(3,1);

sv = ones(3,1)/3;

{x,u1,u2,u3,u4,retcode} = Qprog(sv,Q,r,0,0,C,D,Bounds);
print " x = " x';
print "------------------------------------------------";

let C[1,3] = -1 -1 -1;
let D = 0;
{x,u1,u2,u3,u4,retcode} = Qprog(sv,Q,r,0,0,C,D,Bounds);
print "x = " x';
print "lambda = " u2';
print "------------------------------------------------";

let C[2,3] = -1 -1 -1
              0  1  0;
let D = 0 -2;
{x,u1,u2,u3,u4,retcode} = Qprog(sv,Q,r,0,0,C,D,Bounds);
print "x = " x';
print "lambda = " u2';
print "------------------------------------------------";

P = C*invpd(Q)*C';
T = D-C*invpd(Q)*R;
Bounds = (-1e200~1e200).*ones(2,1);
{x,u1,u2,u3,u4,retcode} = Qprog(1|1,P,T,0,0,0,0,Bounds);
print "lambda = " x';
print "------------------------------------------------";

let C[2,3] = -1 -1 -1
              0  1  0;
let D = 0 -2;
Bounds = (-1e200~1e200).*ones(3,1);
{x,u1,u2,u3,u4,retcode} = Qprog(sv,Q,r,0,0,C,D,Bounds);
print "x = " x';
print "lambda = " u2';
print "fn = " qpFn(x,Q,R);
print "------------------------------------------------";

Lambda = u2;

fn qpFn(x,Q,R) = 0.5*x'*Q*x-x'R;

let epsilon = 0.00 0.00;
eps = seqa(0,1/1000,201);
nEps = rows(eps);
F = zeros(nEps,2);
i = 1;
do until i > nEps;
  Epsilon[1] = Eps[i];
  {x,u1,u2,u3,u4,retcode} = Qprog(sv,Q,r,0,0,C,D - epsilon,Bounds);
  F[i,1] = qpFn(x,Q,R);
  F[i,2] = F[1,1] - epsilon'Lambda;
  i = i + 1;
endo;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  xlabel("\216\202e\201");
  _plegstr = "f\202\34\201x[*]\202\34e\118\118\201\000"\
             "f\202\34\201x[*]\202\34\2010\202\118\118\201+\202l\201[*]]1[\202e\201";
  _plegctl = {2 6 5 5};
  xtics(0,0.20,0.05,1);
  graphprt("-c=1 -cf=qprog1.eps");
  xy(Eps,F);




