new;
library qam,pgraph,optmum;

cls;

__eps = 1e-15;

let sigma = 0.04 0.04 0.05 0.05 0.06 0.06 0.10 0.10 0.15 0.15;
n = rows(sigma);
Bounds = -1.5~1.5;

let score[2,10] = -3 -2.5 -2.0 -1.5 -1.0 1.0 1.5 2.0 2.5 3.0
                  -3 3 -2.5 2.5 -2 2 -1 1 0 0;
A = ones(1,n); B = 0; 

let scalar_rho = 0.25 0.50 0.90 0.00;

let vol_target = 0.04;

x = zeros(10,8);
er = zeros(8,1);
risk = zeros(8,1);
phi = zeros(8,1);

i = 1;
do until i > 2;
  sc = score[i,.]';
  j = 1;
  do until j > 4;
    rho = ConstantCorrelation(scalar_rho[j],n);
    Cov = rho .* sigma .* sigma'; 
    {x[.,(i-1)*4+j],er[(i-1)*4+j],risk[(i-1)*4+j],phi[(i-1)*4+j],retcode} = Qprog_Allocation_Solve(sc,cov,A,B,0,0,Bounds,vol_target,2); 
    j = j + 1;
  endo;
  i = i + 1;
endo;

exposure = sumc(_max_(x,0));

data = 100*x|er'|exposure';

print data;

TexFile = "qprog11.tex";
mask = 1;
let fmt[12,3] = 
               "%lf" 6 1
               "%lf" 6 1
               "%lf" 6 1
               "%lf" 6 1
               "%lf" 6 1
               "%lf" 6 1
               "%lf" 6 1
               "%lf" 6 1
               "%lf" 6 1
               "%lf" 6 1
               "%lf" 6 3
               "%lf" 6 3;

call Tabular(TeXFile,data,mask,fmt,0,0,0,0,1);

cls;
call text_print(TexFile);


