new;
library qam,pgraph,optmum;

FileName = "qam_cac40";

factor = 100^2;
factor = 1;

PathName = "..\\data\\";
datFileName = PathName $+ FileName $+ "_num_data";
loadm num_data = ^datFileName;
index_cov_matrix = factor * vread(num_data,"cov");
index_weights = vread(num_data,"weights");

datFileName = PathName $+ FileName $+ "_str_data";
loads num_data = ^datFileName;
index_sedols = num_data[.,1];
index_names = num_data[.,2];

rndseed 123;
n = rows(index_Weights);
index_alpha = rndu(n,1) * 0.30;

declare matrix _vol_TE_Target;

let Bounds = 0.15;

proc vol_TE_Fn(phi);
  local x,vol_TE,Surperf;
  {x,vol_TE,Surperf} = Qprog_Index_Solve(index_weights,index_cov_matrix,0,0,0,0,0~Bounds,phi,index_alpha,0,0);
  retp(100*vol_TE-_vol_TE_Target);
endp;

let Vol_TE_Target = 0.20 0.50 1.00 5.00;
nRows = rows(Vol_TE_Target);
Surperf = zeros(nRows,1);
vol_TE = zeros(nRows,1);
x = zeros(n,nRows);
phi = zeros(nRows,1);

__eps = 1e-10;

i = 1;
do until i > nRows;
  _vol_TE_Target = vol_TE_Target[i];
  phi[i] = Bisection(&vol_TE_Fn,0,5);
  {x[.,i],vol_TE[i],Surperf[i]} = Qprog_Index_Solve(index_weights,index_cov_matrix,0,0,0,0,0~Bounds,phi[i],index_alpha,0,0);
  i = i + 1;
endo;

mv = error(0)~error(0);
data = ftosa(mv~vol_TE',"%lf",3,2);
data = data $| ftosa(100 * miss((index_weights~index_alpha~x),0),"%lf",3,2);
data = data $| ftosa(100*((mv~phi') | (mv~Surperf')),"%lf",3,2);

str = "" $| index_Names $| "" $| "";

Results = str $~ data;
TexFile = "qprog20.tex";
call DeleteFile(TexFile);
call saTabular(Results,TexFile);

cls;
call text_print(TexFile);

