new;
library qam,pgraph,optmum;

PathName = "..\\data\\";
datFileName = PathName $+ "qam_cac40_num_data";
loadm num_data = ^datFileName;
index_cov_matrix = 100^2 * vread(num_data,"cov");
index_weights = vread(num_data,"weights");
index_alpha = vread(num_data,"alpha");

datFileName = PathName $+ "qam_cac40_str_data";
loads num_data = ^datFileName;
index_sedols = num_data[.,1];
index_names = num_data[.,2];

p = 2;

MaxSize = seqa(1,1,40);
nIters = rows(MaxSize);
x = zeros(rows(index_weights),nIters);
vol_TE = zeros(nIters,1);
size = zeros(nIters,1);
i = 1;
do until i > nIters;
  {x[.,i],vol_TE[i]} = Qprog_Index_Sampling(index_weights,index_cov_matrix,MaxSize[i],p);
  size[i] = sumc(x[.,i] ./= 0);
  i = i + 1;
endo;

loadm sampling_snp;
sampling_cac = size~vol_TE;

sampling_snp[.,1] = sampling_snp[.,1]/500;
sampling_cac[.,1] = sampling_cac[.,1]/40;

ratio = 0.002|0.01|seqa(0.025,0.0125,80);
vol_te1 = fspline(csspline(sampling_snp[.,1],sampling_snp[.,2],1,1),ratio);
vol_te2 = fspline(csspline(sampling_cac[.,1],sampling_cac[.,2],1,0.999),ratio);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pltype = 6|1; _pgrid = {3,0}; _pcolor = 1|4;
  xlabel("\216Ratio n'/n (en %)");
  ylabel("\216Volatilite de la TE (en %)");
  xtics(0,100,10,5);
  ytics(0,10,2,5);
  _plegstr = "S&P 500\000CAC 40";
  _plegctl = {2 5 5 4};
  _pmsgstr = "-";
  _pmsgctl = 0.18~3.23~0.07~-45~2~0~5 ;
  graphprt("-c=1 -cf=qprog24.eps");
  xy(100*ratio,vol_te1~vol_te2);

orders = rev(sortind(sumr(x ./= 0)));
print num_data[orders,2];
