new;
library qam,pgraph,optmum;

cls;

PathName = "..\\data\\";
datFileName = PathName $+ "qam_cac40_num_data";
loadm num_data = ^datFileName;
cov_matrix = vread(num_data,"cov");
index_weights = vread(num_data,"weights");

datFileName = PathName $+ "qam_cac40_str_data";
loads num_data = ^datFileName;
index_sedols = num_data[.,1];
index_names = num_data[.,2];

rndseed 123;
n = rows(index_Weights);
index_alpha = rndu(n,1) * 0.30;

MinSize = 50;  // Minimum size of stocks in the portfolio
p = 0.01;      // Weight % triming at each iteration 

let TE = 0.03 0.04 0.04 0.06;     
let sl = 0.10 0.10 0.30 0.30;    
nIters = rows(TE);

x = zeros(n,nIters);
Leverage = zeros(nIters,1);
Beta = zeros(nIters,1);
Info = zeros(7,nIters);

iter = 1;
do until iter > nIters;
  {x[.,iter],weight_in,Leverage[iter],Beta[iter],info[.,iter]} = Qprog_Index_130_30(index_weights,cov_matrix,TE[iter],MinSize,p,index_alpha,0,sl[iter]);
  iter = iter + 1;
endo;
Surperf = sumc(x .* index_alpha) - sumc(index_weights .* index_alpha);

mv = error(0)~error(0);
data = ftosa(mv~TE',"%lf",3,2);
data = data $| ftosa(mv~sl',"%lf",3,2);
data = data $| ftosa(100 * miss((index_weights~index_alpha~x),0),"%lf",3,2);

data = data $| ftosa(mv~info[6,.],"%lf",3,2);
data = data $| ftosa(mv~info[7,.],"%lf",3,2);


str = "" $| "" $| index_Names  $| ""  $| "";

Results = str $~ data;
TexFile = "qprog25.tex";
call DeleteFile(TexFile);
call saTabular(Results,TexFile);

cls;
call text_print(TexFile);