new;
library qam,pgraph,optmum;

cls;

declare matrix indx_LS,indx_VG,indx_LVG,indx_SVG,indx_4F;

PathName = "..\\data\\";
datFilename = PathName $+ "qam_Funds";

data = loadd(datFileName);
vnames = getname(datFileName);

frq = 52;
p = 0.90;

dates = data[.,1];
nDates = rows(dates);
data = data[.,1:cols(data)];

R_data = data./lag1(data) - 1;
R_Fund = R_Data[.,3];
let selected_factors = "L" "S" "V" "G" "LV" "LG" "SV" "SG";
indx_Factors = indcv(selected_Factors,vnames);
R_Factors = R_Data[.,indx_Factors];
nFactors = cols(R_Factors);
Factor_Names = vnames[indx_Factors];

// Year 2009
indx_t = selif(seqa(1,1,nDates),(Dates .>= 20090101) .and (Dates .<= 20091231));

let selected_names[4,5] = "L" "V" "LV" "SV" "LV" 
                          "S" "G" "LG" "SG" "LG" 
                          .   .   .    .    "SV" 
                          .   .   .    .    "SG";
let string model_names[5,1] = "LS" "VG" "LVG" "SVG" "4F";
nC = cols(selected_names);
w = miss(zeros(nfactors,nC),0);
R2 = zeros(nC,1);

i = 1;
do until i > nC;
  indx_Factors = indcv(packr(selected_names[.,i]),Factor_Names);
  call varput(indx_Factors,"indx_" $+ model_names[i]);
  {w[indx_Factors,i],u,R2[i]} = regSharpeStyle(R_Fund[indx_t],R_Factors[indx_t,indx_Factors]);
  i = i + 1;
endo;

{w_OLS,stderr,Mcov,u} = regOLS(R_Fund[indx_t],R_Factors[indx_t,indx_Factors],0,0);
R2_OLS = vread(_reg_stats,"R2");

print $Factor_Names';
print ftosa(100*w'~100*R2,"%lf",3,1);
print ftosa(100*(miss(zeros(1,4),0)~w_OLS')~100*R2_OLS,"%lf",3,1);

{w_LS,R2_LS} = rollingSharpeStyle(R_Fund,R_Factors[.,indx_LS],frq,p);
{w_VG,R2_VG} = rollingSharpeStyle(R_Fund,R_Factors[.,indx_VG],frq,p);
{w_LVG,R2_LVG} = rollingSharpeStyle(R_Fund,R_Factors[.,indx_LVG],frq,p);
{w_SVG,R2_SVG} = rollingSharpeStyle(R_Fund,R_Factors[.,indx_SVG],frq,p);
{w_4F,R2_4F} = rollingSharpeStyle(R_Fund,R_Factors[.,indx_4F],frq,p);

e = ones(nDates,1);

graphset;
  window(2,2,1);

  _pdate = 0; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1|2|4;
  _paxht = 0.22; _pnumht = 0.22; _ptitlht = 0.25;

  ytics(0,100,20,2);
  xtics(0,52.5*10,52.5*2,1);
  let xlab = "2000" "02" "04" "06" "08" "10";
  asclabel(xlab,0);

  setwind(1);   
    title("\216Large / Smid");
    _pline = e.*(1~2)~seqa(1,1,nDates)~100*e~seqa(1,1,nDates)~100*w_LS[.,1]~e.*(1~3~5) |
             e.*(1~2)~seqa(1,1,nDates)~0*e~seqa(1,1,nDates)~100*w_LS[.,1]~e.*(1~4~5) ;
    _pline = 0;
    _pcolor = 1;
    _pmsgstr = "Large\000Smid";
    _pmsgctl = 52.5*4.0~20~0.30~0~1~1~8 |
               52.5*7.0~80~0.30~0~1~0~8 ;
    xy(seqa(1,1,nDates),100*W_LS[.,1]);

  setwind(2);
    title("\216Value / Growth");
    _pline = e.*(1~2)~seqa(1,1,nDates)~100*e~seqa(1,1,nDates)~100*w_VG[.,1]~e.*(1~1~5) |
             e.*(1~2)~seqa(1,1,nDates)~0*e~seqa(1,1,nDates)~100*w_VG[.,1]~e.*(1~2~5) ;
    _pline = 0;
    _pcolor = 2;
    _pmsgstr = "Value\000Growth";
    _pmsgctl = 52.5*2.0~20~0.30~0~1~2~8 |
               52.5*5.5~70~0.30~0~1~0~8 ;
    xy(seqa(1,1,nDates),100*W_VG[.,1]);

  setwind(3);
    title("\216Large Value / Growth");
    _pline = e.*(1~2)~seqa(1,1,nDates)~100*e~seqa(1,1,nDates)~100*w_LVG[.,1]~e.*(1~3~5) |
             e.*(1~2)~seqa(1,1,nDates)~0*e~seqa(1,1,nDates)~100*w_LVG[.,1]~e.*(1~4~5) ;
    _pline = 0;
    _pcolor = 4;
    _pmsgstr = "Value\000Growth";
    _pmsgctl = 52.5*2.0~20~0.30~0~1~4~8 |
               52.5*5.5~70~0.30~0~1~0~8 ;
    xy(seqa(1,1,nDates),100*W_LVG[.,1]);

    _pline = 0;
    _pcolor = 1|2|4;
    _pmsgctl = 0;
    _pltype = 6|1|3;
    
  setwind(4);
    title("\216R[2]");
    ytics(0,100,20,2);
    _plegstr = "Large / Smid\000Value / Growth\000Large Value / Growth";
    _plegctl = {2 5 3.5 1};
    xy(0,100*(R2_LS~R2_VG~R2_4F));

    graphprt("-c=1 -cf=qprog3.eps");

  endwind;


proc (2) = rollingSharpeStyle(R_fund,R_Style,frq,p);
  local nDates,nFactors,weights,R2,t,y,x,w,u;

  nDates = rows(R_Fund);
  nFactors = cols(R_Style);

  weights = miss(zeros(nDates,nFactors),0);
  R2 = miss(zeros(nDates,1),0);

  t = frq + 1;
  do until t > nDates;
    {y,x} = packr2(R_fund[t-frq:t],R_Style[t-frq:t,.]);

    if rows(x) > p * frq;
      {w,u,R2[t]} = regSharpeStyle(y,x);                    
      weights[t,.] = w';
    endif;
    t = t + 1;
  endo;

  R2 = missex(R2, R2 .< 0);

  retp(weights,R2);
endp;

