new;
library qam,optmum,pgraph;

cls;

__eps = 1e-10;

let sigma  = 5.00	1.00	5.00	2.50	5.00	7.50	10.00;
let mu     = 5.00	1.00	5.00	2.50	5.00	7.50	10.00;

sharpe = mu ./ sigma;

mu = mu / 100;
sigma = sigma / 100;

n = rows(mu);
rho = diagrv(0.25*ones(n,n),1.0);

cov = sigma .* sigma' .* rho;

Target_Vol = 2/100;
Target_Method = 2;
Bounds = ones(n,1) .* (0~1);

_Allocation_bounds = 1;
{x0,er0,vol0,phi0,retcode0} = Qprog_Allocation_Solve(mu,cov,1,0,0,0,1,Target_Vol,Target_Method);

Target_Vol = 4/100;
Target_Method = 2;
TC_p = 100e-4;
TC_m = 200e-4;

_Allocation_bounds = 1;
{x1,er1,vol1,phi1,retcode1} = Qprog_Allocation_Solve(mu,cov,1,0,0,0,1,Target_Vol,Target_Method);

d1 = x1 - x0;
TC1 = _max_(d1 .* TC_p,0) - _min_(d1 .* TC_m,0);

_Allocation_bounds = 1;
{x2,x2_m,x2_p,er2,vol2,phi2,retcode2} = Qprog_Allocation_Solve_With_TC(mu,cov,1,0,0,0,1,Target_Vol,Target_Method,x0,TC_m,TC_p);

d2 = -x2_m + x2_p;
TC2 = _max_(d2 .* TC_p,0) - _min_(d2 .* TC_m,0);

err = error(0);
Table = 100*(mu~sigma~x0~x1~x2) |
        100*(err~err~er0~er1~er2) |
        100*(err~err~vol0~vol1~vol2) |
        100*(err~err~err~sumc(TC1)~sumc(TC2));
Results = ftosa(Table,"%lf",3,2);
TexFile = "qprog31.tex";
call DeleteFile(TexFile);
call saTabular(Results,TexFile);

cls;
call text_print(TexFile);
