new;
library qam,optmum,pgraph;

cls;

proc (3) = square(n,dx,dz);
  local r,x,y,z;

  r = 2*n;
  z = ones(r,r);
  x = seqa(1,dx,r/2);
  x = -rev(x)|x;
  y = x;

  z = dz * _max_(abs(z .* x), abs(z .* y'));

  retp(x,y',z);
endp;

n = 4;
{x,y,z} = square(n,1,-2);
z = 2*n + z;

m = 10*2*n+1;
xs = seqa(-n,2*n/(m-1),m);
ys = xs';

z1 = BiLinear_Interpolation(x,y,z,xs,ys);

_Quadratic_Interpolation_Mtd = 1;
z2 = Quadratic_Interpolation(x,y,z,xs,ys);

_Quadratic_Interpolation_Mtd = 0;
z3 = Quadratic_Interpolation(x,y,z,xs,ys);

_Quadratic_Interpolation_Mtd = -1;
z4 = Quadratic_Interpolation(x,y,z,xs,ys);

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");

  _pdate = ""; _pframe = 0; _pnum = 2;
  _pnumht = 0.20; _paxht = 0.20; _ptitlht = 0.25;
  xlabel("\216x");
  ylabel("\216y");
  zlabel("\216z");
  xtics(-4,4,2,2);
  ytics(-4,4,2,2);
  ztics(0,7,1,2);

  _pzclr = {0 1,
            1 2,
            2 3,
            3 4,
            4 5,
            5 6,
            6 7,
            7 8,
            8 9};

  setwind(1);
    title("\216Interpolation bilineaire");
    _pmsgstr = "-";
    _pmsgctl = 6.27~6.31~0.07~45~2~0~6;
    surface(xs',ys',fill_miss(z1,1)');

    _pmsgctl = 0;

  setwind(2);
    title("\216Interpolation quadratique");
    surface(xs',ys',fill_miss(z2,1)');

  setwind(3);
    title("\216Interpolation lineaire generalisee");
    _pmsgstr = "-\000-\000-\000-";
    _pmsgctl = 4.95~6.31~0.07~45~2~0~6 |
               6.27~6.31~0.07~45~2~0~6 |
               6.71~6.31~0.07~45~2~0~6 |
               7.70~6.31~0.07~45~2~0~6;
    surface(xs',ys',fill_miss(z3,3)');

    _pmsgctl = 0;

  setwind(4);
    title("\216Interpolation MLQ\L\216\202w\201 = 1");
    surface(xs',ys',fill_miss(z4,1)');

    graphprt("-c=1 -cf=qprog42.eps");

  endwind;
