new;
library qam,pgraph,optmum;

cls;

PathName = "..\\Data\\";
datFileName = PathName $+ "qam_dataset2";
data = loadd(datFileName);
vnames = getname(datFileName);
Dates = data[.,1];

let selected_names = "S&P" "STXX" "TPX" 
                     "EM_EU" "EM_ASIA" "EM_LAT" 
                     "US_HY" "EMBI" "US_IG" "EUR_IG" 
                     "RICI"
                     "MSCI_W" "BarCap" "Euribor";
let Asset_Classes  = 1 1 1 
                     2 2 2                      
                     3 3 3 3
                     4;

indx = indcv(selected_names,vnames);
Data = Data[.,indx];
Data = dates~Data;

Begin_Date = 19931231;
Last_Date = 20091231;

Data = selif(data,(Data[.,1] .>= Begin_Date) .and (Data[.,1] .<= Last_Date));

Dates = data[.,1]; 
nDates = rows(Dates);

Data = Data[.,2:cols(Data)];
BenchMark = Data[.,2 cols(Data)-2:cols(Data)];
Euribor = BenchMark[.,4];
Basket = Data[.,1:cols(Data)-3];
nBasket = cols(Basket);

{cov,vol,cor} = Compute_Running_Covariance(Dates,Basket,260,2);
Weights = zeros(nDates,nBasket);

A = ones(1,nBasket);
B = 1;
C = -design(Asset_Classes)';
C[1,.] = C[1,.] + C[2,.];
D = -(1.00|0.20|0.50|0.20);
Bounds = (0.00~0.20) .* ones(nBasket,1);

t = 1;
do until t > nDates;
  cov_t = arraytomat(cov[t,.,.]);
  {x,sigma,retcode} = Qprog_Min_Variance(cov_t,A,B,C,D,Bounds);
  Weights[t,.] = x';
  t = t + 1;
endo;

Backtest = Compute_Monthly_Backtest(Dates,Weights,Basket);
Data = Dates ~ Backtest ~ BenchMark[.,1] ~ Euribor;
Begin_Date = 19941231;
Last_Date = 20091231;
Data = selif(Data,(Data[.,1] .>= Begin_Date) .and (Data[.,1] .<= Last_Date));
Dates = Data[.,1];
nDates = rows(Dates);
Data = Data[.,2:4];
Data = Data ./ Data[1,.] * 100;
Vol = Compute_Running_Statistics(Dates,Data,260,2);

graphset;
  begwind;
  makewind(9,6.855,0,0,0);
  makewind(3.5,2.2,1,4.7,1);

  setwind(1);
    _pdate = ""; _pnum = 2; _pframe = 0;
    _pltype = 6|3|1; _pcolor = 1|4|3; _plwidth = 10;
    xtics(1,nDates,261,2);
    let xlab = "95" "96" "97" "98" "99" "00" "01" "02" "03" "04" "05" "06" "07" "08" "09" "10";
    asclabel(xlab,0);
    ytics(50,450,50,2);
    _plegstr = "Variance minimale\000STOXX 600\000Euribor";
    _plegctl = {2 4 6 0.7};
    xy(0,Data);

  setwind(2);
    title("\216Volatilite annuelle");
    ytics(0,40,10,2);
    _plegctl = 0; _pnumht = 0.30; _pgrid = {3,0}; _ptitlht = 0.30;
    xtics(1,nDates,261*5,2);
    let xlab = "95" "00" "05" "10";
    asclabel(xlab,0);
    _pmsgstr = "-";
    _pmsgctl = 4.6~6.35~0.10~45~2~0~5;
    xy(0,100*Vol[.,1 2]);

    graphprt("-c=1 -cf=qprog5.eps");

  endwind;

Rdt = Data ./ lag1(Data) - 1.0;
Rdt = packr(Rdt);
vol = stdc(Rdt)* sqrt(260);
ratio = vol[1]/vol[2];
print ftosa(100*ratio,"Volatility ratio = %lf",3,2);