new;
library qam,optmum,pgraph;

let mu =    0.05 0.09 0.07 0.06;
let sigma = 0.04 0.15 0.05 0.10;
let rho =   1.00 
            0.10  1.00
            0.40  0.20  1.00
           -0.10 -0.10 -0.20 1.00;
rho = xpnd(rho);
Cov = rho .* sigma .* sigma';

Bounds = 0~1;

phi = seqa(-1,0.0025,1500);
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,1,0,0,0,Bounds,phi,0); 

rf1 = 0.03;
{x1,mu1,sigma1,sharpe1,phi1} = Qprog_Sharpe_Maximize(mu,cov,1,0,0,0,Bounds,rf1,0,0.001);  

sigma2 = 0.06;
mu2 = rf1 + sharpe1 * sigma2;

rf1 = 100*rf1;
mu1 = 100*mu1;
sigma1 = 100*sigma1;
Risk = 100*Risk;
ER = 100*ER;
mu2 = 100*mu2;
sigma2 = 100*sigma2;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1;
  xtics(0,6,1,2);
  ytics(2,8,1,2);
  xlabel("\216Volatilite (en %)");
  ylabel("\216Rendement espere (en %)");
  _psym = 0~rf1~11~4~4~1~10 |
          sigma1~mu1~11~4~4~1~10 |
          sigma1~rf1~11~4~4~1~10 ;
  _pline = 1~3~0~rf1~sigma2~mu2~1~4~10 |
           1~3~sigma1~rf1~sigma1~mu1~1~4~10 |
           1~3~0~rf1~sigma1~rf1~1~4~10 |
           4~3~0~rf1~2~0~0.64~4~10 |
           4~3~0~rf1~1.95~0~0.64~4~10 ;
  _pmsgstr = "B\000A\000C\000\202a\201";
  _pmsgctl = 0.10~rf1-0.35~0.20~0~1~4~10 |
               sigma1+0.125~mu1-0.20~0.20~0~1~4~10 |
               sigma1+0.125~rf1-0.25~0.20~0~1~4~10 |
               2.0~3.5+0.25~0.20~0~1~4~10 ;  
  _pmsgstr = _pmsgstr $+ "\000-\000-\000-";
  _pmsgctl = _pmsgctl |
             4.75~0.31~0.07~45~2~0~5 |
             0.18~4.12~0.07~-45~2~0~5 |
             0.18~4.36~0.07~-45~2~0~5 ;
  graphprt("-c=1 -cf=qprog8.eps");
  xy(Risk,ER);

