new;
library qam,optmum,pgraph;

let mu =    0.05 0.09 0.07 0.06;
let sigma = 0.04 0.15 0.05 0.10;
let rho =   1.00 
            0.10  1.00
            0.40  0.20  1.00
           -0.10 -0.10 -0.20 1.00;
rho = xpnd(rho);
Cov = rho .* sigma .* sigma';

Bounds = 0~1;

phi = seqa(-1,0.0025,1500);
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,1,0,0,0,Bounds,phi,0); 

rf1 = 0.03;
{x1,mu1,sigma1,sharpe1,phi1} = Qprog_Sharpe_Maximize(mu,cov,1,0,0,0,Bounds,rf1,0,0.001);  

rf1 = 100*rf1;
mu1 = 100*mu1;
sigma1 = 100*sigma1;
Risk = 100*Risk;
ER = 100*ER;

rf = 1~3~6;
Sharpe = (er-rf)./ risk;

graphset;
  window3d;

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|2|4;
  _paxht = 0.20; _pnumht = 0.25;

  ylabel("\216Ratio de Sharpe");
  ytics(-0.3,1.8,0.3,2);

  setwind(1);
    xtics(0,15,5,2);
    xlabel("\216Volatilite (en %)");
    _pmsgstr = "-";
    _pmsgctl = 5.10~0.33~0.07~45~2~0~5 ;
    xy(risk,Sharpe);

  setwind(2);
    xtics(5,9,1,2);
    xlabel("\216Rendement espere (en %)");
    _pmsgstr = "-\000-";
    _pmsgctl = 5.62~0.33~0.07~45~2~0~5 |
               5.92~0.33~0.07~45~2~0~5 ;
    xy(er,Sharpe);

  _pmsgctl = 0;

  setwind(3);
    xtics(-1,3,1,2);
    xlabel("\216\202F\201");
    _plegstr = "r = 1%\000r = 3%\000r = 6%";
    _plegctl = {2 6.25 10 3};
    xy(phi,Sharpe);

  graphprt("-c=1 -cf=qprog9.eps");

  endwind;
