new;
library qam,pgraph,optmum;

TT = 50/250;
tau = seqa(TT,-5/250,11);
t = TT-tau;
nT = rows(t);

r = 0.05; b = 0.05;
sigma = 0.20;
K = 100;
mu = 0.10;
S0 = 100;

nS = 3;

rndseed 123;
St = simulate_GBM(S0,mu,sigma,t,nS);

C0 = EuropeanBS(S0,K,sigma,TT,b,r);
Ct = EuropeanBS(St,K,sigma,tau,b,r);
PnL = C0 - Ct;
Data = zeros(nT,nS*2+1);
Data[.,1] = t;
indx = seqa(2,2,nS);
Data[.,indx] = St;
Data[.,indx+1] = PnL;

print Data;

TexFile = "ap-option10.tex";
mask = 1;
let fmt[7,3] = "%lf" 6 2
               "%lf" 6 3
               "%lf" 6 2
               "%lf" 6 3
               "%lf" 6 2
               "%lf" 6 3
               "%lf" 6 2;
let string colNames = "$t$" "$S\\left(t \\right)$" "$PnL\\left(t\\right)$" "$S\\left(t \\right)$" "$PnL\\left(t\\right)$"  "$S\\left(t \\right)$" "$PnL\\left(t\\right)$" ; 
Tabular(TeXFile,data,mask,fmt,0,colNames,0,0,1);

newSigma = sigma + (-cumsumc(rndu(nt,1)*0.03)~sqrt(t)~rndn(nt,1)*0.03);
newSigma[1,.] = Sigma*ones(1,3);

C0 = EuropeanBS(S0,K,sigma,TT,b,r);
Ct = EuropeanBS(St,K,newSigma,tau,b,r);
PnL = C0 - Ct;
Data[.,indx] = newSigma;
Data[.,indx+1] = PnL;

print Data;

let string colNames = "$t$" "$\\Sigma\\left(t \\right)$" "$PnL\\left(t\\right)$" 
                      "$\\Sigma\\left(t \\right)$" "$PnL\\left(t\\right)$"  "$\\Sigma\\left(t \\right)$" "$PnL\\left(t\\right)$" ; 

Tabular(TeXFile,data,mask,fmt,0,colNames,0,0,0);

cls;
call text_print(TexFile);





