new;
library qam,pgraph,optmum,option;

cls;

// fn sumr(x) = sumc(x');

Notional = 100;
S0 = 98; mu = 0.10; sigma = 0.20;
tau = 130/260;
r = 0.05;
b = r;
K = 100;
C0 = EuropeanBS(S0,K,sigma,tau,r,r);

Ns = 20000;

sigma = 0.20;

fn Premium_Proc(t,St,rt) = EuropeanBS(St,K,sigma,tau-t,rt,rt);
fn Delta_Proc(t,St,rt) = EuropeanBS_Delta(St,K,sigma,tau-t,rt,rt);

let dt = 1;
PnL_Ratio = zeros(Ns,3);
t = seqa(0,dt/260,130/dt+1);

St = Simulate_GBM(S0,mu,sigma,t,Ns);
{Dynamic_Hedging,PnL,PnL_Option,PnL_Hedging,Results} = Compute_Dynamic_Delta_Hedging(Notional,C0,&Premium_Proc,&Delta_Proc,t,St,r,0);
PnL_Ratio[.,1] = PnL' / (Notional * C0);

sigma = 0.25;
St = Simulate_GBM(S0,mu,sigma,t,Ns);
{Dynamic_Hedging,PnL,PnL_Option,PnL_Hedging,Results} = Compute_Dynamic_Delta_Hedging(Notional,C0,&Premium_Proc,&Delta_Proc,t,St,r,0);
PnL_Ratio[.,2] = PnL' / (Notional * C0);

sigma = 0.15;
St = Simulate_GBM(S0,mu,sigma,t,Ns);
{Dynamic_Hedging,PnL,PnL_Option,PnL_Hedging,Results} = Compute_Dynamic_Delta_Hedging(Notional,C0,&Premium_Proc,&Delta_Proc,t,St,r,0);
PnL_Ratio[.,3] = PnL' / (Notional * C0);

x = seqa(-1.00,2.00/500,501);
d = zeros(rows(x),cols(PnL_Ratio));
i = 1;
do until i > cols(d);
  {d[.,i],F} = regKernelDensity(PnL_Ratio[.,i],x);
  i = i + 1;
endo;

d = missex(d, d .<= 1e-5);
  
graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|2|3; 
  xtics(-60,60,20,2);
  ytics(0,8,1,2);
  xlabel("\216Ratio \202p\201 (en %)");
  _plegstr = "\202s\201 = 20%\000\202s\201 = 25%\000\202s\201 = 15%";
  _plegctl = {2 5 1.5 5};
  graphprt("-c=1 -cf=ap-option14.eps");
  xy(100*x,d);

Pr = zeros(3,1);
{tmp,Pr[1]} = regKernelDensity(PnL_Ratio[.,1],0.0);
{tmp,Pr[2]} = regKernelDensity(PnL_Ratio[.,2],0.0);
{tmp,Pr[3]} = regKernelDensity(PnL_Ratio[.,3],0.0);

print ftosa(100*Pr,"%lf",3,2);