new;
library qam,pgraph,optmum;

cls;

rndseed 1;
Notional = 100;

K = 100; r = 0.05; b = r;

S0 = 98;
mu = 0.05; sigma = 0.20;
tau = 20/52;
t = seqa(0,1,21)/52;
Ns = 1;
St = Simulate_GBM(S0,mu,sigma,t,Ns);

Premium = EuropeanBS(S0,K,sigma,tau,b,r);

format /sa 10,8;

fn Premium_Proc(t,St,rt) = EuropeanBS(St,K,sigma,tau-t,rt,rt);
fn Delta_Proc(t,St,rt) = EuropeanBS_Delta(St,K,sigma,tau-t,rt,rt);

{Dynamic_Hedging,PnL,PnL_Option,PnL_Hedging,Results} = Compute_Dynamic_Delta_Hedging(Notional,Premium,&Premium_Proc,&Delta_Proc,t,St,r,1);
indx = seqa(1,1,cols(Results));
c = 5;
indx = setdif(indx,c,1);
Results = results[.,indx];

if c == 5;
  print "     Iter.    Maturity  Stock Price  Delta    Trading   Borrowing  Hedging     Premium    Option       PnL       PnL         PnL";
  print "                                     (in %)   Cost      Cost       Cost    Capitalized    Price       Option    Hedging       ";
  print "-------------------------------------------------------------------------------------------------------------------------------------------------";
else;
  print "     Iter.    Maturity  Stock Price  Delta    var. Delta  Trading   Borrowing  Hedging     Premium    Option       PnL       PnL         PnL";
  print "                                     (in %)   (in Shares) Cost      Cost       Cost    Capitalized    Price       Option    Hedging       ";
  print "-------------------------------------------------------------------------------------------------------------------------------------------------";
endif;

print ftosa(Results,"%*.*lf",3,2);
print;
print ftos(PnL_Option,"PnL Option = %lf",1,0);
print ftos(PnL_Hedging,"PnL Hedging = %lf",1,0);
print ftos(PnL,"PnL = %lf",1,0);
print (ftos(100*PnL/(Notional*Premium),"PnL Ratio = %lf",1,2) $+ " %");