new;
library qam,option,gWizard,pgraph;

cls;

S0 = 100;
K = 100;
sigma = 0.20;
tau = 1;
r = 0.05;
b = r;

nMax = 100;

C_CRR = zeros(nMax,1);
N = 1;
do until N > nMax;
  {C_CRR[N],tree} = EuropeanCRR(S0,K,sigma,tau,b,r,N);
  N = N + 1;
endo;

BS = EuropeanBS(S0,K,sigma,tau,b,r);

N = 20;

{C,tree} = EuropeanCRR(S0,K,sigma,tau,b,r,N);
tree_S = vread(tree,"S");
Tree_CallPut = vread(tree,"callput");

print "Tree of the underlying asset price";
call PrintTree(Tree_S,0);
print "Tree of the option price";
call PrintTree(Tree_CallPut,0);
print ftos(C,"Option price = %lf",4,4);

diff = C_CRR-BS;
dt = 1;
{t,diff} = graph_smooth(0,diff,0.995,dt,0);

graphset;
  window3d;

  setwind(1);
    gBuffer = PlotTree(tree_S,4);
    call gWizardInfo(gBuffer);
    _paxht = 0.225; _pnumht = 0.20; _ptitlht = 0.275; _pframe = 0;
    gWizardSet(gBuffer,1);
    _psym[.,4] = 4*ones(rows(_psym),1);
    _psym[.,5] = 1*ones(rows(_psym),1);
    _pline[.,8] = 1*ones(rows(_pline),1);
    xtics(0,22,2,2);
    ytics(0,250,50,2);
    title("\216Arbre du sous-jacent");
    xlabel("\216j");
    ylabel("\216S(t)");
    gWizardDraw(gBuffer,1);

  setwind(2);
    gBuffer = PlotTree(Tree_CallPut,4);
    call gWizardInfo(gBuffer);
    _paxht = 0.225; _pnumht = 0.20; _ptitlht = 0.275; _pframe = 0;
    gWizardSet(gBuffer,1);
    _psym[.,4] = 4*ones(rows(_psym),1);
    _psym[.,5] = 4*ones(rows(_psym),1);
    _pline[.,8] = 4*ones(rows(_pline),1);
    xtics(0,22,2,2);
    ytics(0,150,25,2);
    title("\216Arbre de l'option");
    xlabel("\216j");
    ylabel("\216C(t)");
    gWizardDraw(gBuffer,1);

  _psym = 0; _pline = 0;

  setwind(3);
    _pdate = ""; _pnum = 2; _pframe = 0;
    _pltype = 6; _plwidth = 10; _pcolor = 2;
    xlabel("\216N"); _pcross = 0;
    ytics(-2,2,1,2);
    title("\216Convergence de C]CRR[(T) vers C]BS[(T)");
    ylabel("\216C]CRR[(T) - C]BS[(T)");
    xtics(0,60,10,2);
    xy(0,diff);

    graphprt("-c=1 -cf=ap-option20.eps");

  endwind;