new;
library qam,pgraph,optmum;

cls;

Notional = 100000;
let S0 = 49  48    47    50    51    53    53   51    51    53  49    48    49    50    52    51    52    54    54    55    57;
digits = 0 | 1/8 | 3/8 | 1/4 | 3/4 | 1/8 | 0  | 7/8 | 3/8 | 0 | 7/8 | 1/2 | 7/8 | 3/8 | 1/8 | 7/8 | 7/8 | 7/8 | 5/8 | 7/8 | 1/4; 
S0 = S0 + digits;
K = 50;
r = 0.05;
b = r;
sigma = 0.20;
tau = seqa(20,-1,21)/52;
Week = seqa(0,1,21);

let delta = 0.522 0.458 0.400 0.596 0.693 0.774 0.771 0.706 0.674 0.787 0.550 0.413 0.542 0.591 0.768 0.759 0.865 0.978 0.990 1.000 1.000;
Premium = EuropeanBS(S0[1],K,sigma,tau[1],b,r);

USE_Hull_Delta = 1;

format /sa 10,8;

tmp1 = arrayinit(21|1|1,0);
tmp2 = arrayinit(21|1|1,0);
i = 1;
do until i > 21;
  tmp1[i,1,1] = S0[i];
  tmp2[i,1,1] = Delta[i];
  i = i + 1;
endo;

S0 = tmp1;
Delta = tmp2;

fn Premium_Proc(t,St,rt) = EuropeanBS(St,K,sigma,t,rt,rt);
if Use_Hull_Delta;
  Delta_Proc = Delta;
else;
  fn _Delta_Proc(t,St,rt) = EuropeanBS_Delta(St,K,sigma,t,rt,rt);
  Delta_Proc = &_Delta_Proc;
endif;

{Dynamic_Hedging,PnL,Net_Hedging_Cost,Mtm_Premium,Results} = Compute_Dynamic_Delta_Hedging2(Notional,Premium,&Premium_Proc,Delta_Proc,tau,S0,r,1);

print "     Iter.    Maturity  Stock Price  Delta    Delta      Trading   Hedging    Borrowing   Premium    Option     Option   Net Hedging    PnL";
print "                                     (in %)  (in Shares)  Value      Cost       Cost    Capitalized   Price       MtM       Cost           ";
print "-------------------------------------------------------------------------------------------------------------------------------------------------";
print ftosa(Results,"%lf",3,3);
print;
print ftos(Net_Hedging_Cost,"Net Hedging Cost = %lf",1,0);
print ftos(Mtm_Premium,"Mark-to-Market of the option = %lf",1,0);
print ftos(PnL,"Final PnL = %lf",1,0);
print (ftos(100*PnL/(Notional*Premium),"Final PnL Ratio = %lf",1,2) $+ " %");


