new;
library qam,optmum,pgraph;

datFileName = "..\\data\\qam_spx_daily_option";

Data = loadd(datFileName);
vnames = getname(datFileName);

let selected_names = "date" "SPX_TR" "LIBOR";
indx = indcv(selected_names,vnames);
data = data[.,indx];

data = selif(data, (data[.,1] .>= 19900101) .and (data[.,1] .<= 20091231));
nDates = rows(data);

Dates = Data[.,1];
SPX = Data[.,2];
SPX = 100 * SPX / SPX[1];
R_Libor = Data[.,3]/100;
dt = etdays2(lag1(dates),dates)/365;
Libor = 1 + lag1(R_Libor) .* dt;
Libor[1] = 1.0;
Libor = 100 * cumprodc(Libor);

sigma = 0.20;
sigma = Compute_Running_Statistics(Dates,SPX,60,2);
sigma = missrv(sigma,0.20);

p = 0.05; nLoss = 20; nGain = 20;
Loss = cdfni(1-p) .* sigma .* sqrt(nLoss./260);
Gain = cdfni(1-p) .* sigma .* sqrt(nGain./260);

{S,w1} = Simulate_StopLoss_strategy(SPX,Libor,nLoss,Loss,nGain,Gain);
indx_begin_stop = indexcat((w1 .== 0) .and (lag1(w1) .== 1),1);
indx_end_stop = indexcat((w1 .== 1) .and (lag1(w1) .== 0),1);
nStop = rows(indx_end_stop);
Smean = zeros(nStop,1);
i = 1;
do until i > nStop;
  Smean[i] = meanc(S[indx_begin_stop[i]:indx_end_stop[i]]);
  i = i + 1;
endo;
e = ones(nStop,1);
pline = e.*(1~6)~indx_begin_stop~Smean~indx_end_stop~Smean~e.*(1~0~10) |
        e.*(1~6)~indx_begin_stop~e*0~indx_begin_stop~Smean~e.*(1~0~5) |
        e.*(1~6)~indx_end_stop~e*0~indx_end_stop~Smean~e.*(1~0~5) ;

S1 = S;
pline1 = pline;

p = 0.20; nLoss = 20; nGain = 20;
Loss = cdfni(1-p) .* sigma .* sqrt(nLoss./260);
Gain = cdfni(1-p) .* sigma .* sqrt(nGain./260);

{S,w1} = Simulate_StopLoss_strategy(SPX,Libor,nLoss,Loss,nGain,Gain);
indx_begin_stop = indexcat((w1 .== 0) .and (lag1(w1) .== 1),1);
indx_end_stop = indexcat((w1 .== 1) .and (lag1(w1) .== 0),1);
nStop = rows(indx_end_stop);
Smean = zeros(nStop,1);
i = 1;
do until i > nStop;
  Smean[i] = meanc(S[indx_begin_stop[i]:indx_end_stop[i]]);
  i = i + 1;
endo;
e = ones(nStop,1);
pline = e.*(1~6)~indx_begin_stop~Smean~indx_end_stop~Smean~e.*(1~0~10) |
        e.*(1~6)~indx_begin_stop~e*0~indx_begin_stop~Smean~e.*(1~0~5) |
        e.*(1~6)~indx_end_stop~e*0~indx_end_stop~Smean~e.*(1~0~5) ;

S2 = S;
pline2 = pline;

p = 0.05; nLoss = 60; nGain = 60;
Loss = cdfni(1-p) .* sigma .* sqrt(nLoss./260);
Gain = cdfni(1-p) .* sigma .* sqrt(nGain./260);

{S,w1} = Simulate_StopLoss_strategy(SPX,Libor,nLoss,Loss,nGain,Gain);
indx_begin_stop = indexcat((w1 .== 0) .and (lag1(w1) .== 1),1);
indx_end_stop = indexcat((w1 .== 1) .and (lag1(w1) .== 0),1);
nStop = rows(indx_end_stop);
Smean = zeros(nStop,1);
i = 1;
do until i > nStop;
  Smean[i] = meanc(S[indx_begin_stop[i]:indx_end_stop[i]]);
  i = i + 1;
endo;
e = ones(nStop,1);
pline = e.*(1~6)~indx_begin_stop~Smean~indx_end_stop~Smean~e.*(1~0~10) |
        e.*(1~6)~indx_begin_stop~e*0~indx_begin_stop~Smean~e.*(1~0~5) |
        e.*(1~6)~indx_end_stop~e*0~indx_end_stop~Smean~e.*(1~0~5) ;

S3 = S;
pline3 = pline;

S = SPX~S1~S2~S3;
Results = zeros(3,4);
i = 1;
do until i > 4;
  report = Compute_Global_Reporting(Dates,S[.,i],SPX,Libor,0,0);
  Results[.,i] = 100*vread(report,"mu") |
                 100*vread(report,"sigma") |
                 vread(report,"SR") ;
  i = i + 1;
endo;

print ftosa(Results,"%lf",2,2);

    