new;
library pgraph;

PathName = "..\\data\\";
FileName = PathName $+ "qam_volume";

data = loadd(FileName);
vnames = "" $+ getname(FileName);
loads data_str = ^FileName;

indx = sortind(data[.,1]);
data = data[indx,.];
data_str = data_str[indx,.];

cls;
print data;
print vnames';


Price = data[., 2];
bid = data[.,6];
ask = data[.,7];
mid = (bid + ask)/2;
spread = 1e4 * abs(bid - ask)./mid;

s = 2|5|10|25|50|100|200|1e4;
frq = counts(spread,s);
frq = frq/rows(data);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pnumht = 0.13;
  _pbarwid = 0.2; _pbartyp = {6 4};
  let xlab = "(0,2)" "(2,5)" "(5,10)" "(10,25)" "(25,50)" "(50,1%)" "(1%,2%)" "+2%";
  asclabel(xlab,0);
  ytics(0,30,5,2);
  graphprt("-c=1 -cf=liquidity1.eps");
  bar(0,100*frq);



