new;
library qam,pgraph,optmum;

PathName = "..\\Data\\";
datFileName = PathName $+ "qam_dataset2";
data = loadd(datFileName);
vnames = getname(datFileName);
Dates = data[.,1];

// "Date" "S&P" "STXX" "TPX" "EM_EU" "EM_ASIA" "EM_LAT" "RICI" "US_HY" "EMBI" "US_IG" "EUR_IG" "Libor" "Euribor" "Tibor" "MSCI_W" "BarCap";

let selected_names = S&P STXX US_IG EUR_IG MSCI_W BarCap Euribor;
indx = indcv(selected_names,vnames);
Data = Data[.,indx];
Data = dates~Data;

Begin_Date = 19931231;
Last_Date = 20091231;

Data = selif(data,(Data[.,1] .>= Begin_Date) .and (Data[.,1] .<= Last_Date));

Dates = data[.,1]; 
nDates = rows(Dates);

Data = Data[.,2:cols(Data)];
Benchmark = Data[.,cols(Data)-2:cols(Data)];
Euribor = Benchmark[.,3];
Basket = Data[.,1:cols(Data)-3];
nBasket = cols(Basket);

Weights0 = ones(nDates,nBasket)/nbasket;

RD_Weekly = zeros(nDates,1);
indx = seqa(1,5,nDates/5);
RD_Weekly[indx] = ones(nDates/5,1);

let lag_vector = 22 61 130 260;
let bound_vector = 0.10 0.25 0.50 0.75 1.00;
nLags = rows(lag_vector);
nBounds = rows(bound_vector);

Turnover = zeros(nLags,nBounds);

iter_Lag = 1;
do until iter_Lag > nLags;

  pLag = lag_vector[iter_Lag];
  {cov,vol,cor} = Compute_Running_Covariance(Dates,Basket,pLag,2);
  er_1Y = Basket./lagn(Basket,pLag) - 1;

  iter_Bound = 1;
  do until iter_Bound > nBounds;

    pBound = Bound_vector[iter_Bound];

    Weights1 = Weights0;

    A = ones(1,nBasket);
    B = 0;
    Bounds = (-pBound~pBound) .* ones(nBasket,1);

    t = 1;
    do until t > nDates;

      if t > 260;
        cov_t = arraytomat(cov[t,.,.]);
        er_t = er_1Y[t-1,.]';
      else;
        t = t + 1;
        continue;
      endif;

      if RD_Weekly[t] == 0;
        x = Weights1[t-1,.]';
        weights1[t,.] = x';
      else;
        {x,mu,sigma,phi,retcode} = Qprog_Allocation_Solve(er_t,cov_t,A,B,0,0,Bounds,0.04,2);
        if (retcode == 0) and (ismiss(x) == 0);
          weights1[t,.] = x';
        else;
          weights1[t,.] = weights1[t-1,.];
        endif;
      endif;

      t = t + 1;
    endo;

    weights1 = selif(weights1,RD_Weekly);
    Tm = Compute_Turnover(weights1,0);
    Tm = trimr(Tm,53,1);
    Turnover[iter_Lag,iter_bound] = 52*meanc(Tm);
  
    iter_bound = iter_bound + 1;
  endo;

  iter_Lag = iter_Lag + 1;
endo;

cls;
print ftosa(Turnover,"%lf",3,2);
