new;
library qam,pgraph,optmum;

PathName = "..\\Data\\";
datFileName = PathName $+ "qam_dataset2";
data = loadd(datFileName);
vnames = getname(datFileName);
Dates = data[.,1];

// "Date" "S&P" "STXX" "TPX" "EM_EU" "EM_ASIA" "EM_LAT" "RICI" "US_HY" "EMBI" "US_IG" "EUR_IG" "Libor" "Euribor" "Tibor" "MSCI_W" "BarCap";

let selected_names = S&P STXX US_IG EUR_IG MSCI_W BarCap Euribor;
indx = indcv(selected_names,vnames);
Data = Data[.,indx];
Data = dates~Data;

Begin_Date = 19931231;
Last_Date = 20091231;

Data = selif(data,(Data[.,1] .>= Begin_Date) .and (Data[.,1] .<= Last_Date));

Dates = data[.,1]; 
nDates = rows(Dates);

Data = Data[.,2:cols(Data)];
Benchmark = Data[.,cols(Data)-2:cols(Data)];
Euribor = Benchmark[.,3];
Basket = Data[.,1:cols(Data)-3];
nBasket = cols(Basket);

Weights0 = ones(nDates,nBasket)/nbasket;

{cov,vol,cor} = Compute_Running_Covariance(Dates,Basket,260,2);
er_1Y = Basket./lagn(Basket,260) - 1;
Weights1 = Weights0;

A = ones(1,nBasket);
B = 0;
Bounds = (-0.5~0.5) .* ones(nBasket,1);

Months = trunc(Dates/100);
RD_Monthly = Months ./= lag1(Months);
RD_Monthly[1] = 1;

t = 1;
do until t > nDates;

  if t > 260;
    cov_t = arraytomat(cov[t,.,.]);
    er_t = er_1Y[t-1,.]';
  else;
    t = t + 1;
    continue;
  endif;

  if RD_Monthly[t] == 0;
    x = Weights1[t-1,.]';
    weights1[t,.] = x';
  else;
    {x,mu,sigma,phi,retcode} = Qprog_Allocation_Solve(er_t,cov_t,A,B,0,0,Bounds,0.04,2);
    if (retcode == 0) and (ismiss(x) == 0);
      weights1[t,.] = x';
    else;
      weights1[t,.] = weights1[t-1,.];
    endif;
  endif;

  t = t + 1;
endo;

R_Basket = Basket./lag1(Basket) - Euribor./lag1(Euribor);
R_Basket = missrv(R_Basket,0);
Basket_notFunded = 100 * cumprodc(1 + R_Basket);
Weights_Euribor = ones(nDates,1);

F1 = Compute_Monthly_Backtest2(Dates,Weights_Euribor,Euribor,Weights1,Basket_notFunded);

implied_weights1 = Compute_Implied_Weights(Dates,Weights1,Basket);

weights1 = selif(weights1,RD_Monthly);
Tm = Compute_Turnover(weights1,0);
Tm = trimr(Tm,13,1);
print 12*meanc(Tm);
