new;
library qam,pgraph,optmum;

rndseed 123;

nLS = 100;
nT = 12*5;

Perf = zeros(nT,2);
G = zeros(nT,2);

i = 1;
do until i > nT;
  S1  = (rndn(nLS/2,1)+2)|rndn(nLS/2,1);
  S2  = (rndn(nLS/2,1)+2)|(rndn(nLS/2,1));
  R = (0.02 + 0.14*rndn(nLS/2,1) | (0.00 + 0.10 * rndn(nLS/2,1)));
  indx = maxindc(S1);
  R[indx] = R[indx] + 0.90;
  {indx_Short,indx_Long,R_Short,R_Long} = Long_Short_Scoring(S1,R,0);
  Perf[i,1] = meanc(R_Long) - meanc(R_Short);
  {indx_Short,indx_Long,R_Short,R_Long} = Long_Short_Scoring(S2,R,0);
  Perf[i,2] = meanc(R_Long) - meanc(R_Short);

  Y = R .>= median(R);
  {G[i,1],dataSelect,dataPerf,dataDiscr} = Scoring_Curve(Y,S1,0,0);
  {G[i,2],dataSelect,dataPerf,dataDiscr} = Scoring_Curve(Y,S2,0,0);

  i = i + 1;
endo;

Backtest = 100* cumprodc(1 + Perf);

x = seqa(-1,2/100,101);
{d1,F1} = regKernelDensity(G[.,1],x);
{d2,F2} = regKernelDensity(G[.,2],x);


graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9/2.5,6.855/2.5,1.25,3.75,1);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pltype = 6|3; _pcolor = 1|3;
  
  
  setwind(1);
    xtics(1,nT,12,0);
    let xlab = "2005" "2006" "2007" "2008" "2009" "2010";
    asclabel(xlab,0);
    _plegstr = "S]1[\000S]2[";
    _plegctl = {2 5 6 1};
    xy(0,Backtest);

    _plegctl = 0;

  setwind(2);
    _pnumht = 0.22; _ptitlht = 0.25; _paxht = 0.22;
    asclabel(0,0);
    xtics(-0.5,0.5,0.25,0);
    ytics(0,3.5,0.5,0);
    title("\216Gini");
    xy(x,d1~d2);

    graphprt("-c=1 -cf=scoring14.eps");

  endwind;







