new;
library qam,optmum,pgraph;

N = 100;

R1 = seqa(1,1,N);
R1[N] = N;
pdf1 = ones(N,1)/N;

x1 = R1;
y1 = pdf1;

R2 = seqa(1,1,N);
R2[N] = N;
pdf2 = ones(N,1)/N;

{x2,y2} = aggregate(R1,R2,pdf1,pdf2,0.0);
{x3,y3} = aggregate(R1,R2,pdf1,pdf2,-0.70);
{x4,y4} = aggregate(R1,R2,pdf1,pdf2,0.50);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  fonts("simplex simgrma");
  _ptitlht = 0.25;
  xtics(0,100,10,2);
  ytics(0,1,0.2,0);

  setwind(1);
    title("\216S]j[");
    _pbartyp = 6~1;
    call bar(x1,100*y1);

  setwind(2);
    title("\216\202r\201 = 0");
    _pbartyp = 6~2;
    call bar(x2,100*y2);

  setwind(3);
    title("\216\202r\201 = -70%");
    _pbartyp = 6~3;
    ytics(0,3,1,0);
    call bar(x3,100*y3);

  setwind(4);
    title("\216\202r\201 = 60%");
    ytics(0,1,0.2,0);
    _pbartyp = 6~4;
    call bar(x4,100*y4);

    graphprt("-c=1 -cf=scoring2.eps");

  endwind;

proc cdfCopula(u1,u2,rho);
  local y1,y2;
  y1 = cdfni(u1);
  y2 = cdfni(u2);
  retp( cdfbvn(y1,y2,rho) );
endp;

proc (2) = aggregate(R1,R2,pdf1,pdf2,rho);
  local N,cdf1,cdf2,cdf1_lag,cdf2_lag,pdf,R;

  N = rows(R1);
  cdf1 = cumsumc(pdf1);
  cdf1[N] = 1.0;
  cdf2 = cumsumc(pdf2);
  cdf2[N] = 1.0;
  cdf1_lag = lag1(cdf1);
  cdf1_lag[1] = 0.0;
  cdf2_lag = lag1(cdf2);
  cdf2_lag[1] = 0.0;

  pdf = cdfCopula(cdf1,cdf2',rho) - cdfCopula(cdf1_lag,cdf2',rho) - cdfCopula(cdf1,cdf2_lag',rho) + cdfCopula(cdf1_lag,cdf2_lag',rho);
  pdf = vecr(pdf);

  R = 0.5*(R1 + R2');
  R = vecr(R);

  pdf = countwts(R,unique(R,1),pdf);
  R = unique(R,1);

  retp(R,pdf);
endp;



