new;
library gdr,qam,optmum,pgraph;

rndseed 123;

N = 100;
nSimul = 20000;
nScore = 10;

R = floor(N * rndu(nSimul,nScore));
x = seqa(0,0.1,10*N);

rho = 0.0;
u = cdfn(sqrt(rho) .* rndn(nSimul,1) + sqrt(1 - rho^2) .* rndn(nSimul,nScore));
Rc = rndCopulaEmpiricalQuantile(u,R);

R1 = Rc[.,1:5];
R1 = meanc(R1');
R2 = Rc[.,1:10];
R2 = meanc(R2');

rho = 0.70;
u = cdfn(sqrt(rho) .* rndn(nSimul,1) + sqrt(1 - rho^2) .* rndn(nSimul,nScore));
Rc = rndCopulaEmpiricalQuantile(u,R);
R3 = Rc[.,1:5];
R3 = meanc(R3');
R4 = Rc[.,1:10];
R4 = meanc(R4');

{d1,F1} = regKernelDensity(R1,x);
{d2,F2} = regKernelDensity(R2,x);
{d3,F3} = regKernelDensity(R3,x);
{d4,F4} = regKernelDensity(R4,x);

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");

  _pdate = ""; _pnum = 2; _pframe = 0;  
  _plwidth = 10; _pltype = 6;
  _ptitlht = 0.25; _pnumht = 0.20; _paxht = 0.20;
  xlabel("\216S");

  setwind(1);
    title("\216\202r\201 = 0 et m = 5");
    _pcolor = 1;
    ytics(0,3,1,0); 
    xy(x,100*d1);

  setwind(2);
    title("\216\202r\201 = 0 et m = 10");
    _pcolor = 2;
    ytics(0,4.5,1.5,0);
    xy(x,100*d2);

  setwind(3);
    title("\216\202r\201 = 70% et m = 5");
    _pcolor = 3;
    ytics(0,1.5,0.5,0);
    xy(x,100*d3);

  setwind(4);
    title("\216\202r\201 = 70% et m = 10");
    _pcolor = 4;
    xy(x,100*d4);

    graphprt("-c=1 -cf=scoring3.eps");

  endwind;
