new;
library qam,pgraph,optmum;

cls;

rndseed 123;

n = 5000;
GoodPercent = 0.4;

nGood = GoodPercent*n;
nBad = (1-GoodPercent)*n;

Y  = ones(nGood,1)|zeros(nBad,1);
S = (rndn(nGood,1)+1.0)|(rndn(nBad,1));

x = seqa(0,1/200,201);
{Gini,dataSelect,dataPerf,dataDiscr} = Scoring_Curve(Y,S,0,x);

S0 = selif(S,Y .== 0);
S1 = selif(S,Y .== 1);
x = seqa(-4,8/100,101);
{d0,F0} = regKernelDensity(S0,x);
{d1,F1} = regKernelDensity(S1,x);

KS = maxc(F0-F1);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _paxht = 0.25; _pnumht = 0.22; _ptitlht = 0.25;
  _plwidth = 10; _pltype = 6|3; _pcolor = 1|4;
  xtics(0,1,0.2,2);
  ytics(0,1.0,0.2,2);
  xlabel("\216x");

  setwind(1);
    title("\216Courbe (S)");
    ylabel("\216S(x)");
    _pline = 1~1~0~0~1~1~0~0~10;
    xy(dataSelect[.,1],dataSelect[.,2 3]);

    _pmsgctl = 0;

  setwind(2);
    title("\216Courbe (P)");
    ylabel("\216P(x)");
    _pline = 1~1~0~1~1~1~0~0~10;
    xy(dataPerf[.,1],dataPerf[.,2 3]);

  setwind(3);
    title("\216Courbe (D)");
    ylabel("\216D(x)");
    _pline = 1~1~0~0~1~1~0~0~10;
    xy(dataDiscr[.,1],dataDiscr[.,2 3]);

  setwind(4);
    xtics(-4,4,1,0);
    title("\216CDF");
    ylabel("\216F(s)");
    xlabel("\216s");
    _pline = 0;
    _plegstr = "Y = 0\000Y = 1";
    _plegctl = {2 5 2 4};
    xy(x,F0~F1);

    graphprt("-c=1 -cf=scoring9.eps");

  endwind;