new;
library qam,pgraph,optmum;

cls;

rndseed 123456;

_reg_PrintIters = 0;
__output = 0;

T = 500;
ns = 1000;

rho = 0.20;

let nVector = 2 3 5 10 20;
nRows = rows(nVector);
ml = zeros(ns,nRows);
var = zeros(nRows,1);
var1 = zeros(ns,nRows);
var2 = zeros(ns,nRows);

iter = 1;
do until iter > nRows;
  n = nVector[iter];
  corr = diagrv(rho .* ones(n,n),1.0);

  x = ones(n,1)/n;
  var[iter] = sqrt(x'*corr*x);

  i = 1;
  do until i > ns;
    data = rndmn(0,corr,T);
    {ml[i,iter],corHat} = regCorr1(data);

    var1[i,iter] = sqrt(x'*diagrv(ml[i,iter] .* ones(n,n),1.0)*x);
    var2[i,iter] = sqrt(x'*corHat*x);

    i = i + 1;
  endo;

  iter = iter + 1;
endo;

var1 = var1./var';
var2 = var2./var';

x = seqa(0,0.40/255,256);
x1 = seqa(0.8,0.40/255,256);
x2 = x1;

d = zeros(256,nRows);
d1 = zeros(256,nRows);
d2 = zeros(256,nRows);

iter = 1;
do until iter > nRows;
  {d[.,iter],F} = regKernelDensity(ml[.,iter],x);
  {d1[.,iter],F} = regKernelDensity(var1[.,iter],x1);
  {d2[.,iter],F} = regKernelDensity(var2[.,iter],x2);
  iter = iter + 1;
endo;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|4|5; _plwidth = 10|10|10|15|10; _pcolor = 1|2|3|4|5;
  xlabel("\216\202r\201 (en %)");
  xtics(10,30,5,2);
  ytics(0,30,5,2);
  _plegstr = "Empirique\000n = 3\000n = 5\000n = 10\000n = 20";
  _plegctl = {2 5 6 4};
  graphprt("-c=1 -cf=cov1.eps");
  xy(100*x,d);