new;
library qam,pgraph,optmum;

cls;

PathName = "..\\Data\\";
datFileName = PathName $+ "qam_equity_index";
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);
Dates = data[.,1];

// SPTR R2000 USA_LC USA_SC TSX SXXT FTSE SMI OBX OMX TOPIX BOVESPA RUSSIA RTS SENSEX CHINA KOSPI 

let selected_names = sptr   sxxt    ftse    topix
                     bovespa rts    sensex  china;
let Factors        = 1      1       1       1
                     2      2       2       2;

indx = indsav("" $+ selected_names,vnames);
Data = Data[.,indx];

Data = Dates~Data;
Begin_Date = 20041201;
Last_Date = 20091231;

Data = selif(data,(Data[.,1] .>= Begin_Date) .and (Data[.,1] .<= Last_Date));
Data = Fill_Miss(Data,4);

Dates = data[.,1]; 
nDates = rows(Dates);
Data = data[.,2:cols(data)];
{First_NoMiss,Last_NoMiss} = indn_nomiss(Data);
Data = 100*Data ./ subvec(Data',First_NoMiss)';

dt = 5;
Rdt = Data./lagn(Data,dt) - 1;
Rdt = packr(Rdt);
x = (Rdt - meanc(Rdt)') ./ stdc(Rdt)';

{Sigma,alpha,Sigma1,Sigma2} = vcx_cc_shrinkage(x);

stddev = sqrt(diag(Sigma));
C8 = Sigma ./ stddev ./ stddev';

print ftosa(C8,"%lf",1,2);

print alpha;

TexFile = "cov.tex";
mask = 1;
let fmt[8,3] = 
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2;

C8 = miss(lowmat(C8),0);
call Tabular(TeXFile,C8,mask,fmt,0,0,0,0,0);






