new;
library qam,pgraph,optmum;

cls;

PathName = "..\\Data\\";
datFileName = PathName $+ "qam_equity_index";
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);
Dates = data[.,1];

// SPTR R2000 USA_LC USA_SC TSX SXXT FTSE SMI OBX OMX TOPIX BOVESPA RUSSIA RTS SENSEX CHINA KOSPI 

let selected_names = sptr   sxxt    ftse    topix
                     bovespa rts    sensex  china;
let Factors        = 1      1       1       1
                     2      2       2       2;

indx = indsav("" $+ selected_names,vnames);
Data = Data[.,indx];

Data = Dates~Data;
Begin_Date = 20041201;
Last_Date = 20091231;

Data = selif(data,(Data[.,1] .>= Begin_Date) .and (Data[.,1] .<= Last_Date));
Data = Fill_Miss(Data,4);

Dates = data[.,1]; 
nDates = rows(Dates);
Data = data[.,2:cols(data)];
{First_NoMiss,Last_NoMiss} = indn_nomiss(Data);
Data = 100*Data ./ subvec(Data',First_NoMiss)';

dt = 5;
Rdt = Data./lagn(Data,dt) - 1;
Rdt = packr(Rdt);
x = (Rdt - meanc(Rdt)') ./ stdc(Rdt)';
C0 = corrx(x);

rho_mean = meanc(packr(vech(miss(miss(lowmat1(C0),0),1))));

_reg_PrintIters = 0;
{rho,C1} = regCorr1(x);
C1 = ConstantCorrelation(rho,8);

_reg_cov = 0;
_regCorrF_Bound = 0.70;
{rho_c,rho_f,C2,cor} = regCorr2(x,1,Factors,0);

cls;

print ftosa(rho_mean,"%lf",1,2);

print ftosa(C0,"%lf",1,2);
print ftosa(C1,"%lf",1,2);
print ftosa(C2,"%lf",1,2);

LogL0 = sumc(lnpdfmvn(x,C0));
LogL1 = sumc(lnpdfmvn(x,C1));
LogL2 = sumc(lnpdfmvn(x,C2));

print ftosa(LogL0,"Logl0 = %lf",1,3);
print ftosa(LogL1,"Logl1 = %lf",1,3);
print ftosa(LogL2,"Logl2 = %lf",1,3);

LR01 = 2*(Logl0-Logl1);
LR02 = 2*(Logl0-Logl2);
print ftosa(LR01,"LR 0/1 = %lf",1,3);
print ftosa(LR02,"LR 0/2 = %f",1,3);

LM = cdfchic(2,10*11/2);

TexFile = "cov.tex";
mask = 1;
let fmt[8,3] = 
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2;

C0 = miss(lowmat(C0),0);
C1 = miss(lowmat(C1),0);
C2 = miss(lowmat(C2),0);

call Tabular(TeXFile,C0,mask,fmt,0,0,0,0,1);
call Tabular(TeXFile,C1,mask,fmt,0,0,0,0,0);
call Tabular(TeXFile,C2,mask,fmt,0,0,0,0,0);