new;
library gdr,qam,pgraph,optmum;

cls;

PathName = "..\\Data\\";
datFileName = PathName $+ "qam_equity_index";
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);
Dates = data[.,1];

// SPTR R2000 USA_LC USA_SC TSX SXXT FTSE SMI OBX OMX TOPIX BOVESPA RUSSIA RTS SENSEX CHINA KOSPI 

let selected_names = sptr   sxxt    ftse    topix
                     bovespa rts    sensex  china;
let Factors        = 1      1       1       1
                     2      2       2       2;

indx = indsav("" $+ selected_names,vnames);
Data = Data[.,indx];

Data = Dates~Data;
Begin_Date = 20041201;
Last_Date = 20091231;

Data = selif(data,(Data[.,1] .>= Begin_Date) .and (Data[.,1] .<= Last_Date));
Data = Fill_Miss(Data,4);

Dates = data[.,1]; 
nDates = rows(Dates);
Data = data[.,2:cols(data)];
{First_NoMiss,Last_NoMiss} = indn_nomiss(Data);
Data = 100*Data ./ subvec(Data',First_NoMiss)';

__output = 1;

dt = 5;
Rdt = Data./lagn(Data,dt) - 1;
Rdt = packr(Rdt);
x = (Rdt - meanc(Rdt)') ./ stdc(Rdt)';
C0 = corrx(x);
print ftosa(C0,"%lf",1,2);
{va0,ve0,pca0} = regPCA(C0,8);

u = dependogram(x);
u = substute(u,u .== 1, 1-__macheps);
C9 = regCopulaNormal(u); 
print ftosa(C9,"%lf",1,2);
{va9,ve9,pca9} = regPCA(C9,8);

TexFile = "cov.tex";
mask = 1;
let fmt[8,3] = 
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2;

C9 = miss(lowmat(C9),0);
call Tabular(TeXFile,C9,mask,fmt,0,0,0,0,0);

data = 100*(va0[1:4]/sumc(va0)|va9[1:4]/sumc(va9));
data = data' |(ve0[.,1:4]~ve9[.,1:4]);
call Tabular(TeXFile,data,mask,fmt,0,0,0,0,0);


QLTvar0 = vread(pca0,"QLTvar");
QLTvar9 = vread(pca9,"QLTvar");
CTRvar0 = vread(pca0,"CTRvar");
CTRvar9 = vread(pca9,"CTRvar");

data = (QLTvar0[.,1:4]~QLTvar9[.,1:4]);
call Tabular(TeXFile,data,mask,fmt,0,0,0,0,0);

data = (CTRvar0[.,1:4]~CTRvar9[.,1:4]);
call Tabular(TeXFile,data,mask,fmt,0,0,0,0,0);
