new;
library qam,pgraph,optmum;

cls;

PathName = "..\\Data\\";
datFileName = PathName $+ "qam_equity_index";
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);
Dates = data[.,1];

// SPTR R2000 USA_LC USA_SC TSX SXXT FTSE SMI OBX OMX TOPIX BOVESPA RUSSIA RTS SENSEX CHINA KOSPI 

let selected_names = sptr   sxxt    ftse    topix
                     bovespa rts    sensex  china;
let Factors        = 1      1       1       1
                     2      2       2       2;

indx = indsav("" $+ selected_names,vnames);
Data = Data[.,indx];

Data = Dates~Data;
Begin_Date = 20041201;
Last_Date = 20091231;

Data = selif(data,(Data[.,1] .>= Begin_Date) .and (Data[.,1] .<= Last_Date));
Data = Fill_Miss(Data,4);

Dates = data[.,1]; 
nDates = rows(Dates);
Data = data[.,2:cols(data)];
{First_NoMiss,Last_NoMiss} = indn_nomiss(Data);
Data = 100*Data ./ subvec(Data',First_NoMiss)';

dt = 5;
Rdt = Data./lagn(Data,dt) - 1;
Rdt = packr(Rdt);
x = (Rdt - meanc(Rdt)') ./ stdc(Rdt)';
V0 = vcx(x);
C0 = corrx(x);

declare matrix C4,C5,C6,A4,A5,A6;

p = 1;
do until p > 3;
  {A,D} = regFactorModel(C0,p);
  if p == 1;
    let sgn = 1;
  elseif p == 2;
    let sgn = 1 1;
  elseif p == 3;
    let sgn = -1 1 1;
  endif;
  A = A .* sgn';
  V = A*A' + D;
  s = sqrt(diag(V));
  C = V ./ s ./ s';
  call invpd(C);
  call varput(C,itos("C",p+3));
  call varput(A,itos("A",p+3));
  p = p + 1;
endo;

print ftosa(C4,"%lf",1,2);
print ftosa(A4,"%lf",1,4);

print ftosa(C5,"%lf",1,2);
print ftosa(A5,"%lf",1,4);

print ftosa(C6,"%lf",1,2);
print ftosa(A6,"%lf",1,4);

C4 = miss(lowmat(C4),0);
C5 = miss(lowmat(C5),0);
C6 = miss(lowmat(C6),0);

TexFile = "cov.tex";
mask = 1;
let fmt1[8,3] = 
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2
               "%lf" 4 2;
let fmt2[8,3] = 
               "%lf" 4 4
               "%lf" 4 4
               "%lf" 4 4
               "%lf" 4 4
               "%lf" 4 4
               "%lf" 4 4
               "%lf" 4 4
               "%lf" 4 4;

call Tabular(TeXFile,C4,mask,fmt1,0,0,0,0,0);
call Tabular(TeXFile,A4,mask,fmt2,0,0,0,0,0);
call Tabular(TeXFile,C5,mask,fmt1,0,0,0,0,0);
call Tabular(TeXFile,A5,mask,fmt2,0,0,0,0,0);
call Tabular(TeXFile,C6,mask,fmt1,0,0,0,0,0);
call Tabular(TeXFile,A6,mask,fmt2,0,0,0,0,0);
