new;
library qam,optmum,pgraph;
dlibrary mars36;

cls;

rndseed 123;

N1 = 500;
N2 = 100;
N3 = 200;
N4 = 200;

M1 = zeros(4,1);
M2 = 1|1|1|1;
M3 = 0.5|-0.2|-1|1;
M4 = -0.2|-1|2|-0.7;

X1 = 2*rndn(N1,4) + M1';
X2 = rndn(N2,4) + M2';
X3 = rndn(N3,4) + M3';
X4 = rndn(N4,4) + M4';

X  = X1|X2|X3|X4;

Y  = zeros(N1,1)|ones(N2+N3+N4,1);

u = rndu(N1+N2+N3+N4,1);
data = sortc(U~Y~X,1);
Y = data[.,2];
X = data[.,3:cols(data)];
data = 0;

Ytrain = Y[1:700,.];
Xtrain = X[1:700,.];

Yvalid = Y[701:1000,.];
Xvalid = X[701:1000,.];

nB = 15;
nI = 3;
Lx = ones(cols(x),1);

_mars_logit = 1;
{fm,im} = regMars(Ytrain,Xtrain,0,nB,nI,Lx);
s1 = cdfLogit(regMarsForecast(Xvalid,fm,im,1));

_reg_PrintIters = 2;
{theta,stderr,Mcov,LogL} = regLogit(0,Ytrain,Xtrain,zeros(4,1),0,0);
s2 = cdfLogit(Xvalid * theta);

graphset;
  _plctrl = -1; _pcross = 1; _pframe = 0; 
  _pdate = ""; _pnum = 2; _plwidth = 10;
  _pcolor = 1; _pstype = 8;

  xtics(0,1,0.2,5);
  ytics(0,1,0.2,5);
  ztics(0,1,0.2,5);

  xlabel("\216y");
  ylabel("\216Mars");
  zlabel("\216Logit");

  xyz(yValid,s1,s2);


