new;
library qam,pgraph,optmum;

PathName = "..\\data\\";
xlsFileName = "qam_stocks_weekly";

FileName = PathName $+ xlsFileName;
data = loadd(FileName);
vnames = "" $+ getname(FileName);

data = selif(data,(data[.,1] .>= 19900101) .and (data[.,1] .<= 20091231));

Dates = data[.,1];

let string selected_names[5,1] = "cac 40" "total" "danone" "bnp" "ppr"; 
indx = indsav(selected_names,vnames);
data = data[.,indx];

Bench = data[.,1];
data = data[.,2:cols(data)];
R_Bench = Bench./lag(Bench) - 1;
R = data./lag(data) - 1;

alpha = seqa(0.01,0.01,99);
nAlpha = rows(alpha);

nX = cols(R);
beta_OLS = zeros(nX,1);
beta_LAD = zeros(nX,1);
beta_QR = zeros(nAlpha,nX);

i = 1;
do until i > nX;

  {y,x} = packr2(R_Bench,R[.,i]);
  x = x~ones(rows(x),1);
  {beta,u,retcode} = regRobust(y,x,&_regRobust_OLS_rho,&_regRobust_OLS_psi);
  beta_OLS[i] = beta[1];
  {beta,u,retcode} = regLAD(y,x);
  beta_LAD[i] = beta[1];
  j = 1;
  do until j > nAlpha;
    {beta,u,retcode} = regQR(y,x,alpha[j]);  
    beta_QR[j,i] = beta[1];
    j = j + 1;
  endo;
  i = i + 1;
endo;

graphset;
  begwind;
  window(2,2,0);
  
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 12; _pcolor = 1|2|3; _pltype = 6|1|3;
  _ptitlht = 0.25; _paxht = 0.20; _pnumht = 0.20;

  xtics(0,1.0,0.25,2);
  fonts("simplex simgrma");
  xlabel("\216\202a\201");

  setwind(1);
    title("\216Total");
    iter = 1;
    beta = (beta_Ols[iter]~beta_LAD[iter]) .* ones(nAlpha,1) ~ beta_QR[.,iter];
    ytics(0.38,0.54,0.04,2);
    xy(alpha,beta);

  setwind(2);
    title("\216Danone");
    iter = 2;
    beta = (beta_Ols[iter]~beta_LAD[iter]) .* ones(nAlpha,1) ~ beta_QR[.,iter];
    ytics(0.38,0.54,0.04,2);
    xy(alpha,beta);

  setwind(3);
    title("\216BNP");
    iter = 3;
    beta = (beta_Ols[iter]~beta_LAD[iter]) .* ones(nAlpha,1) ~ beta_QR[.,iter];
    ytics(0.30,0.45,0.05,2);
    xy(alpha,beta);

  setwind(4);
    title("\216PPR");
    iter = 4;
    beta = (beta_Ols[iter]~beta_LAD[iter]) .* ones(nAlpha,1) ~ beta_QR[.,iter];
    ytics(0.30,0.45,0.05,2);
    _plegstr = "OLS\000LAD\000Quantile";
    _plegctl = {2 5 5 4};
    xy(alpha,beta);

    graphprt("-c=1 -cf=reg1.eps");
  endwind;