new;
library qam,pgraph,optmum;

rndseed 123;

nR = 200;
nS = 800;
nT = nR + nS;

c = 1000;
x = zeros(nT,c);
y = zeros(nT,c);

n = 5; alpha = 2; beta = 4;
x0 = 5*ones(1,c);
y0 = 0.5*ones(1,c);

i = 1;
do until i > nT;
  x0 = rndb(1,c,y0,n) ;
  y0 = rndbeta(1,c,x0 + alpha,n - x0 + beta);
  x[i,.] = x0;
  y[i,.] = y0;
  i = i + 1;
endo;

g_all = x .* y;
g = trimr(g_all,nR,0);
x_g = seqa(0.5,0.5/200,201);
d_g = zeros(201,2);
{d_g,F_g} = regKernelDensity(meanc(g),x_g);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _paxht = 0.25;_pnumht = 0.20; _ptitlht = 0.30;
  fonts("simplex simgrma");

  xtics(0,1000,200,2); _plctrl = -1;
  xlabel("\216Iteration i");
  _pmsgstr = "-";

  _pline = 1~1~nR~-1~nR~6~1~0~10;

  setwind(1); 
    title("\216x");
    _pcolor = 1;
    ytics(-1,6,1,2);
    let ylab = "  " " 0" " 1" " 2" " 3" " 4" " 5" "  ";
    asclabel(0,ylab); 
    _pmsgctl = 3.80~0.36~0.07~45~2~0~6 ;
    xy(0,x[.,1]);

  setwind(2);
    title("\216y");
    _pcolor = 2;
    asclabel(0,0);   
    ytics(0,1.0,0.2,2); 
    _pmsgctl = 4.02~0.36~0.07~45~2~0~6 ;  
    xy(0,y[.,1]);

  setwind(3);
    title("\216xy");
    _pcolor = 3;
    ytics(0,5,1,2); 
    _pmsgctl = 3.90~0.36~0.07~45~2~0~6 ;  
    xy(0,g_all[.,1]);

  _plctrl = 0;

  setwind(4);
    title("\216g(x,y) = E@[xy@]");
    _pcolor = 4; _plwidth = 10;
    xtics(0.5,1,0.1,2);
    ytics(0,10,2,2);  
    _pmsgctl = 0; 
    xlabel("");
    xy(x_g,d_g);

    graphprt("-c=1 -cf=reg3.eps");

  endwind;

g_hat = meanc(meanc(g));
print ftos(g_hat,"g = %lf",3,4);
