new;
library qam,pgraph,optmum;

PathName = "..\\data\\";
xlsFileName = "qam_stocks_weekly";

FileName = PathName $+ xlsFileName;
data = loadd(FileName);
vnames = "" $+ getname(FileName);

data = selif(data,(data[.,1] .>= 19900101) .and (data[.,1] .<= 20091231));

Dates = data[.,1];

let string selected_names[5,1] = "cac 40"; 
indx = indsav(selected_names,vnames);
data = data[.,indx];

Bench = data[.,1];

R = 100*packr(Bench./lag(Bench) - 1);

min_R = minc(R);
max_R = maxc(R);

mu = meanc(R);
sigma = stdc(R);

x1 = seqa(-10,20/20,21);
x2 = seqa(-10,20/200,201);
x3 = seqa(-10,20/2000,2001);

graphset;
  window3d;

  _pdate = ""; _pnum = 2; _pframe = 0;
  ylabel("\216Frequence (en %)");
  xlabel("\216Rendement (en %)");
  xtics(-10,10,2,1);
  _ptitlht = 0.25; _pnumht = 0.20; _paxht = 0.20;
  _pmsgstr = "-";
  _pmsgctl = 0.18~2.50~0.07~-45~2~0~6 ;

  setwind(1);
    _pbartyp = {6 1};
    title("\216h = 1%");
    call histp(R,x1);

  setwind(2);
    _pbartyp = {6 2};
    title("\216h = 10 pbs");
    call histp(R,x2);

  setwind(3);
    _pbartyp = {6 3};
    title("\216h = 1 pb");
    call histp(R,x3);

    graphprt("-c=1 -cf=reg4.eps");

  endwind;