new;
library qam,pgraph,optmum;

PathName = "..\\data\\";
xlsFileName = "qam_stocks_weekly";

FileName = PathName $+ xlsFileName;
data = loadd(FileName);
vnames = "" $+ getname(FileName);

data = selif(data,(data[.,1] .>= 19900101) .and (data[.,1] .<= 20091231));

Dates = data[.,1];

let string selected_names[5,1] = "cac 40"; 
indx = indsav(selected_names,vnames);
data = data[.,indx];

Bench = data[.,1];

R = 100*packr(Bench./lag(Bench) - 1);

x = seqa(-10,20/200,201);
mu = meanc(R);
sigma = stdc(R);
sv = mu|sigma;

d1 = pdfn((x - mu)/sigma)/sigma;
F1 = cdfn((x - mu)/sigma);

declare matrix nu; 
fn gen_pdft(x,mu,sigma,nu) = pdft((x - mu)/sigma,nu)/sigma;
fn gen_cdft(x,mu,sigma,nu) = cdft((x - mu)/sigma,nu);

proc (1) = ml_t(theta);
  local mu,sigma,logl;
  mu = theta[1];
  sigma = sqrt(theta[2]^2);
  logl = ln(gen_pdft(R,mu,sigma,nu));
  retp(logl);
endp;

nu = 4;
{theta,stderr,Mcov,LogL} = regML(0,0,&ml_t,sv,0,0);
mu = theta[1];
sigma = sqrt(theta[2]^2);
d2 = gen_pdft(x,mu,sigma,nu);
F2 = gen_cdft(x,mu,sigma,nu);

nu = 2; 
{theta,stderr,Mcov,LogL} = regML(0,0,&ml_t,sv,0,0);
mu = theta[1];
sigma = sqrt(theta[2]^2);
d3 = gen_pdft(x,mu,sigma,nu);
F3 = gen_cdft(x,mu,sigma,nu);

{d4,F4} = regKernelDensity(R,x);

graphset;
  begwind;
  window(2,2,1);

    _pdate = ""; _pnum = 2; _pframe = 0;
    ylabel("\216PDF");
    xlabel("\216Rendement (en %)");
    xtics(-10,10,2,1);
    ytics(0,0.20,0.05,2);
    _ptitlht = 0.25; _pnumht = 0.20; _paxht = 0.20;
    _pltype = 6; _plwidth = 10;

  setwind(1);
    _pcolor = 1;
    title("\216Distribution gaussienne");
    xy(x,d1);

  setwind(2);
    _pcolor = 2;
    title("\216Student t]4[");
    xy(x,d2);

  setwind(3);
    _pcolor = 3;
    title("\216Student t]2[");
    xy(x,d3);

  setwind(4);
    _pcolor = 4;
    title("\216Noyau gaussien");
    xy(x,d4);

    graphprt("-c=1 -cf=reg5.eps");

  endwind;