new;
library qam,pgraph,optmum;

PathName = "..\\data\\";
xlsFileName = "qam_stocks_weekly";

FileName = PathName $+ xlsFileName;
data = loadd(FileName);
vnames = "" $+ getname(FileName);

data = selif(data,(data[.,1] .>= 19900101) .and (data[.,1] .<= 20091231));

Dates = data[.,1];

let string selected_names[5,1] = "cac 40"; 
indx = indsav(selected_names,vnames);
data = data[.,indx];

Bench = data[.,1];

R = 100*packr(Bench./lag(Bench) - 1);

x = seqa(-20,20/200,201);
mu = meanc(R);
sigma = stdc(R);
sv = mu|sigma;

n = 52;

d1 = pdfn((x - mu)/sigma)/sigma;
F1 = cdfn((x - mu)/sigma);
d1_min = n*(1 - F1)^(n-1) .* d1;

declare matrix nu; 
fn gen_pdft(x,mu,sigma,nu) = pdft((x - mu)/sigma,nu)/sigma;
fn gen_cdft(x,mu,sigma,nu) = cdft((x - mu)/sigma,nu);

proc (1) = ml_t(theta);
  local mu,sigma,logl;
  mu = theta[1];
  sigma = sqrt(theta[2]^2);
  logl = ln(gen_pdft(R,mu,sigma,nu));
  retp(logl);
endp;

nu = 4;
{theta,stderr,Mcov,LogL} = regML(0,0,&ml_t,sv,0,0);
mu = theta[1];
sigma = sqrt(theta[2]^2);
d2 = gen_pdft(x,mu,sigma,nu);
F2 = gen_cdft(x,mu,sigma,nu);
d2_min = n*(1 - F2)^(n-1) .* d2;

nu = 2; 
{theta,stderr,Mcov,LogL} = regML(0,0,&ml_t,sv,0,0);
mu = theta[1];
sigma = sqrt(theta[2]^2);
d3 = gen_pdft(x,mu,sigma,nu);
F3 = gen_cdft(x,mu,sigma,nu);
d3_min = n*(1 - F3)^(n-1) .* d3;

{d4,F4} = regKernelDensity(R,x);
d4_min = n*(1 - F4)^(n-1) .* d4;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  ylabel("\216PDF");
  xlabel("\216R]1:52[ (en %)");
  xtics(-20,0,2,1);
  _pltype = 6|1|3|5; _plwidth = 10;
  _pcolor = 1|2|3|4;
  _plegstr = "N(0,1)\000t]4[\000t]2[\000Noyau";
  _plegctl = {2 5 2 5};
  graphprt("-c=1 -cf=reg6.eps");
  xy(x,d1_min~d2_min~d3_min~d4_min);
