new;
library qam,pgraph,optmum;

rndseed 123;

__output = 0;

n = 2000;
x = rndu(n, 1);
y = rndu(rows(x),1) .* (cos(2*pi*X-pi)+1);

p = 50;
xstar = seqa(0,1/(p-1),P);

y0 = 0.5*(cos(2*pi*xstar-pi)+1);
y1 = regKernel(y,x,1,0,0,xstar);
y2 = regKernel(y,x,3,0,0,xstar);

tau = 0.95;

q0 = tau*(cos(2*pi*xstar-pi)+1);
q1 = regKernelQuantile(y,x,tau,1,xstar);
q2 = regKernelQuantile(y,x,tau,2,xstar);

data = y0~y1~y2~q0~q1~q2;

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9,6.855,0,0,1);

  fonts("simplex simgrma");

  setwind(1);
    _pdate = 0; _pframe = 0; _pnum = 2;
    _plctrl  = 0|5|5|0|5|5; _pltype  = 6|3|3|6|3|3; _plwidth = 10;
    _pstype = 8|8|9|10|10|11; _pcolor = 1|2|3|4|5|6;
    xlabel("\216x"); ylabel("\216y");
    ytics(0,2,0.5,1);
    xtics(0,1,0.2,1);
    _plegstr = "m(x)\000m(x) (p = 1)\000m(x) (p = 3)\000q(x;\202a\201)\000q(x;\202a\201) (p = 1)\000q(x;\202a\201) (p = 2)";
    _plegctl = {2 4 6.5 5.25};
    xy(xstar,data);
    _plegctl = 0;
	  
  setwind(2);  
    _plctrl  = -1; _pstype  = 3; _psymsiz = 0.5; _pcolor = 7;  
   xy(x,y);

    graphprt("-c=1 -cf=reg7.eps");

  endwind;