new;
library qam,pgraph,optmum;

#include cppi.src;

rndseed 123;

mu = 0.00;

sigma = 0.20;
m_vector = seqa(1,1,20);
n_M = rows(m_vector);

S0 = 100;
Maturity = 5;
t = seqa(0,1/365,Maturity*365+1);
nT = rows(t);
t[nT] = Maturity;

V0 = 100;
G = 95;
r = 0.05;

nS = 5000;

dt_vector = seqa(1,1,100);
n_dt = rows(dt_vector);

Pr = zeros(n_M,n_dt);
Cost = zeros(n_M,n_dt);

St = simulate_GBM(S0,mu,sigma,t,nS);

j = 1;
do until j > n_M;
  m = m_vector[j];

  i = 1;
  do until i > n_dt;
    dt = dt_vector[i];
	indx = seqa(1,dt,floor(nT/dt))|nT;
    {F,V,D,tau,Loss} = cppi_simulate(r,m,V0,G,Maturity,t[indx],St[indx,.]);
    Pr[j,i] = meanc(D);

	if sumc(D) == 0;
	  Cost[j,i] = 0;
	else;
  	  Cost[j,i] = -sumc(Loss)/sumc(D);
    endif;
	i = i + 1;
  endo;
  print /flush ftos(j,"Iteration no. %lf",1,0);
  j = j + 1;
endo;

Cost = missrv(Cost,0);
Pr = missrv(Pr,0);

save cppi10-pr = Pr;
save cppi10-cost = Cost;

