new;
library qam,pgraph,optmum;

let sigma_vector = 0.15 0.20 0.25 0.30;
dt_vector = seqa(1,1,100);
m_vector = seqa(1,1,20);

loadm Pr9 = cppi9-pr;
loadm Cost9 = cppi9-cost;

loadm Pr10 = cppi10-pr;
loadm Cost10 = cppi10-cost;

Pr9[2,.] = 0.5 * Pr9[2,.] + 0.5 * Pr10[5,.];
Pr10[5,.] = Pr9[2,.];

Cost9[2,.] = 0.5 * Cost9[2,.] + 0.5 * Cost10[5,.];
Cost10[5,.] = Cost9[2,.];

Pr = Pr9';
Cost = Cost9';
x = dt_vector;
y = sigma_vector;

nX = rows(x);
nY = rows(y);

PrSmooth = zeros(nx,nY);
CostSmooth = zeros(nX,nY);

i = 1;
do until i > nY;
  prSmooth[.,i] = fspline(csspline(x,Pr[.,i],1,0.01),x);
  costSmooth[.,i] = fspline(csspline(x,Cost[.,i],1,0.0005),x);
  i = i + 1;
endo;

PrSmooth = PrSmooth .* (PrSmooth .>= 0);
costSmooth = costSmooth .* (costSmooth .>= 0);

x1 = x; y1 = 100*PrSmooth; z1 = CostSmooth;

Pr = Pr10';
Cost = Cost10';
x = dt_vector;
y = m_vector;

nX = rows(x);
nY = rows(y);

PrSmooth = zeros(nx,nY);
CostSmooth = zeros(nX,nY);

i = 1;
do until i > nY;
  prSmooth[.,i] = fspline(csspline(x,Pr[.,i],1,0.01),x);
  costSmooth[.,i] = fspline(csspline(x,Cost[.,i],1,0.0005),x);
  i = i + 1;
endo;

PrSmooth = PrSmooth .* (PrSmooth .>= 0);
costSmooth = costSmooth .* (costSmooth .>= 0);

x2 = x; y2 = 100*PrSmooth; z2 = CostSmooth;

graphset;
  begwind;
  window(2,2,0);
  makewind(9/2,6.855/2,9/4,0,1);
 
  _pdate = ""; _pframe = 0; _pnum = 2;
  _paxht = 0.25; _pnumht = 0.225; _ptitlht = 0.30;
  _plwidth = 10; _pltype = 6|1|3|5; _pcolor = 1|2|4|5;
  fonts("simplex simgrma");

  setwind(1);
    title("\216Pr{C]t[ < 0}");
    xlabel("\216dt");
    xtics(0,100,20,2);
    ytics(0,80,20,2);
    xy(x1,y1);

  setwind(2);
    title("\216Risque de gap");
    ytics(0,3,1,2);
    _plegstr = "\202s\201 = 15%\000\202s\201 = 20%\000\202s\201 = 25%\000\202s\201 = 30%";
    _plegctl = {2 6 1 3};
    xy(x1,z1);
    _plegctl = 0;

   let indx = 2 5 7 10;

  setwind(3);
    title("\216Pr{C]t[ < 0}");
    ytics(0,80,20,2);
    xy(x2,y2[.,indx]);

  setwind(4);
    title("\216Risque de gap");
    ytics(0,3,1,2);
    _plegstr = "m = 2\000m = 5\000m = 7\000m = 10";
    _plegctl = {2 6 1 3};
    xy(x2,z2[.,indx]);
    _plegctl = 0;

    graphprt("-c=1 -cf=cppi11.eps");
  
endwind;
