new;
library qam,pgraph,optmum,option;

r = 0.05;

tau = 5;
V0 = 100;
alpha = 0.90;

X0 = 100;
S0 = 100;
Ns = 1;

nT = 101;
t = seqa(0,tau/(nT-1),nT);

rho = -0.50;
m = 5;

rndseed 123;
mu_X = 0.05;
sigma_X = 0.20;
mu_S = 0.10;
sigma_S = 0.20;

{Xt,St} = simulate_GBM2(X0,S0,mu_X,mu_S,sigma_X,sigma_S,rho,t,nS);
{V_SC,V_LS,C_SC,C_LS} = Core_Satellite_Simulate(r,m,V0,alpha,t,Xt,St);

XS1 = Xt~St;
C1 = C_LS~C_SC;
V1 = V_LS~V_SC;

rho = 0.90;

rndseed 123456;
mu_X = 0.05;
sigma_X = 0.20;
mu_S = 0.10;
sigma_S = 0.20;

{Xt,St} = simulate_GBM2(X0,S0,mu_X,mu_S,sigma_X,sigma_S,rho,t,nS);
{V_SC,V_LS,C_SC,C_LS} = Core_Satellite_Simulate(r,m,V0,alpha,t,Xt,St);

XS2 = Xt~St;
C2 = C_LS~C_SC;
V2 = V_LS~V_SC;

graphset;
  begwind;
  window(2,3,0);

  _pframe = 0; _pdate = ""; _pnum = 2;
  _pltype = 6|1|3; _plwidth = 10;
  _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.30;
  xtics(0,5,1,0);
  xlabel("\216t");

  setwind(1);
    _pcolor = 1|2;
    _plegstr = "X]t[\000S]t[";
    _plegctl = {2 7 1.5 5.25};
    ytics(80,200,20,2);
    xy(t,XS1);

  setwind(2);
    _pcolor = 2|3;
    _plegstr = "C[LS]]t[\000C]t[";
    ytics(0,25,5,2);
    xy(t,C1);

  setwind(3);
    _pcolor = 4|5;
    _plegstr = "V[LS]]t[\000V]t[";
    ytics(80,180,20,2);
    xy(t,V1);

  setwind(4);
    _pcolor = 1|2;
    _plegstr = "X]t[\000S]t[";
    ytics(80,220,20,2);
    xy(t,XS2);

  setwind(5);
    _pcolor = 2|3;
    _plegstr = "C[LS]]t[\000C]t[";
    ytics(0,80,20,2);
    xy(t,C2);

  setwind(6);
    _pcolor = 4|5;
    _plegstr = "V[LS]]t[\000V]t[";
    ytics(80,200,20,2);
    xy(t,V2);

    graphprt("-c=1 -cf=cppi15.eps");

  endwind;
