new;
library qam,pgraph,optmum;

V0 = 100;
r = 0.05;
mu = 0.10;
S0 = 100;
T = 5;
sigma = 0.20;
tau = T;
S = seqa(1,1,501);
pdf_S =  pdfln(S,ln(S0) + (mu-0.5*sigma^2)*T,sigma .* sqrt(T));

G = 100;
C0 = V0 - G*exp(-r*T);

m = 0.5~1~5;
C = seqa(1,1,100);
pdf_C =  cppi_pdf(r,mu,sigma,T,C0,m,C);

V = G + C;
pdf_V = pdf_C;

graphset;
  window3u;

    _pdate = ""; _pnum = 2; _pframe = 0;
    _plwidth = 10; _pcolor = 1|2|4; _pltype = 6|1|3;
    _pnumht = 0.225; _paxht = 0.225; _ptitlht = 0.275;
    _pysci = 0;

  setwind(1);
    xtics(0,500,100,2);
    xlabel("\216S]T[");
    xy(S,pdf_S);

  setwind(2);
    xtics(0,100,20,2);
    xlabel("\216C]T[");
    xy(C,pdf_C);

  setwind(3);
    xtics(100,200,20,2);
    xlabel("\216V]T[");
    _plegstr = "m = 0,5\000m = 1\000m = 5";
    _plegctl = {2 6.0 5.5 3};
    xy(V,pdf_V);

    graphprt("-c=1 -cf=cppi4.eps");

  endwind;