new;
library qam,optmum,pgraph;

rndseed 123;

V0 = 100;
S0 = 100;
mu = 0.10; 
sigma = 0.20;
tau = 5;
r = 0.05;
m = 5;

G = 100;
F0 = G * exp(-r*tau);
t = seqa(0,5/100,101);
Ft = F0 .* exp(r*t);

C0 = V0 - F0;

nS = 1;
St = simulate_GBM(S0,mu,sigma,t,nS);
Ct = cppi_compute(r,mu,sigma,t,C0,m,S0,St);
et = m * Ct;

Vt = Ft + Ct;

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pltype = 6|1; _pcolor = 1|4;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.30;
  xtics(0,5.0,1.0,2);

  setwind(1);   
    _pcolor = 1;
    title("\216S]t[");
    ytics(80,180,20,2);
    xy(t,St);

  setwind(2);
    _pcolor = 2;
    title("\216C]t[");
    ytics(0,35,5,2);
    xy(t,Ct);

  setwind(3);
    _pcolor = 3;
    title("\216e]t[");
    ytics(0,200,50,2);
    xy(t,et);

  setwind(4);
    _pcolor = 4|5;
    title("\216V]t[");
    ytics(70,120,10,2);
    _plegstr = "V]t[\000F]t[";
    _plegctl = {2 6 7 1};
    xy(t,Vt~Ft);

    graphprt("-c=1 -cf=cppi6.eps");

  endwind;
