new;
library qam,pgraph,optmum;

rndseed 123;

mu = 0.00;

sigma_vector = seqa(0.05,0.01,46);
nSigma = rows(sigma_vector);
m_vector = seqa(1,1,15);
nM = rows(m_vector);

S0 = 100;
Maturity = 5;
t = seqa(0,1/365,Maturity*365+1);
nT = rows(t);
t[nT] = Maturity;

V0 = 100;
G = 95;
r = 0.05;

nS = 5000;

dt = 30;
Pr = zeros(nSigma,nM);
Cost = zeros(nSigma,nM);

/*

j = 1;
do until j > nSigma;
  sigma = sigma_vector[j];

  St = simulate_GBM(S0,mu,sigma,t,nS);

  i = 1;
  do until i > nM;
    m = m_vector[i];
	indx = seqa(1,dt,floor(nT/dt))|nT;
    {F,V,D,tau,Loss} = cppi_simulate(r,m,V0,G,Maturity,t[indx],St[indx,.]);
    Pr[j,i] = meanc(D);

	if sumc(D) == 0;
	  Cost[j,i] = 0;
	else;
  	  Cost[j,i] = -sumc(Loss)/sumc(D);
    endif;
	i = i + 1;
  endo;
  print /flush ftos(j,"Iteration no. %lf",1,0);
  j = j + 1;
endo;

Cost = missrv(Cost,0);
Pr = missrv(Pr,0);

save cppi8-pr = Pr;
save cppi8-cost = Cost;
*/
loadm Pr = cppi8-pr;
loadm Cost = cppi8-cost;

Threshold = 0.05;

y = miss(zeros(nM,1),0);

i = 1;
do until i > nM;
  indx = indexcat(Pr[.,i],threshold|1);
  if indx /= error(0);
	y[i] = sigma_vector[minc(indx)];
  endif;
  i = i + 1;
endo;


let indx = 2 5 10 15;
PrSmooth = zeros(nSigma,rows(indx));
CostSmooth = zeros(nSigma,rows(indx));

i = 1;
do until i > rows(indx);
  prSmooth[.,i] = fspline(csspline(sigma_vector,Pr[.,indx[i]],1,0.9999),sigma_vector);
  costSmooth[.,i] = fspline(csspline(sigma_vector,Cost[.,indx[i]],1,0.999),sigma_vector);
  i = i + 1;
endo;

PrSmooth = PrSmooth .* (PrSmooth .>= 0);
costSmooth = costSmooth .* (costSmooth .>= 0);

m2_vector = seqa(0,1/10,200);
y = fspline(csspline(m_vector[3:rows(m_vector)],y[3:rows(m_vector)],1,0.99),m2_vector);

graphset;
  begwind;
  makewind(9/2,6.855/2,0,6.855/2,1);
  makewind(9/2,6.855/2,9/2,6.855/2,1);
  makewind(9/2,6.855/2,9/4,0,1);
 
  _pdate = ""; _pframe = 0; _pnum = 2;
  _paxht = 0.25; _pnumht = 0.225; _ptitlht = 0.30;
  _plwidth = 10; _pltype = 6|1|3|5; _pcolor = 1|2|4|5;
  fonts("simplex simgrma");

  setwind(1);
    title("\216Pr{C]t[ < 0}");
    xlabel("\216\202s\201");
    xtics(0,0.5,0.10,2);
    ytics(0,100,20,2);
    xy(sigma_vector,100*PrSmooth);

  setwind(2);
    title("\216Risque de gap");
    ytics(0,6,1,2);
    _plegstr = "m = 2\000m = 5\000m = 10\000m = 15";
    _plegctl = {2 6 1 3};
    xy(sigma_vector,costSmooth);
    _plegctl = 0;

  setwind(3);
    title("\216Pr{C]t[ < 0} = 5%");
    ylabel("\216\202s\201");
    xlabel("\216m");
    ytics(0,0.5,0.10,2);
    xtics(0,15,3,2);
    xy(m2_vector,y);
    graphprt("-c=1 -cf=cppi8.eps");

endwind;
 