new;
library qam,pgraph,optmum,gdr;

_sqp_PrintIters = 0;
_sqp_MaxIters = 2000;
__output = 0;

proc (1) = _ERC_LongShort_Fn(x);
  local n,Sigma,rc,dev;

  n = rows(x)/2;
  Sigma = _Risk_Budgeting_cov;
  rc = x .* (Sigma*x);
  rc = rc[1:n] + rc[1+n:2*n];

  dev = sumc(vec(rc - rc')^2);

  retp(dev);
endp;

n = 5;
let sigma = 0.10 0.40 0.30 0.10 0.30 
            0.20 0.20 0.20 0.50 0.20;

let rho_inter = 1
                0.6 1
                0.6 0.6 1
                0.6 0.6 0.6 1;
let rho_intra = 0.80 0.70 0.65 0.90;
let indx_sector = 1 2 3 4 4 1 2 3 4 4;

factor = 1;
rho = Compute_Factor_Correlation(rho_inter/factor,rho_intra/factor,indx_sector);

vol_target = 0.10;
alpha = 0.50;

/*
**> 1st Problem
**
*/

cov = sigma .* sigma' .* rho;
_Risk_Budgeting_cov = Cov;  

e = ones(n,1)|-ones(n,1);
x0 = 0.20 * e;
Bounds = (0~5) .* (e .== 1) + (-5~0) .* (e .== -1);

/*
**> 2nd Problem
**
*/

_sqp_A = eye(n)~eye(n); 
_sqp_A =_sqp_A | (1~zeros(1,2*n-1));
_sqp_B = zeros(n,1)  | alpha;

{x,fmin,grd,retcode} = sqpsolve(&_ERC_LongShort_Fn,x0);
{vol,mr,tr,rc} = Compute_Risk_Contribution_LS(x,cov);
c = vol_target/vol;
x = c*x;
{vol,mr,tr,rc} = Compute_Risk_Contribution_LS(x,cov);

print "--------------------------------";
print ftosa(seqa(1,1,n)~reshape(x,2,n)'~rc,"%lf",3,3);

/*
**> 3rd Problem
**
*/

{x,vol,mr,tr,rc} = Compute_EMN_Portfolio(0,cov,vol_target,0);
print "--------------------------------";
print ftosa(seqa(1,1,n)~100*x~mr~tr~100*rc,"%lf",3,3);

results = seqa(1,1,n)~100*(x~tr~rc);

{x,vol,mr,tr,rc} = Compute_EMN_Portfolio(0,cov,vol_target,1);
print "--------------------------------";
print ftosa(seqa(1,1,n)~100*x~mr~tr~100*rc,"%lf",3,3);

results = results~100*(x~tr~rc);
print "--------------------------------";
print ftosa(results,"%lf",3,1);


