new;
library qam,optmum,pgraph;

let params = 0.05 -0.05 0.06 10;

R1 = NelsonSiegel_SpotRate(params,1);

Coupon = 5;
Notionel = 100;

max_nt = 20;
P = zeros(max_nt,1);
dR = miss(zeros(max_nt,1),0);

// en t = 0

i = 2;
do until i > max_nt;

  nt = i;

  t = seqa(1,1,nt);
  Ct = Coupon * ones(nt,1);
  Ct[nt] = Notionel + Ct[nt];
  Rt = NelsonSiegel_SpotRate(params,t);
  t0 = t; Ct0 = Ct; Rt0 = Rt;

  t = seqa(1,1,nt-1);
  Ct = Coupon * ones(nt-1,1);
  Ct[nt-1] = Notionel + Ct[nt-1];
  Rt = NelsonSiegel_SpotRate(params,t);
  t1 = t; Ct1 = Ct; Rt1 = Rt;

  proc Excess_Return(dR);
    local P0,P1,Riding,ER;

    P1 = Bond_Compute_Price(t1,Ct1,Rt1+dR);
    P0 = Bond_Compute_Price(t0,Ct0,Rt0);
    Riding = (P1 + Coupon)./P0 - 1.0;
    ER = Riding - R1;

    retp(ER^2);
  endp;

  {x,grd,fmin,retcode} = optmum(&Excess_Return,0.0);
  dR[i] = x;

  i = i + 1;
endo;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1;
  xtics(0,15,1,0);
  ytics(0,100,10,2);
  xlabel("\216Maturite (en annees)"); 
  _pmsgstr = "-\000-";
  _pmsgctl = 4.29~0.30~0.07~45~2~0~6 |
             5.44~0.30~0.07~45~2~0~6 ;
  graphprt("-c=1 -cf=ir13.eps");
  xy(0,1e4*dR);
