new;
library qam,optmum,pgraph;

#include ir.params

tau = seqa(0.001,0.10,301);

SpotRate = NelsonSiegel_SpotRate(params,tau);
m = 1;
ForwardRate = NelsonSiegel_ForwardRate(params,tau,m);
Roll_Down = missex(NelsonSiegel_ForwardRate(params,tau,m) - NelsonSiegel_ForwardRate(params,tau-1,m),tau .<= 1);

let x = 5 4;
y = NelsonSiegel_ForwardRate(params,x,m);

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9/2,6.855/2,4,3,1);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|4|2;

  setwind(1);
    xlabel("\216Maturite (en annees)"); 
    xtics(0,20,2,12);
    ytics(0,1,0.25,2);
    _pmsgstr = "-\000-";
    _pmsgctl = 4.33~0.30~0.07~45~2~0~6 |
               5.48~0.30~0.07~45~2~0~6 ;
    bar(tau,100*Roll_Down);

  setwind(2);
    _paxht = 0.22; _pnumht = 0.20; _pgrid = {3,0};
    ytics(0,6,1,2);
    _pmsgctl = 4.05~0.35~0.09~45~2~0~6 |
               5.70~0.35~0.09~45~2~0~6 ;
    _psym = x~100*y~ones(2,1).*(8~5~12~1~10);
    _pmsgstr = _pmsgstr $+ "\000A\000B";
    _pmsgctl = _pmsgctl |
               0.95*x[1]~107*y[1]~0.3~0~1~12~8 |
               0.70*x[2]~100*y[2]~0.3~0~1~12~8 ;
    _parrow = 1.05*x[1]~95*y[1]~1.00*x[2]~90*y[2]~4~0.20~01~12~1~6~10;
 
    xy(tau,100*ForwardRate);

    graphprt("-c=1 -cf=ir14.eps");

  endwind;




