new;
library qam,pgraph,optmum;

cls;

#include ir.params

_Bond_Continuous_Time = 0;

nt = 2;
t = seqa(1,1,nt);
Ct = 5 * ones(nt,1);
Ct[nt] = 100 + Ct[nt];
t1 = t; C1 = Ct;

nt = 5;
t = seqa(1,1,nt);
Ct = 5 * ones(nt,1);
Ct[nt] = 100 + Ct[nt];
t2 = t; C2 = Ct;

nt = 10;
t = seqa(1,1,nt);
Ct = 5 * ones(nt,1);
Ct[nt] = 100 + Ct[nt];
t3 = t; C3 = Ct;

fn Bond_Price(t,Ct,params) = Bond_Compute_Price(t,Ct,NelsonSiegel_SpotRate(params,t));

t = t1; Ct = C1;
P = Bond_Price(t,Ct,params);
YTM = Bond_Compute_YTM(t,Ct,P);
D = Bond_Compute_Duration(t,Ct,YTM);
P1 = P; YTM1 = YTM; D1 = D;

t = t2; Ct = C2;
P = Bond_Price(t,Ct,params);
YTM = Bond_Compute_YTM(t,Ct,P);
D = Bond_Compute_Duration(t,Ct,YTM);
P2 = P; YTM2 = YTM; D2 = D;

t = t3; Ct = C3;
P = Bond_Price(t,Ct,params);
YTM = Bond_Compute_YTM(t,Ct,P);
D = Bond_Compute_Duration(t,Ct,YTM);
P3 = P; YTM3 = YTM; D3 = D;

data = P1~100*YTM1~D1 |
       P2~100*YTM2~D2 |
       P3~100*YTM3~D3 ;

print ftosa(data,"%lf",3,2);

DV01 = D1|D2|D3;
Tau = 2|5|10;
Price = P1|P2|P3;

beta = 0.5;

{n1,n2,n3,n4} = Barbell_Calibrate(DV01,Price,Tau,beta);
n1 = 100*n1; n2 = 100*n2; n3 = 100*n3; n4 = 100*n4;
n = n1~n2~n3~n4;
print ftosa(n,"%lf",3,1);

let Scenarios[6,3] =  30  30  30
                     -30 -30 -30
                     -30   0  30
                      30   0 -30
                     -30   0  15
                      30   0 -15;

Scenarios = Scenarios/1e4;
nScenarios = rows(Scenarios);
PnL = zeros(nScenarios,4);

i = 1;
do until i > nScenarios;
  dR = Scenarios[i,.]';
  x = sumc(n .* DV01 .* dR);
  PnL[i,.] = x';
  i = i + 1;
endo;

str = strCombine(itos("",1e4*Scenarios),"/",0);
print str$~ftosa(PnL,"%lf",3,2);



               