new;
library qam,pgraph,optmum;

cls;

_Bond_Continuous_Time = 0;

nt = 10;
t = seqa(1,1,nt);
Ct = 5 * ones(nt,1);
Ct[nt] = 100 + Ct[nt];

let params = 0.035 -0.03 0.10 3;
Rt = NelsonSiegel_SpotRate(params,t);

P = Bond_Compute_Price(t,Ct,Rt);
YTM = Bond_Compute_YTM(t,Ct,P);
D = Bond_Compute_Duration(t,Ct,YTM);

print ftosa(P~100*YTM~D,"%lf",1,2);

dR = seqa(-5,2.5,5);
dR = dR/1000;
n = rows(dR);

Results = zeros(n,5);

i = 1;
do until i > n;
  P1 = Bond_Compute_Price(t,Ct,Rt + dR[i]);
  G1 = P1 - P;

  P2 = Bond_Compute_Price(t,Ct,YTM + dR[i]);
  G2 = P2 - P;

  G3 = D .* dR[i];

  Results[i,.] = P1~G1~P2~G2~G3;

  i = i + 1;
endo;

print ftosa(Results,"%lf",1,2);




