new;
library qam,pgraph,optmum;

cls;

proc (1) = Compute_Weights(S0,alpha,b,sigma,t);
  local f,x,vol,w;

  f = exp(-alpha .* t);
  x = (S0 - b) .* (1 - f);
  vol = sigma .* sqrt( (1 - f .* f)./(2*alpha) );

  w = 1 - 2 * cdfn(x./vol);

  retp(w);
endp;

S0 = seqa(0,200/100,101);
a = 1;
b = 100;
sigma = 10;

t = 1/12~6/12;
w = Compute_Weights(S0,a,b,sigma,t);

graphset;
  fonts("simplex simgrma");

  _pdate = ""; _pframe = 0; _pnum = 2; 
  _plwidth = 10; _pcross = 1; _pltype = 6|3; 
  _pcolor = 1|3;

  xtics(40,160,20,2);
  ytics(-1,1,0.25,2);
  xlabel("\216S]t[");
  _plegstr = "\202D\201]t[ = 1 mois\000\202D\201]t[ = 6 mois";
  _plegctl = {2 5 6 4.5};
  graphprt("-c=1 -cf=momentum13.eps");

  xy(S0,w);

