new;
library qam,pgraph,optmum;

cls;

proc (1) = Compute_Weights(S0,alpha,b,sigma,delta_t);
  local f,x,vol,w;

  f = exp(-alpha .* delta_t);
  x = (S0 - b) .* (1 - f);
  vol = sigma .* sqrt( (1 - f .* f)./(2*alpha) );

  w = 1 - 2 * cdfn(x./vol);

  retp(w);
endp;

a = 0.5;
sigma = 10;
b = 100;
tau = 10;
nDays_in_Year = 264;

nS = 100;
aVector = 0.001|seqa(0.1,0.1,50);
nIters = rows(aVector);
sigmaVector = 10;
nIters = rows(aVector)|rows(sigmaVector);

Sharpe = zeros(nIters[1],nIters[2]);

iter1 = 1;
do until iter1 > nIters[1];
  a = aVector[iter1];
  iter2 = 1;
  do until iter2 > nIters[2];
    sigma = sigmaVector[iter2];
    nt = nDays_in_Year*(tau+1)+1;
    rndseed 123;
    if iter1 == 1;
      St = recserar(sigma*rndn(nt,nS),b.*ones(1,nS),ones(1,nS));
    else;
      {t,St} = Simulate_OU(b,a,b,sigma,0,tau,nt,nS);
    endif;

    Delta = 1/nDays_in_Year;

    nDays = nDays_in_Year * Delta;
    wt = Compute_Weights(St,a,b,sigma,Delta);

    Rt = wt .* (lagn(St,-nDays) - St) ./ St;
    Rt = trimr(Rt,0,nDays_in_Year);
    Ft = 100*cumprodc(1 + Rt);

    mu = (Ft[nDays_in_Year*tau+1,.]'/100)^(1/tau) - 1.0;
    vol = stdc(Rt)*sqrt(1/Delta);
    Sharpe[iter1,iter2] = meanc(mu./vol);
    iter2 = iter2 + 1;
  endo;

  iter1 = iter1 + 1;
endo;

Sharpe[1] = 0.0;

a = seqa(0,5/100,101);
sh = fspline(csspline(aVector,Sharpe,1,0.9999),a);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1;
  xtics(0,5,1,0);
  xlabel("\216a");
  ytics(0,1.5,0.25,2);
  graphprt("-c=1 -cf=momentum14.eps");
  xy(a,Sh);
