new;
library qam,pgraph,optmum;

PathName = "..\\Data\\";
datFileName = PathName $+ "qam_dataset2";
data = loadd(datFileName);
vnames = getname(datFileName);
Dates = data[.,1];

let selected_names = S&P STXX US_IG EUR_IG MSCI_W BarCap Euribor;
indx = indcv(selected_names,vnames);
Data = Data[.,indx];
Data = dates~Data;

Begin_Date = 19931231;
Last_Date = 20091231;

Data = selif(data,(Data[.,1] .>= Begin_Date) .and (Data[.,1] .<= Last_Date));

Dates = data[.,1]; 
nDates = rows(Dates);

Data = Data[.,2:cols(Data)];
Benchmark = Data[.,cols(Data)-2:cols(Data)];
Basket = Data[.,1:cols(Data)-3];
nBasket = cols(Basket);

Weights0 = ones(nDates,nBasket)/nbasket;

{cov,vol,cor} = Compute_Running_Covariance(Dates,Basket,260,2);
er_1Y = Basket./lagn(Basket,260) - 1;
Weights1 = Weights0;
Weights2 = Weights0;

A = ones(1,nBasket);
B = 1;
Bounds = ones(nBasket,1)/nBasket;
Bounds1 = Bounds .* (0.70~1.30);

Bounds2 = ones(nBasket,1) .* (0~1);

Months = trunc(Dates/100);
RD_Monthly = Months ./= lag1(Months);
RD_Monthly[1] = 1;

x0 = ones(nBasket,1)/nBasket;

TE_Target = 0.02;

t = 1;
do until t > nDates;

  if t > 260;
    cov_t = arraytomat(cov[t,.,.]);
    er_t = er_1Y[t-1,.]';
  else;
    t = t + 1;
    continue;
  endif;

  vol_star = sqrt(x0' * cov_t * x0);

  if RD_Monthly[t] == 0;
    x = Weights1[t-1,.]';
    weights1[t,.] = x';
  else;
    {x,mu,sigma,phi,retcode} = Qprog_Allocation_Solve(er_t,cov_t,A,B,0,0,Bounds1,1.00*vol_star,2);
    if (retcode == 0) and (ismiss(x) == 0);
      weights1[t,.] = x';
    else;
      weights1[t,.] = weights1[t-1,.];
    endif;
  endif;

  if RD_Monthly[t] == 0;
    x = Weights2[t-1,.]';
    weights2[t,.] = x';
  else;
    {x,mu,sigma,phi,retcode} = Qprog_TE_Solve(x0,cov_t,A,B,0,0,Bounds2,er_t,TE_Target);
    if (retcode == 0) and (ismiss(x) == 0);
      weights2[t,.] = x';
    else;
      weights2[t,.] = weights2[t-1,.];
    endif;
  endif;

  t = t + 1;
endo;

F1 = Compute_Monthly_Backtest(Dates,Weights1,Basket);

F2 = Compute_Monthly_Backtest(Dates,Weights2,Basket);

F0 = Compute_Monthly_Backtest(Dates,Weights0,Basket);

Data = Dates ~ F1 ~ F2 ~ F0;
Data = selif(Data, Data[.,1] .>= 19950101);
Funds = Data[.,2 3 4];
Funds = Funds./Funds[1,.] * 100;
nDates = rows(Funds);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|4|2;
  xtics(1,nDates,261*5,2);
  let xlab = "1995" "2000" "2005" "2010";
  asclabel(xlab,0);
  ytics(100,400,50,2);
  _plegstr = "Trend Following (#1)\000Trend Following (#2)\0001/n";
  _plegctl = {2 5 2 5};
  graphprt("-c=1 -cf=momentum2.eps");
  xy(0,Funds);
