new;
library qam,pgraph,optmum;

PathName = "..\\Data\\";
datFileName = PathName $+ "qam_dataset2";
data = loadd(datFileName);
vnames = getname(datFileName);
Dates = data[.,1];

// "Date" "S&P" "STXX" "TPX" "EM_EU" "EM_ASIA" "EM_LAT" "RICI" "US_HY" "EMBI" "US_IG" "EUR_IG" "Libor" "Euribor" "Tibor" "MSCI_W" "BarCap";

let selected_names = S&P STXX US_IG EUR_IG MSCI_W BarCap Euribor;
indx = indcv(selected_names,vnames);
Data = Data[.,indx];
Data = dates~Data;

Begin_Date = 19931231;
Last_Date = 20091231;

Data = selif(data,(Data[.,1] .>= Begin_Date) .and (Data[.,1] .<= Last_Date));

Dates = data[.,1]; 
nDates = rows(Dates);

Data = Data[.,2:cols(Data)];
Benchmark = Data[.,cols(Data)-2:cols(Data)];
Euribor = Benchmark[.,3];
Basket = Data[.,1:cols(Data)-3];
nBasket = cols(Basket);

Weights0 = ones(nDates,nBasket)/nbasket;

{cov,vol,cor} = Compute_Running_Covariance(Dates,Basket,260,2);
er_1Y = Basket./lagn(Basket,260) - 1;
Weights1 = Weights0;

A = ones(1,nBasket);
B = 0;
Bounds = (-0.5~0.5) .* ones(nBasket,1);

Months = trunc(Dates/100);
RD_Monthly = Months ./= lag1(Months);
RD_Monthly[1] = 1;

t = 1;
do until t > nDates;

  if t > 260;
    cov_t = arraytomat(cov[t,.,.]);
    er_t = er_1Y[t-1,.]';
  else;
    t = t + 1;
    continue;
  endif;

  if RD_Monthly[t] == 0;
    x = Weights1[t-1,.]';
    weights1[t,.] = x';
  else;
    {x,mu,sigma,phi,retcode} = Qprog_Allocation_Solve(er_t,cov_t,A,B,0,0,Bounds,0.04,2);
    if (retcode == 0) and (ismiss(x) == 0);
      weights1[t,.] = x';
    else;
      weights1[t,.] = weights1[t-1,.];
    endif;
  endif;

  t = t + 1;
endo;

R_Basket = Basket./lag1(Basket) - Euribor./lag1(Euribor);
R_Basket = missrv(R_Basket,0);
Basket_notFunded = 100 * cumprodc(1 + R_Basket);
Weights_Euribor = ones(nDates,1);

F1 = Compute_Monthly_Backtest2(Dates,Weights_Euribor,Euribor,Weights1,Basket_notFunded);

F2 = Euribor;

Data = Dates ~ F1 ~ F2;
Data = selif(Data, Data[.,1] .>= 19950101);
Funds = Data[.,2 3];
Funds = Funds./Funds[1,.] * 100;
nDates = rows(Funds);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 8|10; _pcolor = 1|4;
  xtics(1,nDates,261*5,2);
  let xlab = "1995" "2000" "2005" "2010";
  asclabel(xlab,0);
  ytics(100,350,50,2);
  _plegstr = "Trend Following\000Euribor";
  _plegctl = {2 5 2 5};
  graphprt("-c=1 -cf=momentum4.eps");
  xy(0,Funds);

