new;
library qam,pgraph,optmum;

#include option.src

let string option_strategy[6,2] = "call" "sell"
                                  "put"  "sell"
                                  "call" "buy"
                                  "put"  "buy"
                                  "call" "sell"
                                  "put"  "sell";

let Spread = 0 0 0 0 2 -3;
let Strike = 1.00 0.95 1.00 0.95 1.00 0.95;

nOption_Strategy = rows(option_strategy);
nStrike = rows(Strike);

nIters = nOption_Strategy;

_option_impvol = "bloom";

S = {};
Cash = {};

iter = 1;
do until iter > nIters;

  {tmp_Dates,tmp_S,tmp_Cash} = Option_Backtest(0,Strike[iter],option_strategy[iter,1],option_strategy[iter,2],Spread[iter]);

  S = S ~ tmp_S;
  Cash = Cash ~ tmp_Cash;

  iter = iter + 1;
endo;

all_data = tmp_dates~Cash[.,1]~S;
all_data = selif(all_data,all_data[.,1] .<= 20091231);
all_data = all_data[.,2:cols(all_data)];

nDates = rows(all_data);

dt = 5;
{t,data} = graph_smooth(0,all_data,1,dt,0);

pqgwin many;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|6*ones(nIters,1); _plwidth = 10; 
  _pcolor = 1|2|4; _plctrl = 0|250|250; _pstype = 8|8|9;
  _plctrl = _plctrl / dt;
  xtics(0,nDates,261,2);
  let xlab = "90" "91" "92" "93" "94" "95" "96" "97" "98" "99" "00" "01" "02" "03" "04" "05" "06" "07" "08" "09" "10";
  asclabel(xlab,0);
  _plegstr = "Fed Fund\000Short Call 100%\000Short Put 95%";
  _plegctl = {2 5 1 5};
  graphprt("-c=1 -cf=option10-1.eps");
  xy(t,data[.,1 2 3]);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|6*ones(nIters,1); _plwidth = 10; 
  _pcolor = 1|3|5; _plctrl = 0|250|250; _pstype = 8|8|9;
  _plctrl = _plctrl / dt;
  xtics(0,nDates,261,2);
  let xlab = "90" "91" "92" "93" "94" "95" "96" "97" "98" "99" "00" "01" "02" "03" "04" "05" "06" "07" "08" "09" "10";
  asclabel(xlab,0);
  _plegstr = "Fed Fund\000Long Call 100%\000Long Put 95%";
  _plegctl = {2 5 1 5};
  graphprt("-c=1 -cf=option10-2.eps");
  xy(t,data[.,1 4 5]);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|6*ones(nIters,1); _plwidth = 10; 
  _pcolor = 1|2|4; _plctrl = 0|250|250; _pstype = 8|8|9;
  _plctrl = _plctrl / dt;
  xtics(0,nDates,261,2);
  let xlab = "90" "91" "92" "93" "94" "95" "96" "97" "98" "99" "00" "01" "02" "03" "04" "05" "06" "07" "08" "09" "10";
  asclabel(xlab,0);
  _plegstr = "Fed Fund\000Short Call 100%\000Short Put 95%";
  _plegctl = {2 5 1 5};
  graphprt("-c=1 -cf=option10-3.eps");
  xy(t,data[.,1 6 7]);
