new;
library qam,pgraph,optmum;

#include option.src

let string option_strategy[4,2] = "call" "sell"
                                  "put"  "sell"
                                  "call" "buy"
                                  "put"  "buy";

let Spread = 0 0 0 0;
let Strike = 1.00 0.95 1.00 0.95;

nOption_Strategy = rows(option_strategy);
nStrike = rows(Strike);

nIters = nOption_Strategy;

_option_impvol = "bloom";

S = {};
Cash = {};

iter = 1;
do until iter > nIters;

  {tmp_Dates,tmp_S,tmp_Cash} = Option_Backtest(0,Strike[iter],option_strategy[iter,1],option_strategy[iter,2],Spread[iter]);

  S = S ~ tmp_S;
  Cash = Cash ~ tmp_Cash;

  iter = iter + 1;
endo;

all_data = tmp_dates~S;
all_data = selif(all_data,all_data[.,1] .<= 20091231);
all_data = all_data[.,2:cols(all_data)];

Rdt = all_data./lagn(all_data,1) - 1.0;
Rdt = packr(Rdt);

mu = meanc(Rdt);
sigma = stdc(Rdt);
Rdt = (Rdt-mu')./sigma';
x = seqa(-4,8/1000,1001);
d = zeros(rows(x),4);

i = 1;
do until i > 4;
  {d[.,i],F} = regKernelDensity(Rdt[.,i],x);
  i = i + 1;
endo;

d0 = pdfn(x);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pltype = 6~3; 
  _paxht = 0.22; _pnumht = 0.22; _ptitlht = 0.25;
 
  xtics(-4,4,1,2);
  ytics(0,0.75,0.25,2);
  i = 1;
  setwind(i);
    title("\216Short Call 100%");
    _pcolor = i~5;
    xy(x,d[.,i]~d0);

  ytics(0,1.25,0.25,2);
  i = 2;
  setwind(i);
    title("\216Short Put 95%");
    _pcolor = i~5;
    xy(x,d[.,i]~d0);

  ytics(0,0.75,0.25,2);
  i = 3;
  setwind(i);
    title("\216Long Call 100%");
    _pcolor = i~5;
    xy(x,d[.,i]~d0);

  ytics(0,1.25,0.25,2);
  i = 4;
  setwind(i);
    title("\216Long Put 95%");
    _pcolor = i~5;
    xy(x,d[.,i]~d0);

    graphprt("-c=1 -cf=option11.eps");

  endwind;