new;
library qam,pgraph,optmum;

S0 = 100;
let muVector =   -0.10 0.00 0.10 0.10;
let sigmaVector = 0.10 0.10 0.10 0.30;
tau = 0.25;

rndseed 123;

K = seqa(50,1,101);
Ns = 25000;
Pr = zeros(rows(K),rows(muVector));
Loss = zeros(rows(K),rows(muVector));

i = 1;
do until i > rows(muVector);
  mu = muVector[i];
  sigma = sigmaVector[i];
  vol_ATM = sigma;
  {ST,PnL_CC} = CoveredCall_Simulate(S0,mu,sigma,K',Vol_ATM,tau,0,0,Ns);
  PnL_S = ST - S0;
  diff_PnL = PnL_CC - PnL_S;
  Pr[.,i] = meanc(diff_PnL .>= 0);
  Loss[.,i] = meanc(diff_PnL);
  i = i + 1;
endo;

C = BS_Call(S0,K,sigmaVector',tau,0,0);
Pr2 = cdfn( ( ln((K+C)./S0) - (muVector' - 0.5 * sigmaVector' .* sigmaVector') .* tau ) ./ (sigmaVector' .* sqrt(tau) ) );

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(3.5,2.5,5.0,1.0,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|6; _plwidth = 10; _pstype = 8; _plctrl = 0|0|0|15;
  _pcolor = 0|1|2|3;
  _pgrid = {2,1};
  xtics(50,150,10,5);
  xlabel("\216K");

  setwind(1);
    ytics(0,100,20,2);
    _plegstr = "\202m\201=-10% - \202s\201=10%\000\202m\201=0% - \202s\201=10%\000\202m\201=10% - \202s\201=10%"\
               "\000\202m\201=10% - \202s\201=30%";
    _plegctl = {2 4 6 4.0};
    ylabel("\216Pr\202{\201PnL]CC[>PnL]S[\202}\201");
    xy(K,100*Pr2);

    _pgrid = 0; _plegctl = 0;
    ylabel("");

  setwind(2);
    _pbox = 0.0001; _paxht = 0.25; _pnumht = 0.20; _ptitlht = 0.30; 
    _psymsiz = 8.0;
    title("\216E\202@[\201PnL]CC[-PnL]S[\202@]\201");
    ytics(-2.7,2.7,0.9,1);
    xy(K,Loss);

    graphprt("-c=1 -cf=option21.eps");

  endwind;