new;
library qam,pgraph,optmum;

S0 = 100;
let muVector =   -0.10 0.00 0.10 0.10;
let sigmaVector = 0.10 0.10 0.10 0.30;
tau = 0.25;
n = 10;
alpha = 0;
rho = 0.0;

K = seqa(50,1,101);
Ns = 25000;
Pr = zeros(rows(K),rows(muVector));
Loss = zeros(rows(K),rows(muVector));
Vol_PnL_CC = zeros(rows(K),rows(muVector));
Vol_PnL_S = zeros(1,rows(muVector));

i = 1;
do until i > rows(muVector);

  mu = muVector[i];
  sigma = sigmaVector[i];
  vol_C = sigma;

  rndseed 123;
  {ST,PnL_CC} = CoveredCall_Simulate(S0,mu,sigma,K',Vol_C,tau,0,0,Ns);   
  PnL_S = ST - S0;
  diff_PnL = PnL_CC - PnL_S;
  Pr[.,i] = meanc(diff_PnL .>= 0);
  Loss[.,i] = meanc(diff_PnL);
  Vol_PnL_S[.,i] = stdc(PnL_S);
  Vol_PnL_CC[.,i] = stdc(PnL_CC);

  i = i + 1;
endo;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|6; _plwidth = 10; _pstype = 8; _plctrl = 0|0|0|15;
  _pcolor = 0|1|2|3; 
  xtics(60,140,10,5);
  xlabel("\216K");
  ytics(0,1,0.2,1);
  ylabel("\216\202s\202\34\201PnL]CC[\202\118\201/\202s\202\34\201PnL]S[\202\118\201");
  _plegstr = "\202m\201=-10% - \202s\201=10%\000\202m\201=0% - \202s\201=10%\000\202m\201=10% - \202s\201=10%"\
             "\000\202m\201=10% - \202s\201=30%";
  _plegctl = {2 5 6 2.0};
  graphprt("-c=1 -cf=option23.eps");
  xy(K,Vol_PnL_CC./Vol_PnL_S);

