new;
library qam,pgraph,optmum;

S0 = 100;
mu = 0.10;
sigma = 0.20;
let ImpVol_Vector = 0.20 0.25 0.30;
tau = 0.25;

nS = 25000;
nCols = rows(ImpVol_Vector);
Loss = zeros(nS,nCols);
EL = zeros(nCols,1);

x = seqa(-10,20/500,501);
n_x = rows(x);
d = zeros(n_x,nCols);
 
K = 110;

i = 1;
do until i > nCols;
  rndseed 123;
  vol_ATM = ImpVol_Vector[i];
  {ST,PnL_CC} = CoveredCall_Simulate(S0,mu,sigma,K,Vol_ATM,tau,0,0,Ns);
  PnL_S = ST - S0;
  diff_PnL = PnL_CC - PnL_S;
  Loss = diff_PnL;
  {d[.,i],F} = regKernelDensity(Loss,x);
  EL[i] = meanc(Loss);
  i = i + 1;
endo;
d1 = d;

K = 100;

i = 1;
do until i > nCols;
  rndseed 123;
  vol_ATM = ImpVol_Vector[i];
  {ST,PnL_CC} = CoveredCall_Simulate(S0,mu,sigma,K,Vol_ATM,tau,0,0,Ns);
  PnL_S = ST - S0;
  diff_PnL = PnL_CC - PnL_S;
  Loss = diff_PnL;
  {d[.,i],F} = regKernelDensity(Loss,x);
  EL[i] = meanc(Loss);
  i = i + 1;
endo;

d2 = d;

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(3.5,3,1.2,1.75,1);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pltype = 6|1|3; _pcolor = 0|1|2|3; 
  _plegstr = "\202S\201 = 20%\000\202S\201 = 25%\000\202S\201 = 30%";
  xlabel("\216PnL]CC[-PnL]S[");

  setwind(1);
    title("\216K = 110%");
    xtics(-10,7.5,2.5,0);
    ytics(0,0.5,0.1,2);
    _plegctl = {2 5 7 4.5};
    xy(x,d1);

  _plegctl = 0;
  _paxht = 0.22; _pnumht = 0.20; _ptitlht = 0.30;

  setwind(2);
    title("\216K = 100%");
    xtics(-5,10,2.5,0);
    ytics(0,0.20,0.05,2);
    xy(x,d2);

    graphprt("-c=1 -cf=option24.eps");

  endwind;
