new;
library qam,pgraph,optmum;

datFileName = "..\\data\\qam_dataset1";

Data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

Data = selif(Data,(Data[.,1] .>= 19891231) .and (Data[.,1] .<= 20091231));

Dates = Data[.,1];
nDates = rows(Dates);
let string selected_names = "SPX_TR" "BXM" "BXY";
indx = indsav(selected_names,vnames);
Data = Data[.,indx];
Data = Fill_Miss(Data,4);
Data = Data ./ Data[1,.] * 100;

SPTR = Data[.,1];
BXM = Data[.,2];
BXY = Data[.,3];

Data = (BXM~BXY)./SPTR;

graphset;
  begwind;
  window(1,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10;
  _ptitlht = 0.25; _pnumht = 0.22;
  xtics(1,252*20,252*5,2);
  let xlab = "1990" "95" "2000" "05" "10";
  asclabel(xlab,0);
  ytics(0.8,1.4,0.1,2);

  setwind(1);
    _pcolor = 1;
    title("\216BXM");
    xy(0,Data[.,1]);

  setwind(2);
    _pcolor = 4;
    title("\216BXY");
    xy(0,Data[.,2]);

    graphprt("-c=1 -cf=option25.eps");

  endwind;

Perf = (submat(SPTR~BXM~BXY,nDates,0)'/100)^(1/20) - 1.0;
print Perf';

data = SPTR~BXM~BXY;
Rdt = packr(data./lag1(data) - 1);
vol = stdc(Rdt)*sqrt(260);
print vol';

dt = 5;
Rdt = packr(Data./lagn(Data,dt) - 1);
rho = corrx(rdt);
print rho[1,.];

dt = 22;
Rdt = packr(Data./lagn(Data,dt) - 1);
rho = corrx(rdt);
print rho[1,.];
