new;
library option,pgraph,qam;

cls;

PathName = "..\\data\\";
datFileName = PathName $+ "qam_dataset1";
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

data = selif(data,data[.,1] .>= 20000101 .and data[.,1] .<= 20091231); 

let selected_names = "sx5e" "EUR_1M" "sx5e_vol";
indx = indsav(selected_names,vnames);
  
St = data[.,indx[1]];
St = St/St[1] * 100;
K = 100;
sigma = data[.,indx[3]];
r = data[.,indx[2]]/100; 
b = r;
et = etdays2(data[.,1],data[rows(data),1]);
tau = (et +1) / 360;

Delta = EuropeanBS_Delta(St,K,Sigma,tau,b,r);

nobs = rows(Delta);
step = 5;
indx_step = seqa(1,step,nobs/step);

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9/3,6.855/3,3.5,4.25,1);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10;

  xtics(0,10*260/step,2*260/step,1);
  let xlab = "2000" "02" "04" "06" "08" "10";
  asclabel(xlab,0);

  fonts("simplex simgrma");

  setwind(1);
    _pcolor = 1;
    ylabel("\216e]t[ (en %)");
    xlabel("\216t\201");
    ytics(0,100,20,2);
    xy(0,100*Delta[indx_step]);

  setwind(2);
    _pcolor = 4;
    _pnumht = 0.25; _paxht = 0.30; _paxht = 0.30;
    _pline = 1~3~0~100~4000~100~1~0~10;
    ylabel("\216S]t[");
    ytics(40,120,20,2);
    xy(0,St[indx_step]);

    graphprt("-c=1 -cf=option3.eps");

  endwind;
