new;
library qam,pgraph,optmum;

#include option.src

S0 = 100;
K_C = 1.03 * S0;
K_P = 0.93 * S0;
sigma = 0.30;
tau = 1.0;
dy = 0.00;
r = 0.00;

C = BS_Call(S0,K_C,sigma,tau,dy,r);
P = BS_Put(S0,K_P,sigma,tau,dy,r);

ST = seqa(80,0.1,451);
Pnl_S = ST - S0;
PnL = BullSpread_Payoff(ST,S0,K_C,C,K_P,P);

PnL_C = BullSpread_Payoff(K_C,S0,K_C,C,K_P,P);
PnL_P = BullSpread_Payoff(K_P,S0,K_C,C,K_P,P);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pcross = 1; _pltype = 6|3; _plwidth = 10; _pcolor = 2|1;
  xtics(80,120,5,5);
  ytics(-8,8,2,1);
  xlabel("\216S]T[");
  ylabel("\216PnL");
  _parrow = S0~0~S0~(C-P)~3~0.1~02~0~1~6~10;
  _pmsgstr = "C-P\000K]P[\000K]C[";
  _pmsgctl = 0.9975*S0~0.15*(C-P)~0.15~90~1~0~10 |
             K_P-0.7~0.25~0.15~0~1~0~10 |
             K_C-0.5~-0.75~0.15~0~1~0~10 ;
  _pline = 1~3~K_P~0~K_P~Pnl_P~1~0~10 |
           1~3~K_C~0~K_C~Pnl_C~1~0~10 ;
  _plegstr = "Bull Spread\000Position longue";
  _plegctl = {2 5 5 2};
  graphprt("-c=1 -cf=option30.eps");
  xy(ST,Pnl~PnL_S);