new;
library qam,pgraph,optmum;

#include option.src

S0 = 100;
K_C = 1.03 * S0;
K_P = 0.93 * S0;
sigma = 0.30;
tau = 1.0;
dy = 0.00;
r = 0.00;

mu = 0.10;
m1 = ln(S0) + (mu - 0.5*sigma^2)*tau;
m2 = sigma*sqrt(tau);

C = BS_Call(S0,K_C,sigma,tau,dy,r);
P = BS_Put(S0,K_P,sigma,tau,dy,r);

ST = seqa(50,0.1,1201);
PnL_S = ST - S0;
cdf_S = cdfn((ln(ST) - m1)/m2);

PnL_BS = BullSpread_Payoff(ST,S0,K_C,C,K_P,P);
cdf_BS = cdf_S;
cdf_BS = substute(cdf_BS,ST .< K_P, 0.0);
cdf_BS = substute(cdf_BS,ST .> K_C, 1.0);

min_PnL_BS = minc(PnL_BS);
max_PnL_BS = maxc(PnL_BS);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pcross = 0; _pltype = 6|1; _plwidth = 10; _pcolor = 2|1;
  xtics(-40,60,10,5);
  ytics(0,1.0,0.2,1);
  xlabel("\216PnL");
  _pline = 1~6~-50~0~min_PnL_BS~0~1~2~10 |
           1~6~max_PnL_BS~1~60~1~1~2~10 ;
  _plegstr = "Bull Spread\000Position longue";
  _plegctl = {2 5 6 2};
  graphprt("-c=1 -cf=option31.eps");
  xy(PnL_BS~PnL_S,cdf_BS~cdf_S);