new;
library qam,pgraph,optmum;

#include option.src

S0 = 100;
sigma = 0.30;
tau = 1/12;
dy = 0.00;
r = 0.00;

K_C = seqa(100,0.10,51);
nK = rows(K_C);
K_P = zeros(nK,1);

__eps = 1e-10;

_BullSpread_algo = 0;

i = 1;
do until i > nK;
  K_P[i] = BullSpread_ImpliedStrike(S0,K_C[i],Sigma,error(0),error(0),Sigma,error(0),tau,dy,r);
  i = i + 1;
endo;

C = BS_Call(S0,K_C,sigma,tau,dy,r);
P = BS_Put(S0,K_P,sigma,tau,dy,r);

Sk = 100;
fn smile0(K) = 0.30 + 0 * K;
fn smile1(K) = 0.30 + (0.00075*(abs(K-Sk))^2) .* (K .<= Sk) - (0.0005*(abs(K-Sk))^1.75) .* (K .>= Sk) ;
fn smile2(K) = 0.30 + (0.0005*(abs(K-Sk))^2) .* (K .<= Sk) - (0.005*(abs(K-Sk))^1.25) .* (K .>= Sk) ;

K = seqa(80,1,41);
Sm_Sigma = smile0(K)~smile1(K)~smile2(K);

Sm_K_P = zeros(nK,2);

i = 1;
do until i > nK;
  Sm_K_P[i,1] = BullSpread_ImpliedStrike(S0,K_C[i],&smile1,error(0),error(0),&Smile1,error(0),tau,dy,r);
  Sm_K_P[i,2] = BullSpread_ImpliedStrike(S0,K_C[i],&smile2,error(0),error(0),&Smile2,error(0),tau,dy,r);
  i = i + 1;
endo;

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(3.5,3,1.25,1.25,0);

  fonts("simplex simgrma");

  _pdate = ""; _pnum = 2; _pframe = 0; _pgrid = {3,1};
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|2|3;

  setwind(1);
    xlabel("\216K]c[");
    xtics(100,105,1,2);
    ylabel("\216K]p[");
    _plegstr = "Sans smile\000Smile #1\000Smile #2";
    _plegctl = {2 5 6.25 5};
    xy(K_C,K_P~Sm_K_P);

  _plegctl = 0;

  setwind(2);
    xtics(80,120,10,2);
    xlabel("\216K");
    ytics(10,60,10,2);
    ylabel("\216\202S\34\201K\202\118\201");
    _pnumht = 0.25; _paxht = 0.25; _pgrid = 0; _pbox = 0.1;
    xtics(80,120,10,2);
    xy(K,100*Sm_Sigma);

    graphprt("-c=1 -cf=option32.eps");

  endwind;

