new;
library qam,optmum,pgraph;

#include option.src

Use_Total_Return = 1;

datPathName = "..\\data\\"; 
datFileName = datPathName $+ "qam_spx_daily_option";

data = loadd(datFileName);
vnames = getname(datFileName);

let selected_names = "date" "spx_pi" "spx_dy" "libor" "spx_call" "spx_put" "spx_tr";

indx = indsav(selected_names,vnames);
data = data[.,indx];
data = selif(data,(data[.,1] .>= 19900101) .and (data[.,1] .<= 20091231));

Dates = data[.,1];
nDates = rows(Dates);

Data_DY = data[.,3]/100;
if Use_Total_Return == 1;
  Data_Spot = data[.,7];  
else;
  Data_Spot = data[.,2];  
  Data_DY = 0*Data_DY;
endif;
Data_Libor = data[.,4]/100;
Data_ImpVol_Call = data[.,5]/100;
Data_ImpVol_Put = data[.,6]/100;

Spot = 100*Data_Spot/Data_Spot[1];

Maturity_Put = error(0); // Rebalancing at the end of month
Maturity_Call = error(0); // Rebalancing at the end of month
Maturity_Spot = error(0); // Rebalancing at the end of month

proc (3) = Option_Proc_Pt(d,S,K,Tau,call_or_put);
  local indx_Date,ImpVol,Libor,DY;  

  indx_Date = indnv(d,Dates);

  if call_or_put == 2;      // Put

    ImpVol = Data_ImpVol_Put[indx_Date];

  else;                     // Call

    ImpVol = Data_ImpVol_Call[indx_Date];

  endif;

  Libor = Data_Libor[indx_Date];
  DY = Data_DY[indx_Date];

  retp(ImpVol,Libor,DY);
endp;

Cash = Compute_Capitalized_Eonia(Dates,Data_Libor);

e = ones(nDates,1);

let Delta = 0.01 0.02 0.03;
nIters = rows(delta);

BS = zeros(nDates,nIters);

iter = 1;
do until iter > nIters;
  Data_Strike_Put = (1-delta[iter]) * e;
  Data_Strike_Call = (1+delta[iter]) * e;

  {BS[.,iter],MTM_S,MtM_C,MtM_P} = BullSpread_Backtest(Dates,Data_Spot,
                                Data_Strike_Call,Data_Strike_Put,&Option_Proc_Pt,
                                Data_Libor,Maturity_Call,Maturity_Put,Maturity_Spot,0);
  iter = iter + 1;
endo;

data = Cash~BS;
dt = 5;
{t,data} = graph_smooth(0,data,1,dt,0);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10;
  _pltype = 3|6|6|6;
  _pstype = 8|8|9|10; _plctrl = 0|261/dt|261/dt|261/dt; _psymsiz = 5;
  _pcolor = 1|2|3|4;
  xtics(0,nDates,261,2);
  let xlab = "90" "91" "92" "93" "94" "95" "96" "97" "98" "99" "00" "01" "02" "03" "04" "05" "06" "07" "08" "09" "10";
  asclabel(xlab,0);
  ytics(100,500,50,2);
  _plegstr = "Libor\000k = 1%\000k = 2%\000k = 3%";
  _plegctl = {2 5 1 4.5};
  graphprt("-c=1 -cf=option34.eps");
  xy(t,data);

