new;
library option,pgraph,qam;

cls;

PathName = "..\\data\\";
datFileName = PathName $+ "qam_dataset1";
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

data = selif(data,data[.,1] .>= 19990101 .and data[.,1] .<= 20091231); 

let selected_names = "sx5e" "EUR_1M" "sx5e_vol";
indx = indsav(selected_names,vnames);

St = data[.,indx[1]];
Rt = St./lagn(St,260) - 1;
et = Compute_Exposition(Rt);
sigma = data[.,indx[3]];
r = data[.,indx[2]]/100; 

data = data[.,1]~Rt~et~sigma~r;
data = selif(data,data[.,1] .>= 20000101 .and data[.,1] .<= 20091231); 

St = 100; 
Rt = data[.,2];
et = data[.,3];
sigma = data[.,4];
r = data[.,5];
b = r;
tau = 0.5;

declare matrix _strike_fn_et;
declare matrix _strike_fn_r;
declare matrix _strike_fn_b;
declare matrix _strike_fn_sigma;

proc strike_fn(K);
 retp(EuropeanBS_Delta(St,K,_strike_fn_sigma,tau,_strike_fn_b,_strike_fn_r) - _strike_fn_et);
endp;

nobs = rows(data);
K_min = 20;
K_max = 200;
Kt = zeros(nobs,1);
i = 1;
do until i > nobs;
  _strike_fn_et = et[i];
  _strike_fn_r = r[i];
  _strike_fn_b = b[i];
  _strike_fn_sigma = sigma[i];
  Kt[i] = bisection(&strike_fn,K_min,K_max);
  i = i + 1;
endo;

x = seqa(-1.00,0.01,201);
y = Compute_Exposition(x);

nobs = rows(Kt);
step = 5;
indx_step = seqa(1,step,nobs/step);

graphset;
  window3u;

  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 6; _ptitlht = 0.275; _pnumht = 0.20; _paxht = 0.20;

  fonts("simplex simgrma");

  _pcross = 1; _plwidth = 10; _pltype = 3;

  setwind(1);
    _pcolor = 1; 
    title("\216Fonction d'exposition");
    xtics(-100,100,50,2);
    ytics(-50,150,50,2);
    xy(100*x,100*y);

  _pcross = 0; _pltype = 6;
  xtics(0,10*260/step,2*260/step,1);
  let xlab = "2000" "02" "04" "06" "08" "10";
  asclabel(xlab,0);

  setwind(2);
    _pcolor = 2;
    title("\216e]t[ (en %)");
    ytics(0,100,20,2);
    xy(0,100*et[indx_step]);

  setwind(3);
    _pcolor = 4;
    title("\216K]t[");
    ytics(50,150,25,2);
    xy(0,Kt[indx_step]);

    graphprt("-c=1 -cf=option4.eps");

  endwind;

proc Compute_Exposition(Rt);
  local It,et;

  It = 1.00*Rt + 0.75;
  et = _min_(_max_(It,0.0),0.99);

  retp(et);
endp;

