new;
library option,pgraph;

S0 = 100;
r = 0.05;
sigma = 0.20;
tau = 1;
b = r;

S = seqa(40,1,121);
K1 = 110;
K2 = 90;

G1 = _max_(0,S-K1);
G2 = _max_(0,K2-S);
C = 5;
P = 5;

G_S1 = G1 + G2 - C - P;
G_S2 = G1 + 0.5*G2 - C - 0.5*P;

_option_type = "call";
Delta = EuropeanBS_Delta(S,K1,Sigma,tau,b,r);
Delta1 = Delta;

_option_type = "put";
Delta = EuropeanBS_Delta(S,K2,Sigma,tau,b,r);
Delta2 = Delta;

Delta_S1 = Delta1 + Delta2;
Delta_S2 = Delta1 + 0.5 * Delta2;

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10;
  _ptitlht = 0.275; _pnumht = 0.20; _paxht = 0.25;
  fonts("simplex simgrma");

  xtics(40,160,20,2);
  ytics(-20,40,10,2);  
  xlabel("\216S]T[");
  ylabel("\216PnL");
  
  _pcross = 1;
  setwind(1);
    title("\216Strangle (\202Q\201]c[=1;\202Q\201]p[=1)");
    _pcolor = 1;
    xy(S,G_S1);

  setwind(2);
    title("\216Strangle (\202Q\201]c[=1;\202Q\201]p[=0,5)");
    _pcolor = 2;
    xy(S,G_S2);

  title("");
  ytics(-100,100,50,5); 
  _pgrid = {3,1}; 
  ylabel("\216e]t[ (en %)");

  setwind(3);
    _pcolor = 3;
    xy(S,100*Delta_S1);

  setwind(4);
    _pcolor = 4;
    xy(S,100*Delta_S2);

    graphprt("-c=1 -cf=option5.eps");

  endwind;

