new;
library qam,pgraph;

S0 = 100;
e0 = 0.50~1.00~1.50;

m = e0*S0;


T = 1;
sigma = seqa(0,0.01,50);

ST = seqa(30,180/200,201);
G_mr = S0 + m .* (ln(ST) - ln(S0));
C_mr = 0.5 * m .* (sigma^2) .* T;

m = 100;
sigma2 = 0.00~0.50;
Pnl = S0 + m .* (ln(ST) - ln(S0)) + 0.5 * m .* (sigma2^2) .* T;
PnL = PnL ~ ST;
Pnl = PnL - S0;

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|1|5; _plwidth = 10;
  _ptitlht = 0.275; _pnumht = 0.20; _paxht = 0.25; _pcolor = 1|2|3|4;
  fonts("simplex simgrma");
  
  setwind(1);
    title("\216F(S]T[)");
    _pcross = 0;
    xtics(40,200,20,2);
    ytics(0,160,20,2);  
    xlabel("\216S]T[");
    xy(ST,G_mr);

  setwind(2);
    title("\216F(S]T[) - S]0[");
    _pcross = 1;
    xtics(40,200,20,2);
    ytics(-60,60,20,2);  
    xy(ST,G_mr - S0);

  setwind(3);
    title("\216C]T[");
    _pcross = 0;
    xtics(0,0.50,0.10,2);
    ytics(0,20,5,2);  
    xlabel("\216\202s\201");
    _plegstr = "e]0[ = 50%\000e]0[ = 100%\000e]0[ = 150%";
    _plegctl = {2 6 2 4};
    xy(sigma,C_mr);

  setwind(4);
    title("\216PnL (e]0[ = 100%)");
    _pcross = 1;
    xtics(40,200,20,2);
    ytics(-100,100,50,2);  
    xlabel("\216S]T[");
    _plegstr = "\202s\201 = 0%\000\202s\201 = 50%\000Buy and hold";
    _plegctl = {2 6 4.5 0.75};
    xy(ST,PnL);

    graphprt("-c=1 -cf=option6.eps");

  endwind;


  

