new;
library qam,pgraph,optmum;

rndseed 123;

S0 = 100;
e0 = 1.00;

m = e0/S0;
S_star = 100;

Tau = 1;

let sigma = 0.20 0.20 0.30;
let mu = 0.0 0.20 0.00;

nIters = rows(sigma);

dt = 1/260;
t = seqa(0,dt,260*Tau+1);
Nt = rows(t);
Ns = 10000;

x = seqa(0,0.01,1001);
d = zeros(rows(x),nIters);

i = 1;
do until i > nIters;

  S = simulate_GBM(S0,mu[i],sigma[i],t,Ns);
  ST = S[Nt,.]';

  F_T = S0 + 0.5 * m .* ( (ST-S_Star)^2 - (S0-S_star)^2);
  C_T = 0.5 * m * sumc( S^2 .* dt) .* sigma[i]^2;

  cost = 100 * C_T ./ F_T;

  {d[.,i],F} = regKernelDensity(cost,x);

  i = i + 1;
endo;

d = missex(d,d .<= __macheps);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _pcolor = 1|2|3; _plwidth = 10;
  xlabel("\216C]T[/F]T[ (en %)");
  _plegstr = "\202m\201 = 0% et \202s\201 = 20%\000\202m\201 = 20% et \202s\201 = 20%\000\202m\201 = 0% et \202s\201 = 30%";
  _plegctl = {2 5 5 4};
  graphprt("-c=1 -cf=option8.eps");
  xy(x,d);



