new;
library qam,pgraph,optmum;

datFileName = "..\\data\\qam_sxxr_sectors.dat";
data = loadd(datFileName);
vnames = getname(datFileName);

Data = selif(Data,(Data[.,1] .>= 19920101) .and (Data[.,1] .<= 20091231) );

Dates = Data[.,1];
vnames = "" $+ trimr(vnames,1,0);
nIndexes = cols(data);

Data = Data[.,2:nIndexes];
Data = Data[.,20:38];
vnames = vnames[20:38];

Data = 100 * Data ./ Data[1,.];

indx_SXXR = indsav("SXXR",vNames);
indx = setdif(seqa(1,1,19),indx_SXXR,1);
Last_Data = Data[rows(Data),indx]';
indx_min = sortind(Last_Data) | indx_SXXR;
indx_max = rev(indx_min);

let string Correspondance_Table[19,4] = 
"Dow Jones STOXX 600"	"Automobiles & Parts"		    "SXAP"     "SXAR"
"Dow Jones STOXX 600"	"Banks"				            "SX7P"     "SX7R"
"Dow Jones STOXX 600"	"Basic Resources" 		        "SXPP"     "SXPR"
"Dow Jones STOXX 600"	"Chemicals" 			        "SX4P"     "SX4R"
"Dow Jones STOXX 600"	"Construction & Materials" 	    "SXOP"     "SXOR"
"Dow Jones STOXX 600"	"Financial Services" 		    "SXFP"     "SXFR"
"Dow Jones STOXX 600"	"Food & Beverage" 		        "SX3P"     "SX3R"
"Dow Jones STOXX 600"	"Health Care" 			        "SXDP"     "SXDR"
"Dow Jones STOXX 600"	"Industrial Goods & Services" 	"SXNP"     "SXNR"
"Dow Jones STOXX 600"	"Insurance" 			        "SXIP"     "SXIR"
"Dow Jones STOXX 600"	"Media" 				        "SXMP"     "SXMR"
"Dow Jones STOXX 600"	"Oil & Gas" 			        "SXEP"     "SXER"
"Dow Jones STOXX 600"	"Personal & Household Goods" 	"SXQP"     "SXQR"
"Dow Jones STOXX 600"	"Retail" 				        "SXRP"     "SXRR"
"Dow Jones STOXX 600"	"Technology" 			        "SX8P"     "SX8R"
"Dow Jones STOXX 600"	"Telecommunications" 		    "SXKP"     "SXKR"
"Dow Jones STOXX 600"	"Travel & Leisure" 		        "SXTP"     "SXTR"
"Dow Jones STOXX 600"	"Utilities" 			        "SX6P"     "SX6R"
"Dow Jones STOXX 600"	"" 			                    "SXXP"     "SXXR";

indx = indsav(vnames,Correspondance_Table[.,4]);
Correspondance_Table = Correspondance_Table[indx,.];

Price_Name = Correspondance_Table[.,4];

Index = Data[.,indx_SXXR];
Title_Index = "\216" $+ Correspondance_Table[indx,1] $+ "\L\216" $+ Correspondance_Table[indx,4];

Index_Min = Data[.,indx_min];
// Title_Min = Correspondance_Table[indx_Min,2] $+ "\L\216" $+ Correspondance_Table[indx_Min,4];
// Title_Min = "\216" $+ ftocv(seqa(1,1,19),1,0) $+ ". " $+ Title_Min;

Title_Min = "\216" $+ Correspondance_Table[indx_Min,2] $+ "\L\216" $+ Correspondance_Table[indx_Min,4];

pqgwin many;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 5;
  xtics(1,260*18,260*2,2);
  let xlab = "1992" "94" "96" "98" "2000" "02" "04" "06" "08" "10";
  asclabel(xlab,0);
  graphprt("-c=1 -cf=rotation1.eps");
  xy(0,Index);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10;

  xtics(1,260*18,260*2,2);
  let xlab = "1992" "94" "96" "98" "2000" "02" "04" "06" "08" "10";
  asclabel(xlab,0);

  _pnumht = 0.22; _paxht = 0.22; _ptitlht = 0.25;
  ytics(0,1400,200,2);
  _pgrid = {3,1};

  setwind(1);
    _pcolor = 1;
    indx = 1;
    title(Title_Min[indx]);
    xy(0,Index_Min[.,indx]);

  setwind(2);
    _pcolor = 2;
    indx = 4;
    title(Title_Min[indx]);
    xy(0,Index_Min[.,indx]);

  setwind(3);
    _pcolor = 3;
    indx = 15;
    title(Title_Min[indx]);
    xy(0,Index_Min[.,indx]);

  setwind(4);
    _pcolor = 4;
    indx = 18;
    title(Title_Min[indx]);
    xy(0,Index_Min[.,indx]);

  graphprt("-c=1 -cf=rotation2.eps");

  endwind;


