new;
library qam,pgraph,optmum;

datFileName = "..\\data\\qam_sxxr_sectors.dat";
data = loadd(datFileName);
vnames = getname(datFileName);

Data = selif(Data,(Data[.,1] .>= 19920101) .and (Data[.,1] .<= 20091231) );

Dates = Data[.,1];
vnames = "" $+ trimr(vnames,1,0);
nIndexes = cols(data);

Data = Data[.,2:nIndexes];
Data = Data[.,20:38];
vnames = vnames[20:38];

Data = 100 * Data ./ Data[1,.];

indx_SXXR = indsav("SXXR",vNames);
indx = setdif(seqa(1,1,19),indx_SXXR,1);
Last_Data = Data[rows(Data),indx]';
indx_min = sortind(Last_Data) | indx_SXXR;

let string Correspondance_Table[19,4] = 
"Dow Jones STOXX 600"	"Automobiles & Parts"		    "SXAP"     "SXAR"
"Dow Jones STOXX 600"	"Banks"				            "SX7P"     "SX7R"
"Dow Jones STOXX 600"	"Basic Resources" 		        "SXPP"     "SXPR"
"Dow Jones STOXX 600"	"Chemicals" 			        "SX4P"     "SX4R"
"Dow Jones STOXX 600"	"Construction & Materials" 	    "SXOP"     "SXOR"
"Dow Jones STOXX 600"	"Financial Services" 		    "SXFP"     "SXFR"
"Dow Jones STOXX 600"	"Food & Beverage" 		        "SX3P"     "SX3R"
"Dow Jones STOXX 600"	"Health Care" 			        "SXDP"     "SXDR"
"Dow Jones STOXX 600"	"Industrial Goods & Services" 	"SXNP"     "SXNR"
"Dow Jones STOXX 600"	"Insurance" 			        "SXIP"     "SXIR"
"Dow Jones STOXX 600"	"Media" 				        "SXMP"     "SXMR"
"Dow Jones STOXX 600"	"Oil & Gas" 			        "SXEP"     "SXER"
"Dow Jones STOXX 600"	"Personal & Household Goods" 	"SXQP"     "SXQR"
"Dow Jones STOXX 600"	"Retail" 				        "SXRP"     "SXRR"
"Dow Jones STOXX 600"	"Technology" 			        "SX8P"     "SX8R"
"Dow Jones STOXX 600"	"Telecommunications" 		    "SXKP"     "SXKR"
"Dow Jones STOXX 600"	"Travel & Leisure" 		        "SXTP"     "SXTR"
"Dow Jones STOXX 600"	"Utilities" 			        "SX6P"     "SX6R"
"Dow Jones STOXX 600"	"" 			                    "SXXP"     "SXXR";

indx = indsav(vnames,Correspondance_Table[.,4]);
Correspondance_Table = Correspondance_Table[indx,.];

Rdt = Data[rows(Data),.]' ./ Data[1,.]' - 1;

Table = Correspondance_Table[.,2 4] $~ ftosa(100*Rdt,"%lf",3,2);
Table = ("" $+ ftocv(seqa(1,1,19),1,0)) $~ Table[indx_Min,.];
print Table;