new;
library qam,pgraph,optmum;

datFileName = "..\\data\\qam_sxxr_sectors.dat";
data = loadd(datFileName);
vnames = getname(datFileName);

Data = selif(Data,(Data[.,1] .>= 19920101) .and (Data[.,1] .<= 20091231) );

Dates = Data[.,1];
nDates = rows(Dates);

vnames = "" $+ trimr(vnames,1,0);
nIndexes = cols(data);

Data = Data[.,2:nIndexes];
Data = Data[.,20:38];
vnames = vnames[20:38];

Data = 100 * Data ./ Data[1,.];

Data = Fill_Miss(Data,3);

indx_SXXR = indsav("SXXR",vNames);
Index_SXXR = Data[.,indx_SXXR];

indx = setdif(seqa(1,1,19),indx_SXXR,1);
Index_Sector = Data[.,indx];

let string Correspondance_Table[19,4] = 
"Dow Jones STOXX 600"	"Automobiles & Parts"		    "SXAP"     "SXAR"
"Dow Jones STOXX 600"	"Banks"				            "SX7P"     "SX7R"
"Dow Jones STOXX 600"	"Basic Resources" 		        "SXPP"     "SXPR"
"Dow Jones STOXX 600"	"Chemicals" 			        "SX4P"     "SX4R"
"Dow Jones STOXX 600"	"Construction & Materials" 	    "SXOP"     "SXOR"
"Dow Jones STOXX 600"	"Financial Services" 		    "SXFP"     "SXFR"
"Dow Jones STOXX 600"	"Food & Beverage" 		        "SX3P"     "SX3R"
"Dow Jones STOXX 600"	"Health Care" 			        "SXDP"     "SXDR"
"Dow Jones STOXX 600"	"Industrial Goods & Services" 	"SXNP"     "SXNR"
"Dow Jones STOXX 600"	"Insurance" 			        "SXIP"     "SXIR"
"Dow Jones STOXX 600"	"Media" 				        "SXMP"     "SXMR"
"Dow Jones STOXX 600"	"Oil & Gas" 			        "SXEP"     "SXER"
"Dow Jones STOXX 600"	"Personal & Household Goods" 	"SXQP"     "SXQR"
"Dow Jones STOXX 600"	"Retail" 				        "SXRP"     "SXRR"
"Dow Jones STOXX 600"	"Technology" 			        "SX8P"     "SX8R"
"Dow Jones STOXX 600"	"Telecommunications" 		    "SXKP"     "SXKR"
"Dow Jones STOXX 600"	"Travel & Leisure" 		        "SXTP"     "SXTR"
"Dow Jones STOXX 600"	"Utilities" 			        "SX6P"     "SX6R"
"Dow Jones STOXX 600"	"" 			                    "SXXP"     "SXXR";

indx = indsav(vnames,Correspondance_Table[.,4]);
Correspondance_Table = Correspondance_Table[indx,.];

nYears = 18;
nSelected = 13;
Selected_Sectors = "" $+ zeros(nYears,nSelected);
Weights = zeros(nDates,18);
Uniform_Weights = ones(nDates,18)/18;

Years = seqa(1992,1,nYears);
BeginYear = Years * 1e4 + 101;
EndYear = Years * 1e4 + 1231;

indx_Dates = seqa(1,1,nDates);

i = 1;
do until i > nYears;
  indx = selif(indx_Dates,(Dates .>= BeginYear[i]) .and (Dates .<= EndYear[i]));
  nRows = rows(indx);
  Perf = Index_Sector[indx[nRows],.]' ./ Index_Sector[indx[1],.]' - 1;
  indx_min = sortind(Perf);
  indx_max = rev(indx_min);
  Weights[indx,indx_max[1:nSelected]] = ones(nRows,nSelected)/nSelected;
  Selected_Sectors[i,.] = Correspondance_Table[indx_Max[1:nSelected],4]';
  i = i + 1;
endo;

Strategy1 = Compute_Monthly_Backtest(Dates,Weights,Index_Sector);
Strategy2 = Compute_Monthly_Backtest(Dates,Uniform_Weights,Index_Sector);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 3|6|1; _plwidth = 8; _pcolor = 5|1|4;
  xtics(1,260*18,260*2,2);
  let xlab = "1992" "94" "96" "98" "2000" "02" "04" "06" "08" "10";
  asclabel(xlab,0);
  _plegstr = "SXXR\000S]13[\000S]18[";
  _plegctl = {2 5 1.5 5};
  graphprt("-c=1 -cf=rotation3.eps");
  xy(0,Index_SXXR~Strategy1~Strategy2);


