new;
library qam,pgraph,optmum;

N_Vega = 1;
K = 25;

S0 = 100;
St = seqa(95,0.1,101);
dS = St ./ S0;
variance = 100^2 * 252 .* ln(dS)^2;
n = 60;
PnL1 = N_vega ./ (2 * n .* K) .* (variance - K^2);
x1 = St; y1 = PnL1;

K = seqa(0,50/100,101);
S0 = 100;
St = S0 .* exp( (1~-1) .* K / 100 / sqrt(252) );
x2 = K; y2 = St;

K[1] = error(0);
R = 0.01~0.02~0.05~0.10;
n = 100^2 * 252 * R^2 ./ K^2;
x3 = K; y3 = n;

K = seqa(0,40/100,101);
n = 21 .* (1~3~6);
R = sqrt(n .* K^2 / 100^2 / 252);
x4 = K; y4 = R;

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0; 
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  _paxht = 0.25; _ptitlht = 0.30;
  fonts("simplex simgrma");

  _pnumht = 0.19;

  setwind(1);
    title("\216(a)");
    _pcross = 1;
    xlabel("\216S]t[");
    ylabel("\216PnL");
    xtics(95,105,1,2);
    ytics(-0.5,2,0.5,2);
    xy(x1,y1);

  _pnumht = 0.225;

  setwind(2);
    title("\216(b)");
    _pltype = 1; _pcolor = 2; _pcross = 0;
    xlabel("\216K");
    ylabel("\216S]t[");
    xtics(0,50,10,2);
    ytics(97,103,1,2);
    e = ones(rows(x2),1);
    _pline = (e.*(1~6))~x2~y2[.,1]~x2~y2[.,1]+5~(e.*(1~2~5)) |
             (e.*(1~6))~x2~y2[.,2]~x2~y2[.,2]-5~(e.*(1~2~5)) ;
    xy(x2,y2);

  _pgrid = {3,1};
  _pltype = 6|1|3|5; _pcolor = 1|2|3|4;

  setwind(3);
    title("\216(c)");
    ytics(0,60,10,2);
    ylabel("\216n[*]");
    _plegstr = "R]+[ = 1%\000R]+[ = 2%\000R]+[ = 5%\000R]+[ = 10%";
    _plegctl = {2 5 5.75 3.6};
    xy(x3,y3);

    _plegctl = 0;

  setwind(4);
    title("\216(d)");
    ytics(0,10,1,2);
    ylabel("\216R]+[ (en %)");
    _plegstr = "1M\0003M\0006M";
    _plegctl = {2 6 6.5 2.5};
    xy(x4,100*y4);

    graphprt("-c=1 -cf=volatility11.eps");

  endwind;


