new;
library qam,pgraph,optmum;

S0 = seqa(0.5,0.5,400);
sigma = 0.20;
tau = 1;
b = 0.00;
r = 0.00;

K = 100;
nK = cols(K);
vega = Variance_Vega(K);
vega_sum = aggregate_vega(vega,K,-1);

vega1 = vega;
vega1_sum = vega_sum;

K = seqa(70,30,3)';
nK = cols(K);
vega = Variance_Vega(K);
vega_sum = aggregate_vega(vega,K,0);

vega2 = vega;
vega2_sum = 1.1*vega_sum;

K = seqa(25,25,8)';
nK = cols(K);
vega = Variance_Vega(K);
vega_sum = aggregate_vega(vega,K,0);

vega3 = vega;
vega3_sum = 1.1*vega_sum;

K = seqa(0.5,0.5,500)';
nK = cols(K);
vega = Variance_Vega(K);
vega_sum = aggregate_vega(vega,K,50);

vega4 = vega;
vega4_sum = 1.0*vega_sum;
indx = seqa(1,50,10);

graphset;
  begwind;
  window(2,2,1);
  _pdate = ""; _pframe = 0; _pnum = 2;
  _pltype = 6|reshape(1|3,nK,1); _plwidth = 10|7*ones(nK,1);
  _pcolor = 1|reshape(2|3|4,nK,1);
  _paxht = 0.22; _pnumht = 0.22; _ptitlht = 0.25;
  xtics(0,200,25,2);

  setwind(1);
    title("\216m = 1");
    ytics(0,100,25,2);
    xy(S0,vega1_sum~vega1);

  setwind(2);
     title("\216m = 3");
    ytics(0,150,50,2);
    xy(S0,vega2_sum~vega2);

  setwind(3);
    title("\216m = 8");
    ytics(0,250,50,2);
    xy(S0,vega3_sum~vega3);

  setwind(4);
    title("\216m = 500");
    ytics(0,60,10,2);
    xy(S0,vega4_sum);

    graphprt("-c=1 -cf=volatility12.eps");

  endwind;

proc (1) = Variance_Vega(K);
  local w,d1,vega;
  w = sigma.*sqrt(tau);
  d1 = ( ln(S0./K) + b.*tau )./w + 0.5 * w;  
  vega = exp((b-r).*tau).*pdfn(d1).*S0.*sqrt(tau)/(2*sigma);
  retp(vega);
endp;

proc (1) = aggregate_vega(vega,K,c);
  local vega_max,w,vega_sum;

  vega_max = maxc(vecr(vega));
  w = 1 ./ (K^2);
  vega_Sum = sumr(w .* Vega);
  if c == 0;
    c = vega_max ./ maxc(vega_sum);
  elseif c < 0;
    c = 1./sumr(w);
  else;
    c = c ./ maxc(vega_sum);
  endif;

  vega_sum = c * vega_Sum;

  retp(vega_sum);
endp;




