new;
library qam,pgraph,optmum;

datFileName = "..\\data\\qam_spx_daily_option";

Data = loadd(datFileName);
vnames = getname(datFileName);

let selected_names = "date" "SPX_PI" "SPX_VIX";
indx = indcv(selected_names,vnames);
data = data[.,indx];

data = selif(data, (data[.,1] .>= 19900101) .and (data[.,1] .<= 20091231));
nDates = rows(data);

Dates = Data[.,1];
SPX = Data[.,2];
VIX = Data[.,3];

VOL = 100*Compute_Running_Statistics(Dates,SPX[.,1],22,2);
Spread = packr(VIX - VOL);

x = seqa(-50,100/200,201);
{d,F} = regKernelDensity(Spread,x);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pcross = 1;
  _pltype = 6; _plwidth = 10; _pcolor = 2;
  xlabel("\216Spread");
  xtics(-20,30,10,2);
  ytics(0,0.14,0.02,2);
  graphprt("-c=1 -cf=volatility13.eps");
  xy(x,d);
 
  