new;
library qam,pgraph,optmum;

datFileName = "..\\data\\qam_spx_daily_option";

Data = loadd(datFileName);
vnames = getname(datFileName);

let selected_names = "date" "ALV" "ISP" "ALV_3M" "ISP_3M";
indx = indcv(selected_names,vnames);
data = data[.,indx];

data = selif(data, (data[.,1] .>= 20000101) .and (data[.,1] .<= 20091231));
nDates = rows(data);

Dates = Data[.,1];
hVOL = 100*Compute_Running_Statistics(Dates,Data[.,2:3],22*3,2);

Spread = hVol[.,1] - hVol[.,2];
Spread_Implied = Data[.,4] - Data[.,5];
Spread_Implied_Lag = lagn(Spread_Implied,22*6);

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9/4,6.855/4,3.5,5,1);
  makewind(9/4,6.855/4,6,5,1);
  
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 3; _pcross = 1;

  setwind(1);
    xtics(1,261*10,261*2,2);
    let xlab = "2000" "02" "04" "06" "08" "10";
    asclabel(xlab,0);
    xy(0,Spread);

  setwind(2);
    _pcolor = 5; _plctrl = -1; _pbox = 5;
    _paxht = 0.40; _pnumht = 0.22; _pstype = 4;
    xtics(-30,30,10,2);
    ytics(-30,30,10,2);
    asclabel(0,0);
    _pline = 1~1~-30~-30~30~30~1~0~10;
    xlabel("\216S]t[");
    ylabel("\216S]t-m[[*]");
    xy(Spread,Spread_Implied_Lag);

  setwind(3);
    xlabel("\216S]t[");
    ylabel("\216S]t[[*]");
    xy(Spread,Spread_Implied);

    graphprt("-c=1 -cf=volatility15.eps");

  endwind;

  