new;
library qam,pgraph,optmum;

cls;

Path = "..\\Data\\";
FileName = Path $+ "qam_dispersion_weights";
loadm Index_Weights = ^FileName;
FileName = Path $+ "qam_dispersion_names";
loads names = ^FileName;
FileName = Path $+ "qam_dispersion_prices";
data_prices = loadd(FileName);
FileName = Path $+ "qam_dispersion_impvol_6m";
data_impvol = loadd(FileName);

dates = data_prices[.,1] | data_impvol[.,1];
dates = unique(dates,1);
nDates = rows(Dates);
nCols = cols(data_prices);

new_data_prices = miss(zeros(nDates,nCols),0);
new_data_impvol = miss(zeros(nDates,nCols),0);
indx = indnv(data_prices[.,1],Dates);
new_data_prices[indx,.] = data_prices;
indx = indnv(data_impvol[.,1],Dates);
new_data_impvol[indx,.] = data_impvol;

new_data_prices[.,1] = Dates;
new_data_impvol[.,1] = Dates;

new_data_prices = selif(new_data_prices,new_data_prices[.,1] .>= 19991231);
new_data_impvol = selif(new_data_impvol,new_data_impvol[.,1] .>= 19991231);

if new_data_prices[.,1] /= new_data_impvol[.,1];
  errorlog "error: dates do not match.";
endif;

Dates = new_data_prices[.,1];
nDates = rows(Dates);
Spot = new_data_prices[.,2:nCols];
nSpot = cols(Spot);
ImpVol = new_data_impvol[.,2:nCols];

nMonths = 6;
nDays = nMonths*21;

Rdt = Spot./lag1(Spot) - 1;
data = miss(zeros(nDates,nSpot),0);

t = nDays + 1;
do until t > nDates;
  x = Rdt[t-nDays:t,.];
  x = packr(x);
  if rows(x) > 0.90*nDays;
    data[t,.] = sqrt(260)*stdc(x)';
  endif;
  t = t + 1;
endo;

HistVol = 100 * data;

ImpVol_Basket = ImpVol[.,1]/100;
HistVol_Basket = HistVol[.,1]/100;
ImpVol_Stocks = ImpVol[.,2:cols(ImpVol)]/100;
HistVol_Stocks = HistVol[.,2:cols(HistVol)]/100;
Weights = Index_Weights/100;

{IC1,IC2,IC3} = Compute_Implied_Correlation(HistVol_Basket,HistVol_Stocks,Weights,0);
ImpVol_Stocks = missrv(ImpVol_Stocks,0);
{IC1_star,IC2_star,IC3_star} = Compute_Implied_Correlation(ImpVol_Basket,ImpVol_Stocks,Weights,0);

data = Dates~IC1~IC2~IC3~IC1_star~IC2_star~IC3_star;
data = selif(data,(data[.,1] .>= 20041231) .and (data[.,1] .<= 20091231));
Spread = data[.,7]-lagn(data[.,4],-nDays);

graphset;
  window3d;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 8; _pcolor = 1|4|2;
  _paxht = 0.25; _pnumht = 0.20; _ptitlht = 0.30;
  xtics(1,5*260,260,2);
  let xlab = "2005" "2006" "2007" "2008" "2009" "2010";
  asclabel(xlab,0);

  setwind(1);
    title("\216\202r\201]imp[");
    ytics(30,60,10,2);
    _plegstr = "IC\000\Dirty\000MVR";
    _plegctl = {2 6 5 1};
    xy(0,100*data[.,2:4]);

    _plegctl = 0;

  setwind(2);
    title("\216\202r\201]imp[[*]");
    ytics(20,100,20,2);
    xy(0,100*data[.,5:7]);

  setwind(3);
    _plctrl = -1; _pcross = 1; _ptitlht = 0.25;
    xtics(30,60,10,2);
    ytics(-40,40,10,2);
    title("\216Spread MVR");
    asclabel(0,0);
    ylabel("\216Spread");
    xlabel("\216\202r\201]imp[");
    xy(100*lagn(data[.,4],-nDays),100*Spread);

    graphprt("-c=1 -cf=volatility16.eps");

  endwind;
 
  