new;
library qam,pgraph,optmum;
cls;

PathName = "..\\data\\";
loads path = ^PathName sx5e_sa;

datFileName = Pathname $+ "qam_sx5e_weights";
data_weights = loadd(datFileName);
weights = data_weights[.,2:cols(data_weights)]/100;
date_weights = data_weights[.,1];

if 0;
  datFileName = Pathname $+ "qam_sx5e_pi";
  data_prices = loadd(datFileName);
else;
  datFileName = Pathname $+ "qam_sx5e_prices";
  data_prices = loadd(datFileName);
endif;

FileName = PathName $+ "qam_sx5e_impvol_6m";
data_impvol = loadd(FileName);

dates = data_prices[.,1] | data_impvol[.,1];
dates = unique(dates,1);
nDates = rows(Dates);
nCols = cols(data_prices);

new_data_prices = miss(zeros(nDates,nCols),0);
new_data_impvol = miss(zeros(nDates,nCols),0);
new_data_weights = miss(zeros(nDates,nCols),0);

indx = indnv(data_prices[.,1],Dates);
new_data_prices[indx,.] = data_prices;
indx = indnv(data_impvol[.,1],Dates);
new_data_impvol[indx,.] = data_impvol;

indx = closest_index(Dates,date_weights);
new_data_weights = weights[indx,.];
new_data_weights = Dates~zeros(nDates,1)~new_data_weights;

new_data_prices[.,1] = Dates;
new_data_impvol[.,1] = Dates;

new_data_prices = selif(new_data_prices,new_data_prices[.,1] .>= 19991231);
new_data_impvol = selif(new_data_impvol,new_data_impvol[.,1] .>= 19991231);
new_data_weights = selif(new_data_weights,new_data_weights[.,1] .>= 19991231);

if new_data_prices[.,1] /= new_data_impvol[.,1];
  errorlog "error: dates do not match.";
endif;

Dates = new_data_prices[.,1];
nDates = rows(Dates);
Spot = new_data_prices[.,2:nCols];
nSpot = cols(Spot);
ImpVol = new_data_impvol[.,2:nCols];
Index_Weights = new_data_weights[.,3:nCols];

nYears = 2;
nMonths = 6;
nDays = nMonths*21;

Rdt = Spot./lag1(Spot) - 1;
HistVol = miss(zeros(nDates,nSpot),0);

t = nDays + 1;
do until t > nDates;
  x = Rdt[t-nDays:t,.];
  j = 1;
  do until j > nSpot;
    y = packr(x[.,j]);
    if rows(y) > 0.90*nDays;
      HistVol[t,j] = 100*sqrt(260)*stdc(y);
    endif;
    j = j + 1;
  endo;
  t = t + 1;
endo;

Months = unique(trunc(Dates/1e2),1);
StudyDates = 100*Months + 31;
indx = closest_index(StudyDates,Dates);
StudyDates = Dates[indx];
StudyDates = selif(StudyDates,StudyDates .>= 20050101);
indx_StudyDates = indnv(StudyDates,Dates);
nStudyDates = rows(StudyDates);

let Cases = 5 10 15 20;
nCases = rows(Cases);

Result1 = zeros(nDates,nCases);
Result2 = zeros(nDates,nCases);

BigIter = 1;
do until BigIter > nCases;

  nSelectedStocks = Cases[BigIter];

  PnL_E = zeros(nDates,nStudyDates);
  PnL_W = zeros(nDates,nStudyDates);

  Initial_Wealth = 100;
  Wealth_E = Initial_Wealth;
  Wealth_W = Initial_Wealth;

  Track_E = Initial_Wealth + zeros(nDates,1);
  Track_W = Initial_Wealth + zeros(nDates,1);

  Notional_Vega = 0.5;

  iter = 1;
  do until iter > nStudyDates-1;

    TradingDate = StudyDates[iter];
    BeginDate = TradingDate - nYears*1e4;
    indx_Selected = Stock_Selection(BeginDate,TradingDate,Dates,ImpVol[.,2:cols(ImpVol)],HistVol[.,2:cols(HistVol)],nSpot-1);

    tmp_weights = Index_Weights[indx_StudyDates[iter],.]';

    tmp = selif(indx_selected~tmp_weights,tmp_weights .> 0);
    tmp = tmp[1:nSelectedStocks,.];
    indx_selected = tmp[.,1];
    tmp_weights = tmp[.,2];
     
    indx_Selected = indx_Selected + 1;
    indx_Selected = 1 | indx_Selected;

    Spot_Selected = Spot[.,indx_Selected];
    ImpVol_Selected = ImpVol[indx_StudyDates[iter]+1,indx_Selected]';

    indx1 = indnv(StudyDates[iter],Dates);
    indx = iter + nMonths;
    indx = _min_(indx,nStudydates);
    indx2 = indnv(StudyDates[indx],Dates);
    indx_t = seqa(indx1,1,indx2-indx1+1);

    Rdt = ln(Spot_Selected[indx_t,.]./lag1(Spot_Selected[indx_t,.]));
    Rdt = missrv(Rdt,0);

    Rdt_Index = Rdt[.,1];
    Rdt = Rdt[.,2:nSelectedStocks+1];

    ImpVol_Index = ImpVol_Selected[1];
    ImpVol_Stocks = trimr(ImpVol_Selected,1,0);

    w = ones(nSelectedStocks,1)/nSelectedStocks;

    w_s2 = (Rdt^2)*w;

    rho = Rdt_Index^2 ./ w_s2;
    rho = missrv(rho,0);

    rho_star = ImpVol_Index^2 ./ ((ImpVol_Stocks^2)'w);
    rho_star = missrv(rho_star,0);
    rho_star = 0.0 | rho_star*ones(rows(rho)-1,1);
    Notional = (1/nDays) / (2*ImpVol_Index) * (100^2) * 252;
    PnL =  Notional * (rho_star - rho) .* w_s2;
    PnL = missrv(PnL,0);

    if rows(packr(PnL)) > 1;
      PnL_E[indx_t,iter] = PnL;
    endif;

    Notional = Wealth_E/Initial_Wealth * Notional_Vega;
    Track_E = Track_E + Notional*cumsumc(PnL_E[.,iter]);
    Wealth_E = Track_E[indx_t[1]+22];

    w = tmp_weights;
    w = w / sumc(w);

    w_s2 = (Rdt^2)*w;

    rho = Rdt_Index^2 ./ w_s2;
    rho = missrv(rho,0);

    rho_star = ImpVol_Index^2 ./ ((ImpVol_Stocks^2)'w);
    rho_star = missrv(rho_star,0);
    rho_star = 0.0 | rho_star*ones(rows(rho)-1,1);
    Notional = (1/nDays) / (2*ImpVol_Index) * (100^2) * 252;
    PnL =  Notional * (rho_star - rho) .* w_s2;
    PnL = missrv(PnL,0);

    if rows(packr(PnL)) > 1;
      PnL_W[indx_t,iter] = PnL;
    endif;
 
    Notional = Wealth_W/Initial_Wealth * Notional_Vega;
    Track_W = Track_W + Notional*cumsumc(PnL_W[.,iter]);
    Wealth_W = Track_W[indx_t[1]+22];
 
    iter = iter + 1;
  endo;

  Result1[.,BigIter] = Track_E;
  Result2[.,BigIter] = Track_W;  

  BigIter = BigIter + 1;
endo;

data = Dates~Result1~Result2;
data = selif(data,(data[.,1] .>= 20041231) .and (data[.,1] .<= 20091231));
data = miss(data,100);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  xtics(1,5*260,260,2);
  ytics(80,220,20,2);
  let xlab = "2005" "2006" "2007" "2008" "2009" "2010";
  asclabel(xlab,0);
  _plegstr = "1/n\000MCAP";
  _plegctl = {2 6 3 3};
  graphprt("-c=1 -cf=volatility17.eps");
  xy(0,data[.,8:9]);

proc (1) = Stock_Selection(BeginDate,TradingDate,Dates,ImpVol,HistVol,nSelectedStocks);
  local nStocks,indx,Score,i,PnL,indx_Selected;

  nStocks = cols(ImpVol);

  indx = selif(seqa(1,1,rows(Dates)),Dates .>= BeginDate .and Dates .<= TradingDate);

  HistVol = HistVol[indx,.];
  indx = indnv(TradingDate,Dates);
  ImpVol = ImpVol[indx,.]';
  Score = miss(zeros(nStocks,1),0);

  i = 1;
  do until i > nStocks;
    PnL = -(1/(2*ImpVol[i]))*(ImpVol[i]^2-HistVol[.,i]^2);
    PnL = packr(PnL);
    if PnL /= error(0);
      Score[i] = meanc(PnL .> 0);
    endif;
    i = i + 1;
  endo;  

  indx_Selected = seqa(1,1,nStocks)~Score;
  indx_Selected = rev(sortc(indx_Selected,2));
  indx_Selected = indx_Selected[1:nSelectedStocks,1];

  retp(indx_Selected);
endp;  

proc (1) = Compute_SelectedStock(BeginDate,TradingDate,Dates,ImpVolDates,ImpVol,Data,n);
  local Vol,indx,indxTradingDate,Strike,indxSelectedStock,Score,i;
  local PnL;

    indx = selif(seqa(1,1,rows(Dates)),Dates .>= BeginDate .and Dates .<= TradingDate);
    Vol = Data[indx,.];
    indxTradingDate = indnv(TradingDate,ImpVolDates);
    Strike = ImpVol[indxTradingDate,.];
    Score = miss(zeros(cols(Strike),1),0);
    i = 1;
    do until i > rows(score);
      PnL = -(1/(2*Strike[i]))*(Strike[i]^2-vol[.,i]^2);
      if packr(PnL) /= error(0);
        Score[i] = meanc(packr(PnL));
      endif;
    i = i + 1;
    endo;
    
    indxSelectedStock = seqa(1,1,rows(Score))~score;
    indxSelectedStock = rev(sortc(indxSelectedStock,2));
    indxSelectedStock = (0|indxSelectedStock[1:n,1])+1;

  retp(indxSelectedStock);
endp;  