new;
library qam,pgraph,optmum;

cls;

Path = "..\\Data\\";
FileName = Path $+ "qam_dispersion_weights";
loadm Index_Weights = ^FileName;
FileName = Path $+ "qam_dispersion_names";
loads names = ^FileName;
FileName = Path $+ "qam_dispersion_prices";
data_prices = loadd(FileName);
FileName = Path $+ "qam_dispersion_impvol_6m";
data_impvol = loadd(FileName);

dates = data_prices[.,1] | data_impvol[.,1];
dates = unique(dates,1);
nDates = rows(Dates);
nCols = cols(data_prices);

new_data_prices = miss(zeros(nDates,nCols),0);
new_data_impvol = miss(zeros(nDates,nCols),0);
indx = indnv(data_prices[.,1],Dates);
new_data_prices[indx,.] = data_prices;
indx = indnv(data_impvol[.,1],Dates);
new_data_impvol[indx,.] = data_impvol;

new_data_prices[.,1] = Dates;
new_data_impvol[.,1] = Dates;

new_data_prices = selif(new_data_prices,new_data_prices[.,1] .>= 19991231);
new_data_impvol = selif(new_data_impvol,new_data_impvol[.,1] .>= 19991231);

if new_data_prices[.,1] /= new_data_impvol[.,1];
  errorlog "error: dates do not match.";
endif;

Dates = new_data_prices[.,1];
nDates = rows(Dates);
Spot = new_data_prices[.,2:nCols];
nSpot = cols(Spot);
ImpVol = new_data_impvol[.,2:nCols];

nYears = 2;
nMonths = 6;
nDays = nMonths*21;

Rdt = Spot./lag1(Spot) - 1;
HistVol = miss(zeros(nDates,nSpot),0);
t = nDays + 1;
do until t > nDates;
  x = Rdt[t-nDays:t,.];
  x = packr(x);
  if rows(x) > 0.90*nDays;
    HistVol[t,.] = 100*sqrt(260)*stdc(x)';
  endif;
  t = t + 1;
endo;

Months = unique(trunc(Dates/1e2),1);
StudyDates = 100*Months + 31;
indx = closest_index(StudyDates,Dates);
StudyDates = Dates[indx];
StudyDates = selif(StudyDates,StudyDates .>= 20050101);
indx_StudyDates = indnv(StudyDates,Dates);
nStudyDates = rows(StudyDates);

let Cases = 5 10 15 20;
nCases = rows(Cases);

Result1 = zeros(nDates,nCases);
Result2 = zeros(nDates,nCases);

BigIter = 1;
do until BigIter > nCases;

  nSelectedStocks = Cases[BigIter];

  PnL_E = zeros(nDates,nStudyDates);
  PnL_W = zeros(nDates,nStudyDates);

  Initial_Wealth = 100;
  Wealth_E = Initial_Wealth;
  Wealth_W = Initial_Wealth;

  Track_E = Initial_Wealth + zeros(nDates,1);
  Track_W = Initial_Wealth + zeros(nDates,1);

  Notional_Vega = 0.5;

  iter = 1;
  do until iter > nStudyDates-1;

    TradingDate = StudyDates[iter];
    BeginDate = TradingDate - nYears*1e4;
    {indx_Selected,score} = Stock_Selection(BeginDate,TradingDate,Dates,ImpVol[.,2:cols(ImpVol)],HistVol[.,2:cols(HistVol)],nSelectedStocks);

    indx_Selected = indx_Selected + 1;
    indx_Selected = 1 | indx_Selected;

    Spot_Selected = Spot[.,indx_Selected];
    ImpVol_Selected = ImpVol[indx_StudyDates[iter]+1,indx_Selected]';

    indx1 = indnv(StudyDates[iter],Dates);
    indx = iter + nMonths;
    indx = _min_(indx,nStudydates);
    indx2 = indnv(StudyDates[indx],Dates);
    indx_t = seqa(indx1,1,indx2-indx1+1);

    Rdt = ln(Spot_Selected[indx_t,.]./lag1(Spot_Selected[indx_t,.]));
    Rdt = missrv(Rdt,0);

    Rdt_Index = Rdt[.,1];
    Rdt = Rdt[.,2:nSelectedStocks+1];

    ImpVol_Index = ImpVol_Selected[1];
    ImpVol_Stocks = trimr(ImpVol_Selected,1,0);

    w = ones(nSelectedStocks,1)/nSelectedStocks;

    w_s2 = (Rdt^2)*w;

    rho = Rdt_Index^2 ./ w_s2;
    rho = missrv(rho,0);

    rho_star = ImpVol_Index^2 ./ ((ImpVol_Stocks^2)'w);
    rho_star = missrv(rho_star,0);
    rho_star = 0.0 | rho_star*ones(rows(rho)-1,1);
    Notional = (1/nDays) / (2*ImpVol_Index) * (100^2) * 252;
    PnL =  Notional * (rho_star - rho) .* w_s2;
    PnL = missrv(PnL,0);

    if rows(packr(PnL)) > 1;
      PnL_E[indx_t,iter] = PnL;
    endif;

    Notional = Wealth_E/Initial_Wealth * Notional_Vega;
    Track_E = Track_E + Notional*cumsumc(PnL_E[.,iter]);
    Wealth_E = Track_E[indx_t[1]+22];

    w = Index_Weights[indx_Selected[2:nSelectedStocks+1]-1];
    w = w / sumc(w);

    w_s2 = (Rdt^2)*w;

    rho = Rdt_Index^2 ./ w_s2;
    rho = missrv(rho,0);

    rho_star = ImpVol_Index^2 ./ ((ImpVol_Stocks^2)'w);
    rho_star = missrv(rho_star,0);
    rho_star = 0.0 | rho_star*ones(rows(rho)-1,1);
    Notional = (1/nDays) / (2*ImpVol_Index) * (100^2) * 252;
    PnL =  Notional * (rho_star - rho) .* w_s2;
    PnL = missrv(PnL,0);

    if rows(packr(PnL)) > 1;
      PnL_W[indx_t,iter] = PnL;
    endif;
 
    Notional = Wealth_W/Initial_Wealth * Notional_Vega;
    Track_W = Track_W + Notional*cumsumc(PnL_W[.,iter]);
    Wealth_W = Track_W[indx_t[1]+22];
 
    iter = iter + 1;
  endo;

  Result1[.,BigIter] = Track_E;
  Result2[.,BigIter] = Track_W;  

  BigIter = BigIter + 1;
endo;

data = Dates~Result1~Result2;
data = selif(data,(data[.,1] .>= 20041231) .and (data[.,1] .<= 20091231));
data = miss(data,100);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1; _plwidth = 10; _pcolor = 1|4;
  xtics(1,5*260,260,2);
  ytics(80,180,20,2);
  let xlab = "2005" "2006" "2007" "2008" "2009" "2010";
  asclabel(xlab,0);
  _plegstr = "1/n\000MCAP";
  _plegctl = {2 6 6 1};
  graphprt("-c=1 -cf=volatility17.eps");
  xy(0,data[.,8:9]);

proc (2) = Stock_Selection(BeginDate,TradingDate,Dates,ImpVol,HistVol,nSelectedStocks);
  local nStocks,indx,Score,i,PnL,indx_Selected;

  nStocks = cols(ImpVol);

  indx = selif(seqa(1,1,rows(Dates)),Dates .>= BeginDate .and Dates .<= TradingDate);

  HistVol = HistVol[indx,.];
  indx = indnv(TradingDate,Dates);
  ImpVol = ImpVol[indx,.]';
  Score = miss(zeros(nStocks,1),0);

  i = 1;
  do until i > nStocks;
    PnL = -(1/(2*ImpVol[i]))*(ImpVol[i]^2-HistVol[.,i]^2);
    PnL = packr(PnL);
    if PnL /= error(0);
      Score[i] = meanc(PnL .> 0);
    endif;
    i = i + 1;
  endo;  

  indx_Selected = seqa(1,1,nStocks)~Score;
  indx_Selected = rev(sortc(indx_Selected,2));
  indx_Selected = indx_Selected[1:nSelectedStocks,1];

  retp(indx_Selected,score);
endp;  

