new;
library qam,pgraph,optmum;

K = 100;
b = 0.05;
r = 0.05;
tau = 1/12;
S0 = seqa(80,1,41);
Sigma = 0.15~0.20~0.25;

fn fnDelta(S0) = BS_Straddle(S0,K,Sigma,tau,b,r); 
fn fnVega(Sigma) = BS_Straddle(S0,K,Sigma,tau,b,r); 
fn fnTheta(tau) = BS_Straddle(S0,K,Sigma,tau,b,r); 

Use_Numeric_Gradient = 0;

if Use_Numeric_Gradient; 
  Delta = gradp2(&fnDelta,S0);
  Gamma_ = hessp2(&fnDelta,S0);
  Vega = gradp2(&fnVega,Sigma);
  Theta = gradp2(&fnTheta,tau);
else;
  Delta = BS_Straddle_Delta(S0,K,Sigma,tau,b,r); 
  Gamma_ = BS_Straddle_Gamma(S0,K,Sigma,tau,b,r); 
  Vega = BS_Straddle_Vega(S0,K,Sigma,tau,b,r);  
  Theta = BS_Straddle_Theta(S0,K,Sigma,tau,b,r);  
endif;

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pcross = 1; _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|2|4;
  _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.25;
  xtics(80,120,10,2);
  xlabel("\216S]0[");

  setwind(1);
    _plegstr = "\202S\201 = 15%\000\202S\201 = 20%\000\202S\201 = 25%";
    _plegctl = {2 5 6 0.5};
    ytics(-1.0,1.0,0.5,2);
    ylabel("\216Delta");
    xy(S0,Delta);

    _plegctl = 0;

  setwind(2);
    ytics(0.0,0.20,0.05,2);
    ylabel("\216Gamma");
    xy(S0,Gamma_);

  setwind(3);
    ytics(0,25,5,2);
    ylabel("\216Vega");
    xy(S0,Vega);

  setwind(4);
    ylabel("\216Theta");
    ytics(-10,40,10,2);
    xy(S0,Theta);

    graphprt("-c=1 -cf=volatility2.eps");

  endwind;