new;
library qam,pgraph,optmum;

datFileName = "..\\data\\qam_spx_daily_option";

Data = loadd(datFileName);
vnames = getname(datFileName);

let selected_names = "date" "SPX_PI" "SPX_VIX";
indx = indcv(selected_names,vnames);
data = data[.,indx];

data = selif(data, (data[.,1] .>= 19900101) .and (data[.,1] .<= 20091231));
nDates = rows(data);

Dates = Data[.,1];
SPX = Data[.,2];
VIX = Data[.,3];

h = 5;
dSPX = 100*(SPX./lagn(SPX,h) - 1);
dVIX = VIX - lagn(VIX,h);
h = 22;
dSPX = dSPX ~ 100*(SPX./lagn(SPX,h) - 1);
dVIX = dVIX ~ (VIX - lagn(VIX,h));

VOL = 100*Compute_Running_Statistics(Dates,SPX[.,1],22,2);
h = 5;
dVOL = VOL - lagn(VOL,h);
h = 22;
dVOL = dVOL ~ (VOL - lagn(VOL,h));

dSPX = dSPX[.,1]~dSPX[.,1]~dSPX[.,2]~dSPX[.,2];
dVOL = dVIX~dVOL;

xx = seqa(-50,1,101);
yy = zeros(rows(xx),4);
R2 = zeros(4,1);

i = 1;
do until i > 4;
  Y = dSPX[.,i];
  X = ones(nDates,1)~dVOL[.,i];
  {Y,X} = packr2(Y,X);
  beta = Y/X;
  yy[.,i] = beta[1] + beta[2] .* xx; 
  R2[i] = 1 - sumc((Y-X*beta)^2)/sumc(Y^2);
  i = i + 1;
endo;

let string ptitle[4,1] = "\216VIX - 1W" "\216VIX - 1M"
                         "\216VOL - 1W" "\216VOL - 1M";

graphset;
  begwind;
  window(2,2,1);
  window(2,2,1);

  fonts("simplex simgrma");

  _pdate = ""; _pnum = 2; _pframe = 0;
  _plctrl = -1; _pcross = 1; _pstype = 4;
  _ptitlht = 0.25; _paxht = 0.22; _pnumht = 0.18;

  xtics(-50,50,10,2);
  ytics(-30,30,10,2);
  xlabel("\216\202Ds\201");
  ylabel("\216\202D\201S");    

  i = 1;
  do until i > 4;
    setwind(i);
      _pcolor = i;
      data = packr(dVOL[.,i]~dSPX[.,i]);     
      {x_data,y_data,indx_data} = Closest_Points(data[.,1],data[.,2],0.1);
      _ptitle = ptitle[i];
      xy(x_data,y_data);
    i = i + 1;
  endo;

  _plctrl = 0; _plwidth = 10; _pltype = 3; _pcolor = 12;

  i = 1;
  do until i > 4;
    setwind(4+i);
      _pcolor = 0|0;
      _ptitle = ptitle[i];
      xy(xx,yy[.,i]);
    i = i + 1;
  endo;

  graphprt("-c=1 -cf=volatility21.eps");

  endwind;  