new;
library qam,pgraph,optmum;
cls;

S0 = 100;
ImpVol = 0.10;
tau = 1/365;
r = 0.05;
b = 0.00;

K = S0;                            
Premium = BS_Straddle(S0,K,ImpVol,tau,b,r);

sigma = seqa(0.01,0.50/300,301);
sigma = trimr(sigma,3,0);
sigma = rev(sigma);
nSigma = rows(Sigma);

Sp = S0 + Premium;
Sm = S0 - Premium;
dp = (ln(Sp) - ln(S0)) ./ (sqrt(tau) * Sigma);
dm = (ln(Sm) - ln(S0)) ./ (sqrt(tau) * Sigma);
Pr = cdfn(dp) - cdfn(dm);

Q = zeros(nSigma,4);

alpha = 0.05;

Ns = 50000;

i = 1;
do until i > nSigma;
  rndseed 123;
  Yield = rndn(Ns,1)*sigma[i]*sqrt(tau);
  S1 = (1+Yield) * S0;

  Payoff = Straddle_Payoff(S1,K);
  PnL = (Premium - Payoff) ./ Premium;
  Q[i,.] = quantile(PnL,alpha|1-alpha|0.5)'~meanc(PnL);

  i = i + 1;
endo;
Q = Q[.,1 3 4 2];

Pr = Pr | 1.00;
Q = Q | ones(1,4);

nPr = rows(Pr);

graphset;
   fonts("simplex simgrma");  
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _pltype = 6|1|3|6; _plwidth = 10; _pcolor = 1|2|3|4;
  xlabel("\216Score");
  ylabel("\216PnL");
  xtics(30,100,10,2);
  ytics(-4,1,1,2);
  indx = seqa(1,1,nSigma);
  e = ones(nPr,1);
  _pline = e.*(1~6)~100*Pr~Q[.,1]~100*Pr~Q[.,4]~e.*(1~0~0);
  _plegstr = "Q(5%)\000Q(50%)\000Moyenne\000Q(95%)";
  _plegctl = {2 5 5 2};
  graphprt("-c=1 -cf=volatility3.eps");
  xy(100*Pr,Q);

data = 100*Pr~Q;
save volatility3 = data;
