new;
library qam,pgraph,optmum;
cls;

S0 = 100;
ImpVol = 0.10;
tau = 1/365;
r = 0.05;
b = 0.00;

drawdown = 2;
x = 2 .* ImpVol .* sqrt(tau) .* (drawdown+1) ./ sqrt(2*pi);

C_Strangle_Up = 1 + x;
C_Strangle_Down = 1 - x;
Smile_Up = 0.00; 
Smile_Down = 0.02;

K_Straddle = S0;                        
K_Strangle_Up = S0 .* C_Strangle_Up;    
K_Strangle_Down = S0 .* C_Strangle_Down;

ImpVol_Up = ImpVol + Smile_Up;
ImpVol_Down = ImpVol + Smile_Down;

CallSpread = BS_CallSpread(S0,K_Straddle,K_Strangle_Up,ImpVol,ImpVol_Up,tau,b,r);
PutSpread = BS_PutSpread(S0,K_Strangle_Down,K_Straddle,ImpVol_Down,ImpVol,tau,b,r);
Premium = (PutSpread + CallSpread);

sigma = seqa(0.01,0.50/300,301);
sigma = trimr(sigma,3,0);
sigma = rev(sigma);
nSigma = rows(Sigma);

Sp = S0 + Premium;
Sm = S0 - Premium;
dp = (ln(Sp) - ln(S0)) ./ (sqrt(tau) * Sigma);
dm = (ln(Sm) - ln(S0)) ./ (sqrt(tau) * Sigma);
Pr = cdfn(dp) - cdfn(dm);

Q = zeros(nSigma,4);

alpha = 0.05;

Ns = 50000;

i = 1;
do until i > nSigma;
  rndseed 123;
  Yield = rndn(Ns,1)*sigma[i]*sqrt(tau);
  S1 = (1+Yield) * S0;

  Payoff = PutSpread_Payoff(S1,K_Strangle_Down,K_Straddle) + 
           CallSpread_Payoff(S1,K_Straddle,K_Strangle_Up);
  PnL = (Premium - Payoff) ./ Premium;
  Q[i,.] = quantile(PnL,alpha|1-alpha|0.5)'~meanc(PnL);

  i = i + 1;
endo;
Q = Q[.,1 3 4 2];

graphset;
   fonts("simplex simgrma");  
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _pltype = 6|1|3|6; _plwidth = 10; _pcolor = 1|2|3|4;
  xlabel("\216Score");
  ylabel("\216PnL");
  xtics(30,100,10,2);
  ytics(-4,1,1,2);
  indx = seqa(1,1,nSigma);
  e = ones(nSigma,1);
  _pline = e.*(1~6)~100*Pr~Q[.,1]~100*Pr~Q[.,4]~e.*(1~0~0);
  _plegstr = "Q(5%)\000Q(50%)\000Moyenne\000Q(95%)";
  _plegctl = {2 5 5 2};
  graphprt("-c=1 -cf=volatility5.eps");
  xy(100*Pr,Q);