new;
library qam,optmum,pgraph;

datFileName = "..\\data\\qam_spx_daily_option";

Data = loadd(datFileName);
vnames = getname(datFileName);

let selected_names = "date" "SPX_PI" "SPX_VIX";
indx = indcv(selected_names,vnames);
data = data[.,indx];

data = selif(data, (data[.,1] .>= 19900101) .and (data[.,1] .<= 20091231));
nDates = rows(data);

Dates = Data[.,1];
SPX = Data[.,2];
VIX = Data[.,3];

h = 1;
dSPX = 100*(SPX./lagn(SPX,h) - 1);
dVIX = VIX - lagn(VIX,h);

{H1,x1} = regHurst(dSPX,2,10);
{H2,x2} = regHurst(dVIX,2,10);

t = x1[.,1]~x2[.,1];
Q = x1[.,4]~x2[.,4];
V = x1[.,5]~x2[.,5];
fit = x1[.,6]~x2[.,6];

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1; _plwidth = 10; _pcolor = 1|4;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;

  xlabel("\216log t"); 
  ytics(0.0,2.50,0.50,0);

  setwind(1);
    title("\216S&P 500");
    ylabel("\216log Q]t[");
    logx(t[.,1],log(Q[.,1])~fit[.,1]);

  setwind(2);
    title("\216VIX");
    ylabel("\216log Q]t[");
    logx(t[.,2],log(Q[.,2])~fit[.,2]);

  Bounds = ones(rows(V),2).*(0.809~1.862);
  _pcolor = 1|4|4; _pltype = 6|1|1;
  ytics(0,2.5,0.5,2);
  xtics(0,5000,1000,2);
  xlabel("\216t"); 

  setwind(3);
    title("\216S&P 500");
    ylabel("\216V]t[");
    xy(t[.,1],V[.,1]~Bounds);

  setwind(4);
    title("\216VIX");
    ylabel("\216V]t[");
    xy(t[.,2],V[.,2]~Bounds);

    graphprt("-c=1 -cf=arfima4.eps");

  endwind;
