new;
library qam,tsm,optmum,pgraph;
TSMset;

z = eye(2);
d = zeros(2,1);
H = zeros(2,2);
T = (0.5~0.5) |
    (0.0~0.5);
c = zeros(2,1);
R = eye(2);
Q = eye(2)*0.10^2;

proc sgf(lambda);
  local n,Fz,w;

  n = rows(lambda);

  call SSM_build(Z,d,H,T,c,R,Q,0);
  Fz = sgf_SSM(lambda);
  w = Fz[.,2]./sqrt(Fz[.,1] .* Fz[.,4]);

  retp(w);
endp;

let coeffs = -0.9 -0.5 0.0 0.5 0.9;
nIters = rows(coeffs);
lambda = seqa(1e-5,2*pi/100,101);
n = rows(lambda);
alpha = zeros(n,nIters);
phi = zeros(n,nIters);

iter = 1;
do until iter > nIters;
  T = (0.5~coeffs[iter]) |
      (0.0~0.5);
  w = sgf(lambda);
  {alpha[.,iter],phi[.,iter]} = topolar2(w);
  iter = iter + 1;
endo;

alpha1 = alpha;
phi1 = phi;

iter = 1;
do until iter > nIters;
  T = (0.5~coeffs[iter]) |
      (0.4~0.5);
  w = sgf(lambda);
  {alpha[.,iter],phi[.,iter]} = topolar2(w);
  iter = iter + 1;
endo;

alpha2 = alpha;
phi2 = phi;

iter = 1;
do until iter > nIters;
  T = (0.5~coeffs[iter]) |
      (-0.5~0.5);
  w = sgf(lambda);
  {alpha[.,iter],phi[.,iter]} = topolar2(w);
  iter = iter + 1;
endo;

alpha3 = alpha;
phi3 = phi;

alpha2 = alpha;
phi2 = phi;

iter = 1;
do until iter > nIters;
  T = (0.5~coeffs[iter]) |
      (-0.7~0.5);
  w = sgf(lambda);
  {alpha[.,iter],phi[.,iter]} = topolar2(w);
  iter = iter + 1;
endo;

alpha4 = alpha;
phi4 = phi;

/*
graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|5; _pcolor = 1|2|3|4; _plwidth = 10;
  _pnumht = 0.225; _paxht = 0.225; _ptitlht = 0.275;

  xtics(0,pi,pi/4,0);
  let xlab = "0" "\202p\201/4" "\202p\201/2" "\2013\202p\201/4" "\202p\201";
  let ylab = "0" "\202p\201/2" "\202p\201" "\2013\202p\201/2" "2\202p\201";

  setwind(1);
    ytics(0,1.0,0.2,0);
    asclabel(xlab,0);
    ylabel("\216\202a\201]x,y[(\202l\201)");
    title("\216A]1,2[ = 0.0");
    xy(lambda,alpha1);

  setwind(2);
    asclabel(xlab,ylab);
    ytics(0,2*pi,pi/2,0);
    ylabel("\216\202Q\201]x,y[(\202l\201)");
    xy(lambda,phi1);

  setwind(3);
    asclabel(xlab,0);
    ytics(0,1.0,0.2,0);
    ylabel("\216\202a\201]x,y[(\202l\201)");
    title("\216A]1,2[ = 0.2");
    xy(lambda,alpha2);

  setwind(4);
    asclabel(xlab,ylab);
    ytics(0,2*pi,pi/2,0);
    ylabel("\216\202Q\201]x,y[(\202l\201)");
    _plegstr = "A]2,1[ = -0.9\000A]2,1[ = -0.5\000A]2,1[ = 0.0\000A]2,1[ = 0.4";
    _plegctl = {2 5 5.5 0.75};
    xy(lambda,phi2);

    graphprt("-c=1 -cf=spectral12.eps");

  endwind;
*/


graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|5|4; _pcolor = 1|2|3|4|5; _plwidth = 10|10|10|10|12;
  _pnumht = 0.225; _paxht = 0.225; _ptitlht = 0.275;

  xtics(0,pi,pi/4,0);
  let xlab = "0" "\202p\201/4" "\202p\201/2" "\2013\202p\201/4" "\202p\201";
  let ylab = "0" "\202p\201/2" "\202p\201" "\2013\202p\201/2" "2\202p\201";

  xtics(-1,1,0.5,2);
  ytics(-1,1,0.5,2);

  setwind(1);
    title("\216A]1,2[ = 0");
    polar(alpha1,phi1);

  setwind(2);
    title("\216A]1,2[ = 0,4");
    polar(alpha2,phi2);

  setwind(3);
    title("\216A]1,2[ = -0,5");
    polar(alpha3,phi3);

  setwind(4);
    title("\216A]1,2[ = -0,9");
    _plegstr = "A]2,1[ = -0,9\000A]2,1[ = -0,5\000A]2,1[ = 0\000A]2,1[ = 0,4\000A]2,1[ = 0,9";
    _plegctl = {2 6 -1.5 5.75};
    polar(alpha3,phi4);

    graphprt("-c=1 -cf=spectral12.eps");

  endwind;


