new;
library tsm,optmum,pgraph,qam;

cls;

rndseed 123456;

t = seqa(0,1/250,250*10);
nt = rows(t);

nc = 3;
p = 5 + 5 * rndu(1,nc);
omega = 5 * rndu(1,nc);
a = 1.5 * rndn(1,nc);

x_lc = a .* sin(2*pi./p.*t+omega);

nc = 5;
p = rndu(1,nc);
omega = rndu(1,nc);
a = 0.25*rndn(1,nc);

x_sc = a .* sin(2*pi./p.*t+omega);

x = sumr(x_lc) + sumr(x_sc) + 0.10*rndn(nt,1);

d = fourier(x);
abs_d = abs(d);
m = rev(sortc(abs_d,1));

let bd = 2 4 6 8 10 20 40 50 100;
nd = rows(bd);
decomp_x = zeros(nt,nd);

i = 1;
do until i > nd;
  decomp_x[.,i] = inverse_fourier(d .* (abs(d) .>= m[bd[i]]));
  i = i + 1;
endo;

decomp_x = real(decomp_x);

graphset;
  begwind;
  window(3,3,1);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _pcolor = 1|2|4; _plwidth = 0;
  _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.35;
  xlabel("\216t\201");
  xtics(0,10,2,2);
  ytics(-2,2,1,0);

  i = 1;
  do until i > rows(_pwindmx);
    setwind(i);
      title(ftos(bd[i],"\216m = %lf",1,0));
      _pcolor = 1 + i % 8;
      xy(t,decomp_x[.,i]);
    i = i + 1;
  endo;

  graphprt("-c=1 -cf=spectral15.eps");
  
  endwind;

