new;
library qam,pgraph,tsm,optmum;

rndseed 123456789;

phi = 0.5;
sigma = 0.20;

n = 1000;
_fourier = 1;
x = recserar(sigma * rndn(n,1),0,phi);
t = seqa(1,1,n);

{lambda,I} = PDGM(x);
sdf = spectral_density_arma(phi,0,sigma,lambda);
_smoothing = 50|4|1|0.25;  /* Bandwidth = 10 and Tukey lag window */
Is = Smoothing(I);

I = I / (2*pi);
Is = Is / (2*pi);

k = 50;

t = seqa(0,1,k+1);
r0 = phi^t;

r1 = compute_autocovariance(x,k);
r1 = r1/r1[1];
r2 = real(inverse_fourier(I));
r2 = r2[1:k+1]/r2[1];

r3 = real(inverse_fourier(Is));
r3 = r3[1:k+1]/r3[1];

graphset;
  window3u;
  fonts("simplex simgrma");
  
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pcross = 1;
  _pltype = 6|3; _plwidth = 10;
  _pnumht = 0.225; _paxht = 0.25; 
  xtics(0,50,10,2);
  ytics(-0.2,1.0,0.2,0);
  xlabel("\216k");

  _pcolor = 1|2;
  setwind(1);
    _plegstr = "\202r\201(k)\000Empirique";
    _plegctl = {2 6 5 5};
    xy(0,r0~r1);

  _pcolor = 1|3;
  setwind(2);
    _plegstr = "\202r\201(k)\000Periodogramme";
    _plegctl = {2 6 4.5 5};
    xy(0,r0~r2);

  _pcolor = 1|4;
  _pmsgstr = "-";
  _pmsgctl = -3.23~5.43~0.07~45~2~0~5 ; 

  setwind(3);
    _plegstr = "\202r\201(k)\000Tukey";
    _plegctl = {2 6 5 5};
    xy(0,r0~r3);

   graphprt("-c=1 -cf=spectral9.eps");

  endwind;