/*
**> Results MCMC
*/

new;
library qam,pgraph,optmum,cml;

FileName = "sv2";
loadm all_results = ^FileName;

Nr = 3000;
Ns = 8000;

h = vread(all_results,"h");
h = h[.,Nr+1:Nr+Ns];
sVol = exp(0.5 * h);

beta = vread(all_results,"beta");
beta = trimr(beta,Nr,0);

gamma_ = vread(all_results,"gamma");
gamma_ = trimr(gamma_,Nr,0);

phi = vread(all_results,"phi");
phi = trimr(phi,Nr,0);

sigma2v = vread(all_results,"sigma2v");
sigma2v = trimr(sigma2v,Nr,0);
sigma_v = sqrt(sigma2v);

x_beta = seqa(-0.005,0.01/100,101);
x_gamma = seqa(-0.60,0.70/100,101);
x_phi = seqa(0.9,0.1/100,101);
x_sigma = seqa(0.05,0.10/100,101);

{d_beta,F_beta} = regKernelDensity(beta,x_beta);
{d_gamma,F_gamma} = regKernelDensity(gamma_,x_gamma);
{d_phi,F_phi} = regKernelDensity(phi,x_phi);
{d_sigma,F_sigma} = regKernelDensity(sigma_v,x_sigma);

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pframe = 0; _pnum = 2;
  _plwidth = 10; _pltype = 6; 
  _ptitlht = 0.30; _pnumht = 0.20; _paxht = 0.25;

  setwind(1);
    _pcolor = 1;
    title("\216\202b\201 (x 10[3])");
    xtics(-5,5,2.5,1);
    ytics(0,300,100,2);
    xy(1e3*x_beta,d_beta);

  setwind(2);
    _pcolor = 2;
    title("\216\202g\201");
    xtics(-0.6,0.1,0.1,1);
    ytics(0,6,2,2);
    xy(x_gamma,d_gamma);

  setwind(3);
    _pcolor = 3;
    title("\216\202F\201");
    xtics(0.9,1.0,0.025,1);
    ytics(0,40,10,2);
    xy(x_phi,d_phi);

  setwind(4);
    _pcolor = 4;
    title("\216\202s\201]v[ (x 10[2])");
    xtics(7,13,1,1);
    ytics(0,60,20,2);
    xy(1e2*x_sigma,d_sigma);

    graphprt("-c=1 -cf=sv7.eps");

  endwind;


