/*
**> Results MCMC
*/

new;
library qam,pgraph,optmum,cml;

let string FileNames = "sv2" "sv5" "sv3" "sv4";
nModels = rows(FileNames);

Nr = 3000;
Ns = 8000;

all_q = zeros(nModels,12);

i = 1;
do until i > nModels;

  FileName = FileNames[i];
  loadm all_results = ^FileName;

  h = vread(all_results,"h");
  h = h[.,Nr+1:Nr+Ns];
  sVol = exp(0.5 * h);

  beta = vread(all_results,"beta");
  beta = 1e3 * trimr(beta,Nr,0);

  gamma_ = vread(all_results,"gamma");
  gamma_ = trimr(gamma_,Nr,0);

  phi = vread(all_results,"phi");
  phi = trimr(phi,Nr,0);

  sigma2v = vread(all_results,"sigma2v");
  sigma2v = trimr(sigma2v,Nr,0);
  sigma_v = 100*sqrt(sigma2v);

  data = beta~gamma_~phi~sigma_v;
  let alpha = 0.025 0.50 0.975;
  q = quantile(data,alpha);
  all_q[i,.] = reshape(q',1,12);

  i = i + 1;
endo;

print ftosa(all_q[.,1:6],"%lf",4,2);

print ftosa(all_q[.,7:12],"%lf",4,2);