new;
library qam,pgraph,optmum;
qamSet;

rndseed 123;

proc (1) = simulate_unit_root(y0,sigma,nt);
  local k,u,y;

  k = maxc(rows(y0)|rows(sigma)); 
  u = rndn(nt,k) .* sigma';
  y0 = y0' .* ones(1,k);
  y = recserar(u,y0,ones(1,k));

  retp(y);
endp;

y = simulate_unit_root(100|50,0.5|5,100);
y1 = y[.,1];
y2 = y[.,2];
y3 = -10 + 2*y1 - y2 + 0.25*rndn(100,1);
y4 = 2*y1 - y2 - y3;

graphset;
  begwind;
  window(2,2,0);
   _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pltype = 6|1;
  _pnumht = 0.225; _ptitlht = 0.25;

  setwind(1);
    title("\216y[1]]t[");
    _pcolor = 1;
    xy(0,y1);

  setwind(2);
    title("\216y[2]]t[");
    _pcolor = 2;
    xy(0,y2);

  setwind(3);
    title("\216y[3]]t[");
    _pcolor = 3;
    xy(0,y3);

  setwind(4);
    title("\2162y[1]]t[-y[2]]t[-y[3]]t[");
    _pcolor = 4;
    xy(0,y4);

    graphprt("-c=1 -cf=ts1.eps");

  endwind;


