new;
library qam,pgraph,optmum,tsm;
tsmSet;

#include alternative_beta.src

let string selected_Names = "S&PCOMP" "FRUSS2L" "DJES50I" "TOKYOSE" "BMUS10Y" "USEURWD" "FREDD1M" "HFRIFWC";

nFactors = rows(selected_Names) - 2;

datPathName = "..\\data\\";
datFileName = datPathName $+ "qam_hfr_monthly_factors"; 
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);
Dates = data[.,1];
indx_Selected_Names = indsav(Selected_Names,vnames);
Data = data[.,indx_Selected_Names];

Monthly_Factor_Returns = Data;
Monthly_Factor_Dates = Dates;

datFileName = datPathName $+ "qam_hfr_monthly_data"; 
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);
Dates = data[.,1];
indx_Selected_Names = indsav(Selected_Names,vnames);
Data = data[.,indx_Selected_Names];

Monthly_Factor_Index = Data;
if Dates $/= Monthly_Factor_Dates;
  errorlog "error: Dates do not match.";
endif;

R_Fund = Monthly_Factor_Returns[.,nFactors+2];
R_Factors = Monthly_Factor_Returns[.,1:nFactors];
Dates = Monthly_Factor_Dates;
nDates = rows(Dates);

Begin_Date = 19931231;
nMissingDate = sumc(Monthly_Factor_Dates .<= Begin_Date);

P0 = 0*ones(nFactors,nFactors);

a0 = 0*ones(nFactors,1);
{alpha_KF,beta_KF,KGain} = Alternative_Beta_KF(R_Fund,R_Factors,0,a0,P0,0,nMissingDate,1);
Beta1 = 100*beta_KF;

a0 = 0.50*ones(nFactors,1);
{alpha_KF,beta_KF,KGain} = Alternative_Beta_KF(R_Fund,R_Factors,0,a0,P0,0,nMissingDate,1);
Beta2 = 100*beta_KF;

diff = selif(Beta1-beta2,Dates .> 19970101);
print ftosa(maxc(abs(diff)),"%lf",3,2);

diff = selif(Beta1-beta2,Dates .> 20000101);
print ftosa(maxc(abs(diff)),"%lf",3,2);

graphset;
  begwind;
  window(2,3,0);
    _pdate = ""; _pnum = 2; _pframe = 0;
    _pltype = 1|3; _plwidth = 10; _pcolor = 1|4;
    _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.35;
    xtics(1,nDates,12*5,5);
    let xlab = "90" "95" "00" "05" "10";
    asclabel(xlab,0);
    ytics(-30,70,10,2);

   indx = 1;
   setwind(1);
     title("\216SPX");
     xy(0,beta1[.,indx]~Beta2[.,indx]);

   indx = 2;
   setwind(2);
     title("\216RTY/SPX");
     xy(0,beta1[.,indx]~Beta2[.,indx]);

   indx = 3;
   setwind(3);
     title("\216SX5E/SPX");
     xy(0,beta1[.,indx]~Beta2[.,indx]);

   indx = 4;
   setwind(4);
     title("\216TPX/SPX");
     xy(0,beta1[.,indx]~Beta2[.,indx]);

   indx = 5;
   setwind(5);
     title("\216UST");
     xy(0,beta1[.,indx]~Beta2[.,indx]);

   indx = 6;
   setwind(6);
     _plegstr = "b]0[ = 0%\000b]0[ = 50%";
     _plegctl = {2 7 5 5};
     title("\216EUR/USD");
     xy(0,beta1[.,indx]~Beta2[.,indx]);

     graphprt("-c=1 -cf=ts11.eps");

   endwind;