new;
library qam,pgraph,optmum,tsm;
tsmSet;

#include alternative_beta.src

let string selected_Names = "S&PCOMP" "FRUSS2L" "DJES50I" "TOKYOSE" "BMUS10Y" "USEURWD" "FREDD1M" "HFRIFWC";

Begin_Date = 19931231;
End_Date = 20080930;

nFactors = rows(selected_Names) - 2;

datPathName = "..\\data\\";
datFileName = datPathName $+ "qam_hfr_monthly_factors"; 
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);
Dates = data[.,1];
indx_Selected_Names = indsav(Selected_Names,vnames);
Data = data[.,indx_Selected_Names];
Data = selif(Data,Dates .<= End_Date);

Monthly_Factor_Returns = Data;
Monthly_Factor_Dates = Dates;

datFileName = datPathName $+ "qam_hfr_monthly_data"; 
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);
Dates = data[.,1];
indx_Selected_Names = indsav(Selected_Names,vnames);
Data = data[.,indx_Selected_Names];
Data = selif(Data,Dates .<= End_Date);

Monthly_Factor_Index = Data;
if Dates $/= Monthly_Factor_Dates;
  errorlog "error: Dates do not match.";
endif;

Monthly_Factor_Dates = selif(Monthly_Factor_Dates,Dates .<= End_Date);
Dates = Monthly_Factor_Dates;

R_Fund = Monthly_Factor_Returns[.,nFactors+2];
R_Factors = Monthly_Factor_Returns[.,1:nFactors];
nDates = rows(Dates);

nMissingDate = sumc(Monthly_Factor_Dates .<= Begin_Date);

R_Libor = lagn(Data[.,7],1)/1200;

{y,x} = packr2(R_Fund,R_Factors);
Traditional_Beta = y/x;
R_Beta = sumr(Traditional_Beta' .* (R_Factors + R_Libor));

P0 = 1.00*ones(nFactors,nFactors);
a0 = 0*ones(nFactors,1);
{alpha,Alternative_Beta,KGain} = Alternative_Beta_KF(R_Fund,R_Factors,0,a0,P0,0,nMissingDate,1);
te = trimr(KF_Matrix(2),1,0);  // eliminate the first te 

Traditional_Beta = meanc(packr(Alternative_Beta));

R_Cash = (1 - sumc(Traditional_Beta)) .* R_Libor;
R_Beta = sumr(Traditional_Beta' .* (R_Factors + R_Libor)) + R_Cash;

R_Cash = (1 - sumr(lag1(Alternative_Beta))) .* R_Libor;
R_Tracker = sumr(lag1(Alternative_Beta) .* (R_Factors + R_Libor)) + R_Cash;

R = R_Cash ~ R_Beta ~ R_Tracker ~ Data[.,8]/100;
R = missrv(R,0);
Index = 100 * cumprodc(1 + R);
Index = Index[nMissingDate+1:rows(Index),.];
Index = 100 * Index ./ Index[1,.];
Dates = Dates[nMissingDate+1:rows(Dates),.];
nDates = rows(Dates);

Years = trunc(Dates/1e4);
Years = unique(Years,1);
nYears = rows(Years);

let Interest_Dates[3,2] = 19931231 20081231
                          19961231 20081231
                          19991231 20081231;
nID = rows(Interest_Dates);

Data = zeros(nYears+nID,7);

i = 1;
do until i > nYears;

  if i == 1;
    Begin_Year = Dates[1];
  else;
    Begin_Year = selif(Dates, trunc(Dates/1e4) .== Years[i-1]);
    Begin_Year = Begin_Year[rows(Begin_Year)];
  endif;

  if i == nYears;
    End_Year = Dates[nDates];
  else;
    End_Year = selif(Dates, trunc(Dates/1e4) .== Years[i]);
    End_Year = End_Year[rows(End_Year)];
  endif;

  tmp = selif(Index,(Dates .>= Begin_Year) .and (Dates .<= End_Year));
  n = rows(tmp);
  tmp = 100 * tmp ./ tmp[1,.];
  tmp = tmp[n,.]';

  Rdt = (tmp[2]/100 - 1) |
        (tmp[4]/tmp[2] - 1) |
        (tmp[3]/100 - 1) |
        (tmp[4]/tmp[3] - 1) |
        (tmp[4]/100 - 1) ;

  Data[i,.] = begin_Year~End_Year~100*Rdt';
  
  i = i + 1;
endo;

i = 1;
do until i > nID;
  Begin_Year = Interest_Dates[i,1];
  End_Year = Interest_Dates[i,2];
  tmp = selif(Dates~Index,(Dates .>= Begin_Year) .and (Dates .<= End_Year));
  n = rows(tmp);
  dt = etdays2(tmp[1,1],tmp[n,1])/365;
  tmp = tmp[.,2:cols(tmp)];
  tmp = 100 * tmp ./ tmp[1,.];
  tmp = tmp[n,.]';

  Rdt = (tmp[2]/100 - 1) |
        (tmp[4]/tmp[2] - 1) |
        (tmp[3]/100 - 1) |
        (tmp[4]/tmp[3] - 1) |
        (tmp[4]/100 - 1) ;

  Rdt = (1+Rdt)^(1/dt) - 1;

  Data[nYears+i,.] = begin_Year~End_Year~100*Rdt';  
  i = i + 1;
endo;

nDates = rows(Index);
t = seqa(1,1,nDates);
x = seqa(1,0.5,nDates*2);
y = zeros(rows(x),cols(Index));
i = 1;
do until i > cols(Index);
  c = csspline(t,Index[.,i],1.0,1.0);
  y[.,i] = fspline(c,x);
  i = i + 1;
endo;

nX = rows(x);

e = ones(rows(x),1);
pline1 = e.*(1~6)~x~0*y[.,1]~x~y[.,2]~e.*(1~2~5) |
         e.*(1~6)~x~y[.,2]~x~y[.,4]~e.*(1~4~5) ;

pline2 = e.*(1~6)~x~0*y[.,1]~x~y[.,2]~e.*(1~2~5) |
         e.*(1~6)~x~y[.,2]~x~y[.,3]~e.*(1~3~5) |
         e.*(1~6)~x~y[.,3]~x~y[.,4]~e.*(1~4~5) ;

cls;
__fmtnv  = { "*.*lf " 16 2 };
call printfmt(data[.,1 2 4 3 6 5 7],1);

pqgwin many;

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9,6.855,0,0,1);

  fonts("simplex simgrma");

  ytics(100,500,100,2);
  xtics(0,nDates,12,2);
  let xlab = "95" "96" "97" "98" "99" "00" "01" "02" "03" "04" "05" "06" "07" "08" "09";
  asclabel(xlab,0);
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 12; _pcolor = 2|4;

  setwind(1);
    _pbartyp = {6 2, 6 4};
    _plegstr = "\202b\201[(T)]\000\202a\201[(T)]";
    _plegctl = {2 7 1 5}; 
    bar(x,-y[.,2 4]);

  let xlab = "94" "95" "96" "97" "98" "99" "00" "01" "02" "03" "04" "05" "06" "07" "08" "09";
  asclabel(xlab,0);
  _plegctl = 0; 

  setwind(2);
    _pline = pline1;
    _parrow = x[nX]+1~100~x[nX]+1~y[nX,2]~4~0.25~02~0~1~6~10 |
              x[nX]+1~y[nX,2]~x[nX]+1~y[nX,4]~4~0.25~02~0~1~6~10 ;
    _pmsgstr = "\202b\201\000\202a\201";
    _pmsgctl = x[nX]+4~0.5*(100+y[nX,2])~0.20~0~1~0~10 |
               x[nX]+4~0.5*(y[nX,2]+y[nX,4])~0.20~0~1~0~10 ;
    xtics(0,nDates,12,2);
    xy(x,y[.,2 4]);

    graphprt("-c=1 -cf=ts14-1.eps");

  endwind;

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9,6.855,0,0,1);

  fonts("simplex simgrma");

  ytics(100,500,100,2);
  xtics(0,nDates,12,2);
  let xlab = "95" "96" "97" "98" "99" "00" "01" "02" "03" "04" "05" "06" "07" "08" "09";
  asclabel(xlab,0);
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 12; _pcolor = 2|3|4;

  setwind(1);
    _pbartyp = {6 2, 6 3, 6 4};
    _plegstr = "Traditional Beta\000Alternative Beta\000Alternative Alpha";
    _plegstr = "\202b\201[(T)]\000\202b\201[(A)]\000\202a\201[(T)]";
    _plegctl = {2 7 1 5}; 
    bar(x,-y[.,2:4]);

  let xlab = "94" "95" "96" "97" "98" "99" "00" "01" "02" "03" "04" "05" "06" "07" "08" "09";
  asclabel(xlab,0);
  _plegctl = 0; 

  setwind(2);
    _pline = pline2;
    _parrow = x[nX]+1~100~x[nX]+1~y[nX,3]~4~0.25~02~0~1~6~10 |
              x[nX]+1~y[nX,3]~x[nX]+1~y[nX,4]~4~0.25~02~0~1~6~10 ;
    _pmsgstr = "\202b\201\000\202a\201";
    _pmsgctl = x[nX]+4~0.5*(100+y[nX,3])~0.20~0~1~0~10 |
               x[nX]+4~0.5*(y[nX,3]+y[nX,4])~0.20~0~1~0~10 ;
    xtics(0,nDates,12,2);
    xy(x,y[.,2:4]);

    graphprt("-c=1 -cf=ts14-2.eps");

  endwind;