new;
library qam,optmum,pgraph;

rndseed 156;

x1 = rndu(200,1)*5;
x2 = seqa(1,1,200);
x = ones(200,1)~x1~x2;
y1 = 2 + x2[1:100] + 3*x1[1:100] + rndn(100,1);
y2 = 10 + x2[101:200] + 3*x1[101:200] + rndn(100,1);
y = y1 | y2;

{beta,stderr,residuals,sigma,RSS} = regRLS(y,x);

k = 3;
nobs = 200;
t = seqa(1,1,nobs);

residuals = missrv(residuals,0);

u = residuals[.,1];
v = residuals[.,2];
w = residuals[.,3];

s2 = sumc(u^2)/(nobs-k);
wbar = sumc(w^2);
cusum = cumsumc(w)/sqrt(s2);
stderr_cusum = sqrt(t-k);
cusumsq = cumsumc(w^2) / wbar;

tstudent = miss(beta ./ stderr,__Infp);
beta_bound = beta[.,1]~(beta[.,1] - 2*stderr[.,1])~(beta[.,1] + 2*stderr[.,1]);
v_bound = v~(-2*sigma)~(2*sigma);
cusum_bound = cusum~(cusum - 2*stderr_cusum)~(cusum + 2*stderr_cusum);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|3; _plwidth = 10; _pcolor = 1|4|4;
  _paxht = 0.225; _pnumht = 0.20; 

  xlabel("\216t");
  xtics(0,200,50,2);

  _ptitlht = 0.275;

  setwind(1);
    title("\216c]t[");
    ytics(-2,4,2,0);
    xy(t,beta_bound);
  setwind(2);
    title("\216v]t[");
    ytics(-5,10,5,0);
    xy(t,v_bound);

  _ptitlht = 0.25;

  setwind(3);
    title("\216Test CUSUM");
    ytics(-25,100,25,0);
    xy(t,cusum_bound);
  setwind(4);
    title("\216Test CUSUMSQ");
    ytics(0,1.0,0.20,0);
    xy(t,cusumsq~(t/nobs));

  graphprt("-c=1 -cf=ts2.eps");

endwind;

