new;
library pf,pgraph,qam,optmum;

rndseed 123;

PathName = "..\\data\\";

datFileName = PathName $+ "roncalli-weisang-msci"; 
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);
Dates = data[.,1];

let selected_Names = "MSUSAML" "MSEMUI$";
indx_Selected_Names = indsav(Selected_Names,vnames);
Data = data[.,indx_Selected_Names];

R_Data = missrv(Data./lag1(Data) - 1,0);
nDates = rows(Dates);
t = seqa(1,1,nDates);

Coeffs = reshape(0,5*12,1) | 
         reshape(0.5,3*12,1) | 
         reshape(0.25,12,1) | 
         reshape(0.75,6,1) | 
         reshape(1.0,20*12,1) ;
Coeffs = Coeffs[1:nDates];
Coeffs1 = Coeffs~(1-Coeffs);

Period = 12 * (2 .* (Dates .<= 19950601) + 5 .* (Dates .> 19950601) );

Coeffs = 0.5 * (1 + sin(2*pi*t./Period));
Coeffs2 = Coeffs~(1-Coeffs);

Coeffs = Coeffs2 .* (Dates .< 19950601) +
         Coeffs1 .* ((Dates .>= 19950601) .and (Dates .<= 20010101)) +
         Coeffs2 .* (Dates .> 20010101) ;

R_Fund = sumr(R_Data .* Coeffs);
Fund = 100 * cumprodc(1 + R_Fund);
Data = Data ~ Fund;

Coeffs = trimr(100*Coeffs,1,0);
Data = trimr(Data,1,0);
Data = 100 * Data./Data[1,.];

graphset;
  begwind;
  window(2,2,0);

  _pdate = 0; _pframe = 0; _pnum = 2;
  _plwidth = 10; _pltype = 6;
  _paxht = 0.225; _pnumht = 0.20; _ptitlht = 0.275;
  xtics(1,2*12*10,12*2,1);
  let xlab = "90" "92" "94" "96" "98" "00" 
             "02" "04" "06" "08";
  asclabel(xlab,0);
  ytics(0,500,100,2);

  setwind(1);
    _pcolor = 1;
    title("\216MSCI USA");
    xy(0,Data[.,1]);

  setwind(2);
    _pcolor = 2;
    title("\216MSCI EMU");
    xy(0,Data[.,2]);

  setwind(3);
    ytics(0,100,20,2);
    _pcolor = 3;
    title("\216w]t[[(USA)] (en %)");
    xy(0,Coeffs[.,1]);

  setwind(4);
     ytics(0,500,100,2);
    _pcolor = 4;
    title("\216Valeur du fonds");
    xy(0,Data[.,3]);

    graphprt("-c=1 -cf=ts22.eps");

  endwind;
