new;
library qam,pgraph;
cls;

datPathName = "..\\data\\";
datFileName = datPathName $+ "qam_sp500_monthly";

data = loadd(datFileName);
vnames = "" $+ getname(datFileName);
data[.,1] = data[.,1]/1e6;

BeginDate = 19500101;
EndDate = 20091231;
Dates = data[.,1];
data = data[.,cols(data)];

Rdt = ln(data) - ln(lag1(data));
Rdt = selif(Rdt, (Dates .>= BeginDate) .and (Dates .<= EndDate));
Dates = selif(Dates, (Dates .>= BeginDate) .and (Dates .<= EndDate));
nDates = rows(Dates);

graphset;
  window(1,2,0);
  _pdate = 0; _pframe = 0; _pnum = 2;
  _plwidth = 6; _pltype = 6;
  _ptitlht = 0.35; _pnumht = 0.25;
  xtics(1,nDates,12*10,1);

  let xlab = "50" "60" "70" "80" "90" "2000" "10";
  asclabel(xlab,0);
 
  setwind(1);
    _pcolor = 1;
    title("\216r]t[");
    xy(0,100*Rdt);

  nextwind;
    _pcolor = 4;
    title("\216r]t[[2]");
    xy(0,100*Rdt^2);

    graphprt("-c=1 -cf=ts30.eps");

  endwind;
