new;
library qam,pgraph,tsm,optmum;

M = 4;
Nobs = 2^M;

call varput(0,"Base0");                /* Time domain */
call varput(M*ones(Nobs,1),"Base1");   /* Frequency domain */

M = 5;
Nobs = 2^M;

call varput(M|seqa(M,-1,M),"Base2");   /* Wavelet transform 
                                          (better frequency localization at 
                                           lower frequencies)
                                       */

let M = 4 4 5;

graphset;
  window3d;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _ptitlht = 0.275; _paxht = 0.225; _pnumht = 0.225;

  _pmsgstr = "-\000-";
  pmsgctl = 0.19~2.97~0.07~-45~2~0~6 ; 

  i = 0;
  do until i > 2;

    setwind(1 + i);

      if i == 0;
        title("\216Analyse en temps");
        _pmsgctl = pmsgctl;
      elseif i == 1;
        title("\216Analyse en frequences");
        _pmsgctl = pmsgctl | 
                   5.45~6.41~0.07~45~2~0~6 ; 
      elseif i == 2;
        title("\216Analyse en temps-frequences");
        _pmsgctl = pmsgctl | 
                   6.24~6.41~0.07~45~2~0~6 ; 
      endif;

      str = "Base" $+ ftos(i,"%lf",1,0);
      B = varget(str);
      call BasisPlot(B,M[i+1]);
      _pline[.,2] = _pline[.,2]*0 + 6;
      xlabel("\216Temps");
      ylabel("\216Frequence");  
      xtics(0,1,0.2,2);
      ytics(0,1,0.2,2);
      draw;

    i = i + 1;
  endo;

  graphprt("-c=1 -cf=wavelet1.eps");

  endwind;







