/*
**  Wornell and Oppenheim [1992], Estimation of fractal signals
**  from noisy measurements using wavelets,
**  IEEE transactions on Signals Processing, 40, 611-623
*/

new;
library tsm,optmum,pgraph;
TSMset;

{H,G,Htilde,Gtilde} = Daubechies(4);

M = 12;
Nobs = 2^M;
x = rndn(Nobs,1)*4;
w = wt(x,H,G,0);
_wcoeff = w;

declare matrix _wcoeff, _scale;

proc ml(theta);
  local sigma,d,w,j,logl,i,u,v;
  sigma = theta[1];
  d = theta[2];
  w = _wcoeff;
  logl = {};
  j = 1;
  do until j > rows(_scale);
    i = _scale[j];
    u = select(w,i);
    v = (sigma^2)*2^(2*d*i);
    logl = logl | (-0.5*ln(2*pi)-0.5*ln(v)-0.5*u^2/v);
    j = j + 1;
  endo;

  retp(logl);
endp;

_print = 1;
__output = 0;
_tsm_optmum = 1;
__title = "Fractional process estimation via vavelets";
_tsm_parnm = "sigmaX"|"d";
sv = 4|0;

output file = wavelet11.out reset;

s = 2;
do until s > M;
  print;
  print ftos(s,"dilation indice: %lf",1,0);
  print "---------------------------------------";
  print;
  _scale = seqa(1,1,s);
  {theta,stderr,Mcov,Logl} = TD_ml(&ml,sv);
  s = s + 1;
endo;

output off;