new;
library pgraph,tsm,optmum;

rndseed 1234;

Nobs = 2^10;

s = seqa(1,1,Nobs);
sigma = 1;
x0 = miss(0,0);
x = RND_arma(0.62|0.35,2,0,sigma,x0,Nobs);

{H,G,Htilde,Gtilde} = Daubechies(6);

_wcenter = 0;
w = wt(x,H,G,0);

p = 0|0.50|0.95;

graphset;
  begwind;
  window(3,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pnumht = 0.20; _ptitlht = 0.25; _paxht = 0.20;

  i = 1;
  do until i > rows(p);

    w_ = Thresholding(w,p[i]);
    y = iwt(w_,Htilde,Gtilde,0);

    setwind(2*(i-1)+1);
      _wcolor = seqa(1,1,9); 
      _wline = 6;
      call wplot(w,0,w_);
      ylabel("");
      xtics(0,Nobs/2,64,0);
      str = "\216Coefficients d'ondelettes\L\216" $+ ftos(100*p[i],"\216p = %lf",4,1) $+ "%";
      title(str);
      draw;

      _pline = 0;

    setwind(2*i);
      _pcolor = i; _plwidth = 10;
      ytics(-10,10,5,2);
      xtics(0,1024,128,2);
      str = "\216Signal reconstruit";
      title(str);
      xy(s,y);

    i = i + 1;
  endo;

  graphprt("-c=1 -cf=wavelet8.eps");

  endwind;




