new;
library tsm,optmum,pgraph;

rndseed 123;

Nobs = 2^10;

t = seqa(0,2*pi/Nobs,Nobs);
x_ = sin(t) + sin(2*t);
x = x_ + rndn(Nobs,1)*0.4;

{H,G,Htilde,Gtilde} = Daubechies(4);

_wcenter = 0;

w_ = wt(x_,H,G,0);
w = wt(x,H,G,0);

lambda = 2.0;
w1 = WaveShrink(w,lambda,"Hard");
w2 = Waveshrink(w,lambda,"Soft");

y1 = iwt(w1,Htilde,Gtilde,0);
y2 = iwt(w2,Htilde,Gtilde,0);

y = y1~y2;

pqgwin many;

graphset;
  _pdate = ""; _pnum = 2; _pnumht = 0.20; _ptitlht = 0.30;
  _wcolor = seqa(1,1,10); _wline = 8; _paxht = 0.225;
  begwind;
  window(2,2,0);
  setwind(1);
    title("\216x]t[");
    call wplot(w_,0,1);
    xtics(0,Nobs/2,64,0);
    ylabel("\216Niveau de resolution");
    _pmsgstr = "-";
    _pmsgctl = 0.20~3.45~0.07~-45~2~0~6 ; 
    draw;
  setwind(2);
    title("\216y]t[");
    call wplot(w,0,1);
    xtics(0,Nobs/2,64,0);
    ylabel("\216Niveau de resolution");
    _pmsgstr = "-";
    _pmsgctl = 0.20~3.45~0.07~-45~2~0~6 ; 
    draw;
  setwind(3);
    title("\216Hard Shrinkage");
    call wplot(w,0,w1);
    xtics(0,Nobs/2,64,0);
    ylabel("\216Niveau de resolution");
    _pmsgstr = "-";
    _pmsgctl = 0.20~3.45~0.07~-45~2~0~6 ; 
    draw;
  setwind(4);
    title("\216Soft Shrinkage");
    call wplot(w,0,w2);
    xtics(0,Nobs/2,64,0);
    ylabel("\216Niveau de resolution");
    _pmsgstr = "-";
    _pmsgctl = 0.20~3.45~0.07~-45~2~0~6 ; 
    draw;
    graphprt("-c=1 -cf=wavelet9-a.eps");
endwind;

graphset;
  begwind;
  window(1,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  ytics(-3,3,1,0);
  _pnumht = 0.20; _paxht = 0.25; _ptitlht = 0.25;
  _pltype = 6|1|3;

  setwind(1);
    _pcolor = 1;
    title("\216y]t[");
    xlabel("\216t");
    xy(t,x);

  setwind(2);
    _pcolor = 2|3|4;
    _plwidth = 10;
    _plegstr = "Hard Shrinkage - w[+] = 2.5"\
               "\000Soft Shrinkage - w[+] = 2.0"\
               "\000x(t)";
    _plegctl = {2 6 1.5 0.8};
    title("\216Debruitage");
    _pmsgstr = "-";
    _pmsgctl = 4.06~6.65~0.07~45~2~0~6 ; 
    xy(t,y~x_);

    graphprt("-c=1 -cf=wavelet9-b.eps");
  endwind;



